-- ==================================================
-- cockpits V3D 
-- Author - Joёl a.k.a Jogad 
-- Integration by Lygin Gennady a.k.a Croc 21.12.2013,  01.09.2016 и 18.03.2017
-- ==================================================

if not pcall( function() require ("cockpits_config") end ) then
	celestia:log("--cockpits_config error -- cockpits not loaded")
	exiting=zhorutbvigl[0] -- no need to load the textures
end

if  lua_universal_tools and lang ~= "en"
	then require "locale" 
	else require "cockpits_locale"
end
if pcall( function() require ("locale_cockpits_"..lang) end ) then
	for engl, transl in pairs(cockpits_loc_str) do
		loc_str[engl]=transl
	end
end
require "lua-applications/cockpits/utils/pCXBox"
require "lua-applications/cockpits/utils/_textlayout"
------------------------------------------------------
-- constants 
------------------------------------------------------
local degree = 180/math.pi
local km  = 9460730.4725808 -- mly
local uly_to_km = 9460730.4725808                       
local m = km*1000
local km_c = 299792.458; -- km / s
local km_au = 149597870.7
local c_au = km_au/km_c --
local au_ly = 10^6*km /km_c / c_au

local cbutextoff =    {0.8, 0.9, 0.9, 0.8}    -- unactivated button text color
local ctext =     {1, 1, 1, 0.9}    -- main text color
local csetbofill =    {0.05, 0.1 , 0.1, 0.9}    -- setting box filling color
local celestiacolortext = {0.7, 0.7, 1, 1} -- same color than celestia display
local speedontext = {0.4, 1, 0, 1} -- 
--local speedofftext = {1,0.15,0,1}
local speedofftext = {1,0,0,1}
local speedbackground = {0,0,0,0.4}

local cockpitdir = "../panels/" -- relative to the directory of cockpitsBox.lua
local width, height = celestia:getscreendimension()
local newwidth, newheight;
local oldwidth, oldheight = 0,0

local btnrotTexture = {}
local btnmanTexture = {}
for i=0,14 do 
	if i<5 then btnrotTexture[i]=celestia:loadtexture("btnrot"..i..".png") end
	btnmanTexture[i]=celestia:loadtexture("btndir"..i..".png") 
end

local bug = celestia:loadtexture("BUG.png")

--local btnsize = btnsize or 20
local btnsize = 16
--local Vmg = Vmg or 10
local Vmg = Vmg or 5

--local becart = btnsize / 5                                   
local becart = 3

------------------------------------------------------
-- cp = control panel for rotations 
------------------------------------------------------
local cpsize = btnsize*3+2*becart
local cpX, cpY = (width - cpsize)/2+100, Vmg
------------------------------------------------------
-- extra picture 
------------------------------------------------------
local pictTex = nil
------------------------------------------------------
-- choice menu 
------------------------------------------------------
local cockpits = {}
for i=1, # known_cockpits_files do
	local fic = io.open("lua-applications/cockpits/panels/"..known_cockpits_files[i]..".png","r")
	if not fic then
		fic = io.open("lua-applications/cockpits/panels/"..known_cockpits_files[i].."/"..known_cockpits_files[i]..".lua","r")
	end
	if not fic then          -- new jogad
		fic = io.open("lua-applications/cockpits/panels/"..known_cockpits_files[i].."/"..known_cockpits_files[i].."-1.png","r")
	end
	if fic then
		table.insert(cockpits, known_cockpits_files[i])
		fic:close()
	end
end
local ckchoiceWidth = 180
local ckchoiceHeight = #cockpits * 20 + 60
local menuRightpos = 180
if lua_universal_tools_v5 then menuRightpos = boxWidth +10 end
local ckchoiceMg = 10

local cockpitsdata ={}
local ck = 0
local panel = 0
local newpanel = false
local multipanel = false
local nbpanel = 0
local loading = false

local obs=celestia:getobserver()
local frame = obs:getframe()
local refobj = frame:getrefobject()
local celestiaspeed = obs:getspeed()
local savecelspeed = celestiaspeed
local fov=obs:getfov()

------------------------------------------------------
-- direction and speed management 
------------------------------------------------------
local UP = celestia:newvector(0,1,0)
local DN = UP*-1
local AV = celestia:newvector(0,0,-1) -- forward
local AR = AV*-1
local GA = celestia:newvector(1,0,0)  -- left
local DR = GA*-1
local direction={DR,GA,UP,DN,AV,AR,nil,DN,UP,DR,GA,AV,AR}
local direct, inverse = 1, -1
local vv, oldvv, savevv = nil, AV, nil  -- speed vector
local celvv = nil -- celestia speed vector
local impulse = 10 ^ (1/5) -- multiply or divide the speed by 10 in 5 key strokes
local power = 1
local react = 0.5 -- nb of seconds to reach powercmd
local powercmd = 1 -- engine speed
local deltapower = 0 -- acceleration / tic
local acceltime = 0
local scripttime = celestia:getscripttime()
local perf = 1/30
local ckspeed = 0 -- speed to display if controlled by the cockpit
local inputdistcolor = {0.1,0.4,0,0.4}
local distance = math.huge
local remainingdistance = distance
local tabunitdist = { {_"m",  1/m}, {_"km", 1/km}, {_"au", km_au / km} , {_"ly", 10^6 } }
local unitidx = 2 -- km by default

------------------------------------------------------
-- rotation management 
------------------------------------------------------
--local defaultrot = default_rotation or 90
local defaultrot = 90
local inputrotcolor = {0,0.4,0.4,0.4}
local rotspeedcoloroff ={0.4,0,0.7,0.4}
local rotspeedcoloron = {0,0.4,0.7,0.4}
--local rotationspeed = rotation_speed or 60 -- degree/s
local rotationspeed = 1
local rotimpulse = 1.4
local deltarot = 0
local oldrotangle 
local oldangleText
local nbrot = 0
local axerot = UP

------------------------------------------------------
-- multi panel management
------------------------------------------------------
local panelratio, cockpitfov = 0,0
local rearpanel = 0
local frontpanel = 1
local backview = false
local zoomcoef = nil -- zoomcoef =  tan(horizontal_fov /2);   nil=>no zoom management
local azim, elev = 0, 0
local deplX, deplY, deplZ = 0,0,0

------------------------------------------------------
-- additionnal visor
------------------------------------------------------
local visorsize=visorsize or 100
local visor_active = false
local displayspeed = true

------------------------------------------------------
-- extra info 
------------------------------------------------------

local lspace = normalfont:getheight()+1
local dx, dy, dz, drotX, drotY, drotZ = 0,0,0,0,0,0

------------------------------------------------------
-- navaid -- new jogad 
------------------------------------------------------
local tracked=nil -- no track object selected
local aheadposition = nil
local fracrot=1

------------------------------------------------------
--3D cockptis -- new jogad 
------------------------------------------------------
local cockpit3D = false
local controled3Dcolor = {0.2, 1, 0.2, 0.3}
local free3Dcolor = {0.5, 0.2, 0, 0.8}
local model, model3D, SolarSystem -- model3D=name, model=object
local engine, steering
local cockpitorientation = obs:getorientation()
local oldcockpit3Dselection = celestia:getselection()
local cockpitvector, cockpitspeed

----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------
cockpitsBox = CXBox:new()
	:init(0, 0, 0, 0)
	:movable(false)
	:attach(screenBox, width, height, 0, 0);

-- ========================
--  Кнопка Выбор кабины звездолёта
-- ========================

--[[
if lua_universal_tools_v5 then

    cockpitsCheck = CXBox:new()
        :init(0, 0, 0, 0)   
        :bordercolor({0.2,0.8,1,.6})
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,1,1,0.8})
        :textpos("center")
        :movetext(0, 10)                    
        :text(_("Cockpit"))         
        :movable(false)
        :active(true) 
        :attach(menuLine4Box, -46, 0, 0, 0)
    
---------------------------------------------------------------------------------------------------------------------------------
 -- rewrite withe lua_universal_tools_v5's method without togglecockpit function that are not accessible here
    cockpitsCheck.Action = function()
            cockpitsmenuFrame.Visible = not cockpitsmenuFrame.Visible
            if cockpitsmenuFrame.Visible then 
		        cockpitsmenuFrame:orderfront()
		        cockpitsCheck.Bordercolor={1,0,0,.5}
		    else
		        cockpitsCheck.Bordercolor={0.2,0.8,1,.6}  
		    end
    end
end
]]

----- frame -------------------------

cockpitsSurvey = pCXBox:new()
:init(0, 0, 0, 0)
:movable(false)
:attach(screenBox, width, height-4, 0, 0);

cockpitsFrame = pCXBox:new()
:init(0, 0, 0, 0)
:movable(false)
:active(false)
:clickable(true)
:visible(false)
:attach(screenBox,0,0,0,0)

ckpictureFrame = pCXBox:new()
:init(0, 0, 0, 0)
:movable(false)
:active(false)
:clickable(true)
:visible(false)
:attach(cockpitsFrame,0,0,0,0)

-------------------------------------------
-- cockpit rotation panel
-------------------------------------------
rotationpanelFrame = pCXBox:new()
:init(0, 0, 0, 0)
:bordercolor({0.8, 0.8, 0.8, 0.8})
:fillcolor({0,0,0,0.6})
:movable(true)
:active(false)
:clickable(false)
:visible(false)
:attach(screenBox, cpX,cpY,width -cpX - cpsize, height - cpY - cpsize)

btncockpitrotFrame ={}
local btnrotposition = function(x)
	local mg,mb,md,mh
	mg=btnsize + becart; mb = mg -- (x==0)
	if x==1 then mg = mg - btnsize - becart
		elseif x==2 then mg = mg + btnsize + becart
		elseif x==3 then mb = mb + btnsize + becart
		elseif x==4 then mb = 0
	end
	md = cpsize - mg - btnsize
	mh = cpsize - mb - btnsize
	return mg, mb, md, mh
end

local createbtnrot = function (x)
	return pCXBox:new()
		:init(0, 0, 0, 0)
		:fillimage(btnrotTexture[x])
		:movable(false)
		:active(true)
		:clickable(false)
		:visible(false)
		:attach(rotationpanelFrame, btnrotposition(x))
end
for i=0,4 do
	btncockpitrotFrame[i]=createbtnrot(i)
	btncockpitrotFrame[i].panel = 0
end

-- ================================
-- mp = manoeuvre panel-- Панель маневрирования  
-- ================================
local htexte = 20 -- text height at the top of the box                     
local mpsize = 186  -- ширина панели 186 точек                
local mpheight = 173-20 -- высота панели                        
local mpX, mpY = cpX+cpsize+becart, cpY


-- the command's button is in panelAll2Box

-- frame ----------------------------------------------------------------------------
manoeuvrepanelFrame = pCXBox:new()
      :init(0, 0, 0, 0)
      :bordercolor({0,0.5,0.5,.8})
      :fillcolor({0,0,0,0.8})
      :movable(true)
      :active(false)
      :clickable(false)
      :visible(false) 
      if width < 900  then
         manoeuvrepanelFrame:attach(screenBox, (width-mpsize)-6, 3, 6, height-mpheight-20-3) 
      else  
         manoeuvrepanelFrame:attach(screenBox, (width-mpsize)-195, 3, 195, height-mpheight-20-3) 
      end

closemanoeuvrepanelButton = CXBox:new()
        :init(0, 0, 0, 0) 
       -- :bordercolor(cbubordoff)      
        :textfont(smallfont)
        :textcolor({1,0,0,0.5})
        :textpos("left")
        :movetext(1, 12)
        :text("x")
        :movable(false)
        :active(true)
        :attach(manoeuvrepanelFrame, 172, 160, 2, 2);

closemanoeuvrepanelButton.Action = (function()
        return
            function()   
             display_manoeuvrepanel = not display_manoeuvrepanel;
                if manoeuvrepanelFrame.Visible then                   
                   manoeuvrepanelFrame.Visible = false;   
                   panelAll26Check.Text = "";           
              end             
        end
end) ();
    
        local md,mh
        local mg,mg1,mg2,mg3,mg4,mg5,mg6,mg7,mg8
        local mb,mb0,mb1,mb2,mb3,mb4

        mb0=0*btnsize + 1*becart - 1
        mb1=1*btnsize + 2*becart - 3
        mb2=2*btnsize + 3*becart - 5
        mb3=3*btnsize + 4*becart - 7
        mb4=4*btnsize + 5*becart - 9 

        mg1=0*btnsize + 1*becart - 0
        mg2=1*btnsize + 2*becart - 1
        mg3=2*btnsize + 3*becart - 2
        mg4=3*btnsize + 4*becart
        mg5=4*btnsize + 5*becart
        mg6=7*btnsize + 7*becart - 1
        mg7=8*btnsize + 8*becart - 2 
        mg8=9*btnsize + 9*becart - 3 


btncockpitmanFrame ={}
local btnmanposition = function(x)

                                 mg = mg7; mb = mb3      -- (x==0)
	      if x==1  then mg = mg6; mb = mb3 
	elseif x==2  then mg = mg8; mb = mb3 
        elseif x==3  then mg = mg7; mb =  mb4                  
	elseif x==4  then mg = mg7;  mb = mb2  
        elseif x==5  then mg = mg8; mb =  mb4  
        elseif x==6  then mg = mg6; mb =  mb4 
     -- elseif x==7  then mg = mg7; mb = mb3         
    	elseif x==8  then mg = mg1; mb = mb3     -- L4           
        elseif x==9  then mg = mg3; mb = mb3     -- L6           
        elseif x==10 then mg = mg2; mb = mb4     -- L2           
        elseif x==11 then mg = mg2; mb = mb2     -- L7	      
        elseif x==12 then mg = mg1; mb = mb4     -- L1            
        elseif x==13 then mg = mg3; mb = mb4     -- L3
        elseif x==14 then mg = mg2; mb = mb3     -- L5   
	end

	md = mpsize - mg - btnsize
	mh = mpheight - mb - btnsize + htexte
	return mg, mb, md, mh
end

-------------------------------------------------------
local createbtnman = function (x)
	return pCXBox:new()
		:init(0, 0, 0, 0)
		:fillimage(btnmanTexture[x])
		:movable(false)
		:active(true)
		:clickable(false)
		:visible(true)
		:attach(manoeuvrepanelFrame, btnmanposition(x))
end
for i=0,14 do
	btncockpitmanFrame[i]=createbtnman(i)
	local j=i; -- if i==7 then j=0 end -- same function for 0 and 7
	btncockpitmanFrame[i].btn = j
end

--=============================
-- 4-й этаж manoeuvrepanel
--=============================
fenangle = pCXBox:new()  -- угол поворота задаваемый
	:init(0, 0, 0, 0)	
        :bordercolor( {0.2, 0.4 , 0.4, 0.6})    -- edit
	:fillcolor(inputrotcolor)
	:textfont(normalfont)
	:textcolor(ctext)
	:textpos("center")
	:movetext(0, 7)
	:text(tostring(defaultrot))
	:movable(false)
	:active(true)
	:editable(true)
	:clickable(false)
	:visible(true) 
        :attach(manoeuvrepanelFrame, mg4-3, mb3, mg4-3, 154-mb3+4)

--============================
-- 3-й этаж manoeuvrepanel
--============================
speeddisplaybutton = pCXBox:new()  -- Кнопка "v" -- hide/show speed display
	:init(0, 0, 0, 0)	
        :bordercolor( {0.2, 0.4 , 0.4, 0.6}) 
        :fillcolor(cFrameFill) 
	:textfont(normalfont)
        :textcolor({1,0,0,1})
	:textpos("center")
	:text("v")      
	:movetext(0, 8)
	:movable(false)
	:active(true)
	:editable(true)
	:clickable(false)
	:visible(true)       
        :attach(manoeuvrepanelFrame, mg1, mb2, mg8, 154-mb2+4)

speeddisplaybutton.Action = function() 
	displayspeed = not displayspeed 
end
------------------------------------------
extracontrolbutton = pCXBox:new()  -- Кнопка "#" 
	:init(0, 0, 0, 0)
        :bordercolor( {0.2, 0.4 , 0.4, 0.6}) 
        :fillcolor(cFrameFill) 	
        --:bordercolor( {0.2, 0.4 , 0.4, 0.6})    -- edit
	--:fillcolor(inputrotcolor) 
	:textfont(smallfont)
        :textcolor({1,0,0,0.6})
	:textpos("left")
	:text("#")      
	:movetext(0, 8)
	:movable(false)
	:active(true)
	:clickable(false)
	:visible(true)      
        :attach(manoeuvrepanelFrame, mg8, mb2, mg1, 154-mb2+4)

 extracontrolbutton.Action = function() 
	showextra = not showextra
end
----------------------------------
BlockL = pCXBox:new() 
	:init(0, 0, 0, 0)
	:bordercolor({0.5, 0.5, 0.5, 0.5})
	:fillcolor({0,1,1,0.3})
        :textfont(normalfont)
        :textcolor({1, 0, 0, 1})
        :textpos("left")
        :movetext(-4, 7)
        :text(" =")
        :movable(false)        
	:active(true)
	:clickable(false)
	:visible(true)	
        :attach(manoeuvrepanelFrame, mg3, mb2, mg6, 154-mb2+4)

control3Drotation = pCXBox:new() 
	:init(0, 0, 0, 0)
	:bordercolor({0.5, 0.5, 0.5, 0.5})
	:fillcolor(controled3Dcolor)
        :textfont(normalfont)
        :textcolor({1, 1, 1, 1})
	:textpos("left")
        :movetext(-2, 8)
	:text("|||")
	:movable(false)        
	:active(true)
	:clickable(false)
	:visible(true)	
        :attach(manoeuvrepanelFrame, mg3, mb2, mg6, 154-mb2+4)

control3Drotation.Customdraw = function(this)
	if steering then 
		if steering:visible() then
			this:fillcolor(controled3Dcolor)
		else
			-- this:fillcolor(free3Dcolor)
                        this:fillcolor({1,0,0,0.8} )
		end
	end
end     
-----------------------------
BlockR = pCXBox:new() 
	:init(0, 0, 0, 0)
	:bordercolor({0.5, 0.5, 0.5, 0.5})
	:fillcolor({0,1,1,0.3})
        :textfont(normalfont)
        :textcolor({1, 0, 0, 1})
        :textpos("left")
        :movetext(-4, 7)
        :text(" =")
        :movable(false)        
	:active(true)
	:clickable(false)
	:visible(true)	
        :attach(manoeuvrepanelFrame, mg6, mb2, mg3, 154-mb2+4)

control3Dtranslation = pCXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0.5, 0.5, 0.5, 0.5})
	:fillcolor(controled3Dcolor)
        :textfont(normalfont)
        :textcolor({1, 1, 1, 1})
	:textpos("left")
        :movetext(-1, 8)
	:text("|||")
	:movable(false)
	:active(true)
	:clickable(false)
	:visible(true)	
        :attach(manoeuvrepanelFrame, mg6, mb2, mg3, 154-mb2+4)

control3Dtranslation.Customdraw = function(this)
	if engine then 
		if engine:visible() then
			this:fillcolor(controled3Dcolor)
		else
			this:fillcolor(free3Dcolor)
		end
	end
end
---------------------------------------------------------
local fenwidth = (btnsize*3+becart*8)/2

fenspeedrot = pCXBox:new()   -- угол поворота по умолчанию 
	:init(0, 0, 0, 0)	
        :bordercolor( {0.2, 0.4 , 0.4, 0.6}) 
	:fillcolor(rotspeedcoloroff)
	:textfont(normalfont)
	:textcolor(ctext)
	:textpos("center")
	:movetext(0, 7)
	:text(tostring(rotationspeed)) 
	:movable(false)
	:clickable(false)
	:visible(true)     
        :attach(manoeuvrepanelFrame, mg4-3, mb2, mg4-3, 154-mb2+4)

fenwidth = fenwidth / 2  -- левая (невидимая) кнопка коррекции угола поворота по умолчанию 

decspeedrot = pCXBox:new()
	:init(0, 0, 0, 0)
	:textfont(normalfont) 
        :textcolor({1,0,0,1}) 
	:textpos("left")
	:text("<")    
	:movetext(0, 7)     
	:movable(false)
	:active(true)
	:clickable(false)
	:visible(true)	
	:attach(fenspeedrot, 0, 0, fenwidth,0)

incspeedrot = pCXBox:new() -- правая (невидимая) кнопка коррекции угла поворота по умолчанию 
	:init(0, 0, 0, 0)
	:textfont(normalfont) 
        :textcolor({1,0,0,1}) 
	:textpos("left") 
	:text(">")     
	:movetext(37, 7)    
	:movable(false)
	:active(true)
	:clickable(false)
	:visible(true)	
        :attach(fenspeedrot, fenwidth, 0, 0, 0)

--=============================	
-- 1-ый этаж manoeuvrepanel
--=============================
fenwidth = (btnsize*3+becart*8)/2

power1xbutton = pCXBox:new() -- кратность
	:init(0, 0, 0, 0)	
        :bordercolor( {0.2, 0.4 , 0.4, 0.6}) 
        :fillcolor(cFrameFill)    
	:textfont(normalfont)
	:textcolor(ctext)
	:textpos("center")
	:movetext(0, 7)
	:text("1x")
	:movable(false)
	:active(true)
	:clickable(false)
	:visible(true)	
        :attach(manoeuvrepanelFrame, mg1, mb0, mg8, 154-mb0+4)

power1xbutton.Action = function() 
	if refobj then
		powercmd = powercmd / math.abs(powercmd)
		requirepower()
	end
end 
----------------------------
 nominalpowerbutton = pCXBox:new()
	:init(0, 0, 0, 0)	
        :bordercolor( {0.2, 0.4 , 0.4, 0.6})
	:fillcolor({1,0,0,0.25})
        :textfont(normalfont)
	:textcolor(ctext)     
	:textpos("center")
	--:movetext(0, 9) 
	:movable(false)
	:active(true)
	:clickable(false)
	:visible(true)
        :attach(manoeuvrepanelFrame, mg1+btnsize+2, mb0, mg5+btnsize, 154-mb0+4)
----------------------------
fenwidth = fenwidth / 2

slowbutton = pCXBox:new()
	:init(0, 0, 0, 0)
	:textfont(normalfont) 
        :textcolor({1,0,0,1}) 
	:textpos("left") 
	:movetext(0, 7) 
	:text("<")    
	:movable(false)
	:active(true)
	:clickable(false)
	:visible(true)
	:attach(nominalpowerbutton, 0, 0, fenwidth,0)
	
accelbutton = pCXBox:new()
	:init(0, 0, 0, 0)
	:textfont(normalfont) 
        :textcolor({1,0,0,1}) 
	:textpos("left") 
	:text(">")     
	:movetext(32, 7)  
	:movable(false)
	:active(true)
	:clickable(false)
	:visible(true)
	:attach(nominalpowerbutton, fenwidth, 0, 0, 0)
----------------------------------
distancebox = pCXBox:new()
	:init(0, 0, 0, 0)
        :bordercolor( {0.2, 0.4 , 0.4, 0.6})
	:fillcolor(inputdistcolor)
	:textfont(normalfont)
	:textcolor(ctext)
	:textpos("center")
	:text(">>>")
	:movetext(0, 7)
	:movable(false)
	:active(true)
	:editable(true)
	:clickable(false)
	:visible(true)        
        :attach(manoeuvrepanelFrame, mg5+btnsize, mb0, mg1+btnsize+2, 154-mb0+4) 

distancebox.Customdraw = function(this)
	local dist= math.abs(tonumber(this.Text) or math.huge)
	distance = dist * tabunitdist[unitidx][2]
	if not this.Highlight then
		if distance == math.huge then
			this.Text = ">>>"
		else
			this.Text = tostring(dist)
		end
	else
		vv = savevv
		obs:setspeed(savecelspeed)
	end
end

distancebox.Action = function(this)
	remainingdistance = 0
	this.Text = ""
	savevv = vv
	savecelspeed = celestiaspeed
end
------------------------------------------
distanceunitbutton = pCXBox:new() -- ед. измерения расстояний
	:init(0, 0, 0, 0)	
        :bordercolor( {0.2, 0.4 , 0.4, 0.6})
        :fillcolor(cFrameFill)
	--:textfont(normalfont)
        :textfont(smallfont)
	:textcolor(ctext)
	:textpos("left")
	:movetext(-3, 7)
	:text(tabunitdist[unitidx][1])
	:movable(false)
	:active(true)
	:clickable(false)
	:visible(true)      
        :attach(manoeuvrepanelFrame, mg8, mb0, mg1, 154-mb0+4) 

distanceunitbutton.Customdraw = function(this)
	this.Text = tabunitdist[unitidx][1]
end
-- =========================
-- speed display -- новая редакция jogad
-- =========================
speedboxheight = 16
trackSpeedDisplay = pCXBox:new()
	:init(0, 0, 0, 0)
	:fillcolor(speedbackground)
	:textfont(normalfont)
	:textcolor(speedontext)
	:movetext(-4, 5)
	:movable(false)
	:active(false)
	:clickable(true)
	:visible(true)
	:attach(screenBox,0,0,width-130,height-speedboxheight)

-- ============================
-- exp = extracontrol panel 
-- ============================
local expsize = 186
local expheight = 173                                      
local expX = mpX + mpsize + becart
local expY = Vmg
--local showextra = false
local showextra = true

local gn=10
local gg=gn-1

extracontrolpanel =  pCXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0, 0.5, 0.5, 0.8})
        :fillcolor(csetbofill)
	:movable(true)
	:active(false)
	:clickable(false)
	:visible(false)

        if width < 900  then
           extracontrolpanel:attach(screenBox, (width-expsize)-6, 180, 6, height-expheight-180) 
        else  
           extracontrolpanel:attach(screenBox, (width-expsize)-5, 3, 5, height-expheight-3) 
        end

ecBox1 = pCXBox:new()
       :init(0, 0, 0, 0)
       :bordercolor({0, 0.5, 0.5, 0.5})
       :fillcolor(cFrameFill)
       :textpos("left")
       :movetext(3, 10)
       :movable(false)    
       :attach(extracontrolpanel, 3, 2+17*0, 60+3, 3+17*7) 

ecBox2 = pCXBox:new()
       :init(0, 0, 0, 0)
       :bordercolor({0, 0.5, 0.5, 0.5})
       :fillcolor(cFrameFill)
       :textpos("left")
       :movetext(3, 10)
       :movable(false)    
       :attach(extracontrolpanel, 3, 2+17*3, 60+3, 3+17*4)      

ecBox3 = pCXBox:new()
         :init(0, 0, 0, 0)
         :bordercolor({0, 0.5, 0.5, 0.5})
         :fillcolor(cFrameFill)
         :textpos("left")
         :movetext(3, 10)   
         :movable(false)    
         :attach(extracontrolpanel, 3, 2+17*6, 60+3, 3+17*1)

----------------------------------------------
-- Кнопки сброса показателей
----------------------------------------------
reset1Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({1,0,0,0.8})
    :textpos("left")
    :movetext(-5, 10)  
    :text(_("=0"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-16, 2+17*(gg-4)+3, 60+3, 3+17*4)  

reset1Button.Action = function() 
    drotX = 0; drotY = 0; drotZ = 0;	
end 

reset2Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({1,0,0,0.8})
    :textpos("left")
    :movetext(-5, 10)  
    :text(_("=0"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-16, 2+17*(gg-7)+3, 60+3, 3+17*7) 

reset2Button.Action = function() 
     dx=0; dy=0; dz=0;
end 

---------------------------------------------- 
-- Схема управления
---------------------------------------------- 

--SchemeImage = celestia:loadtexture("../panels/Scheme.png");
--[[
if  lang ~= "en" then 
    if lang == "ru" then 
       SchemeImage = celestia:loadtexture("../locale/Scheme_ru.png");
    elseif lang == "fr" then 
       SchemeImage = celestia:loadtexture("../locale/Scheme_fr.png");
       end
else 
    SchemeImage = celestia:loadtexture("../locale/Scheme.png"); 
end
]]

--SchemeImage = celestia:loadtexture("../panels/Scheme.png");

if  lang ~= "en" then 
    if lang == "ru" then 
       SchemeImage = celestia:loadtexture("../locale/scheme_ru.png");
    elseif lang == "fr" then 
       SchemeImage = celestia:loadtexture("../locale/scheme_fr.png");
   elseif lang == "de" then 
     --  SchemeImage = celestia:loadtexture("../locale/scheme_de.png");
	     SchemeImage = celestia:loadtexture("../locale/scheme.png");  
   elseif lang == "it" then 
     --  SchemeImage = celestia:loadtexture("../locale/scheme_it.png");
	     SchemeImage = celestia:loadtexture("../locale/scheme.png"); 
   elseif lang == "es" then 
     --  SchemeImage = celestia:loadtexture("../locale/scheme_es.png");
	     SchemeImage = celestia:loadtexture("../locale/scheme.png"); 
   elseif lang == "ko" then   
     --  SchemeImage = celestia:loadtexture("../locale/scheme_ko.png");
	     SchemeImage = celestia:loadtexture("../locale/scheme.png"); 
   elseif lang == "nl" then 
     --  SchemeImage = celestia:loadtexture("../locale/scheme_nl.png");
	     SchemeImage = celestia:loadtexture("../locale/scheme.png"); 
   elseif lang == "pt" then 
     --  SchemeImage = celestia:loadtexture("../locale/scheme_pt.png");
	     SchemeImage = celestia:loadtexture("../locale/scheme.png");   
   elseif lang == "sv" then 
     --  SchemeImage = celestia:loadtexture("../locale/scheme_sv.png");
	     SchemeImage = celestia:loadtexture("../locale/scheme.png"); 
   elseif lang == "BR" then 
      -- SchemeImage = celestia:loadtexture("../locale/scheme_BR.png");
	     SchemeImage = celestia:loadtexture("../locale/scheme.png"); 
   elseif lang == "US" then 
     --  SchemeImage = celestia:loadtexture("../locale/scheme_US.png");
	     SchemeImage = celestia:loadtexture("../locale/scheme.png"); 
   end
else 
    SchemeImage = celestia:loadtexture("../locale/scheme.png"); 
end

SchemeButton = pCXBox:new()
    :init(0, 0, 0, 0)
    :fillcolor(cFrameFill) 
    :textfont(normalfont)    

    :textcolor({1,0,0,1}) 
    :textpos("left")
    :movetext(0, 6+2)  
    :text(_(""))
    :movable(false)
    :active(true)  
    :attach(cockpitsBox, 185,0,1,0)  

SchemeButton.Action = (function()
    return
        function()
            SchemeFrame.Visible = not(SchemeFrame.Visible); 
             if not(SchemeFrame.Visible) then
                SchemeButton.Bordercolor = cbubordoff;
                SchemeButton.Fillcolor = nil;       

             else
                SchemeButton.Bordercolor = cbubordon;
                SchemeButton.Fillcolor = {cbubordon[1]*2/3, cbubordon[2]*2/3, cbubordon[3]*2/3, cbubordon[4]/2};
            end          
        end
end) ();

SchemeFrame = CXBox:new()
     :bordercolor(cbubordoff)  
     :fillimage(SchemeImage)   
    -- :active(true)
     :movable(false)
     :attach(screenBox,  196, 185, 5, 5)

-------------------------------------------------
ec0Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill)
    :textfont(normalfont)
    :textcolor({1,0,0,0.8})
    :textpos("left")
    :movetext(-1, 8)  
    :text(_("Scheme"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-1, 2+17*(gg-0), 3, 3+17*0) 

ec0Check = pCXBox:new()
        :init(0, 0, 0, 0)
        --:bordercolor(cbubordoff)
        --:fillcolor({1,1,0,.2})
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-3, 9)
        :text("")
        :movable(false)
        :active(true)  
        :attach(ec0Button, 0, 0, 50, 0) 

ec0Button.Action = (function()
        return
            function()
              display_ec0 = not display_ec0;
                if display_ec0 then                 
                     SchemeFrame.Visible = true; 
                     ec0Check.Text = "|";                  
                else 
                     SchemeFrame.Visible = false;
                     ec0Check.Text = "";
                end
            end
        end) ();
--=========================
-- наименование показателей
--=========================
ec1Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-1, 8)  
    :text(_("Change"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-1, 2+17*(gg-3), 3, 3+17*1)
-------------------------------------------------
ec2Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-1, 8)  
    :text(_("the object"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-1, 2+17*(gg-2), 3, 3+17*2)
-------------------------------------------------
ec3Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-1, 8)  
    :text(_("coordin.")) 
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-1, 2+17*(gg-3), 3, 3+17*3)
--===========================
ec4Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor(ctext)
    :textpos("left")
    :movetext(-1, 8)  
    :text(_("Roll"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-1, 2+17*(gg-6), 3, 3+17*4) 
-------------------------------------------------
ec5Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :textfont(smallfont)
    :textcolor(ctext)
    :textpos("left")
    :movetext(1, 8)  
    :text(_("Pitch"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-3, 2+17*(gg-5), 3, 3+17*5) 
-------------------------------------------------
ec6Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :textfont(smallfont)
    :textcolor(ctext)
    :textpos("left")
    :movetext(1, 8)  
    :text(_("Yaw"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-3, 2+17*(gg-6), 3, 3+17*6) 
--===========================
ec7Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-1, 8)  
    :text(_("Offset"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-1, 2+17*(gg-9), 3, 3+17*7) 
-------------------------------------------------
ec8Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(1, 8)  
    :text(_("starship"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-3, 2+17*(gg-8), 3, 3+17*8) 
---------------------------------------------------
ec9Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(1, 8)  
    :text(_("axes xyz"))
    :movable(false)
    :active(true)
    :attach(extracontrolpanel, 186-60-3, 2+17*(gg-9), 3, 3+17*9)

-- ==========================
-- cockpits menu - панель выбора кабин
-- ==========================
cockpitsmenuFrame = pCXBox:new()
      :init(0, 0, 0, 0)
      :bordercolor(cbubordoff)   -- edit
      :fillcolor(csetbofill)
      :textfont(normalfont)
      :textcolor(ctext)
      :textpos("center")
      :movetext(0, 0)
      :text(_("Set a cockpit"))
      :movable(true)
      :clickable(false)
      :visible(false)    
      :attach(screenBox,width-ckchoiceWidth-menuRightpos+20-3, height-ckchoiceHeight-113, menuRightpos+5, 113)

btncockpitchoice={}

local createChoiceButton = function(x)
	local separ = 55
	local cockchoice = "< No cockpit >";
	if x > 0 then cockchoice = cockpits[x] end
	return

pCXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)   -- edit
        :textfont(normalfont)
        :textcolor(cbutextoff)
        :movetext(0, 4)
        :text(_(cockchoice))
        :movable(false)
	:active(true)
	:clickable(false)
	:visible(true)
        :attach(cockpitsmenuFrame, ckchoiceMg-7, ckchoiceHeight-separ-(20*x), 2+1, separ+(20*x)-20)
end
for i=0, #cockpits do 
	btncockpitchoice[i] = createChoiceButton(i) 
	btncockpitchoice[i].ck = i
end

visorFrame = pCXBox:new()
    :init(0, 0, 0, 0)
    --:bordercolor(cbubordoff)   -- edit  
    :fillimage(celestia:loadtexture("viseur.png"))
    :movable(false)
    :active(false)
    :clickable(true)
    :visible(false)
    :attach(screenBox, (width-visorsize)/2, (height-visorsize)/2, (width-visorsize)/2, (height-visorsize)/2)

-- ======================= 
-- local functions
-- =======================
local function round(x,d)
	if x == 0 then return 0 end
	d = d or 0
	local abx = math.abs(x)
	local sign = abx/x
	local m = 10^d
	return math.floor(abx * m +0.5)/m*sign
end

local function sround(x,d)
	if x==0 then return 0 end
	if d then d=d-1 else d=2 end 
	local abx = math.abs(x)
	local sign = abx/x
	return round(abx, -math.floor(math.log10(abx))+d)*sign
end

local function inverserotation(rotation)
	local imag, real = rotation:imag(), rotation:real()
	return celestia:newrotation(-real, imag.x, imag.y, imag.z)
end


local function set3Dposition()
	return cockpit3D and engine and (not engine:visible())
end

local function requirepower()
	acceltime = math.floor(react / perf)
	deltapower = (powercmd-power)/acceltime
end

local initrotation = function(angle,axe)
	if angle == 0 then -- recalculate rotation speed
		if nbrot == math.huge then angle = math.huge end
	end
	if axe ~= axerot then nbrot = 0 end
	axerot = axe
	if angle == math.huge then
		deltarot = rotationspeed/degree * perf
		nbrot = math.huge
	else
		local newangle = angle + nbrot * deltarot
		nbrot = math.floor(newangle*degree / rotationspeed / perf)+1
		deltarot = newangle / nbrot
	end
end

local function initspeed()
	local v0 = ckspeed
	local sel = celestia:getselection()
	local reference = refobj or sel
	if set3Dposition() and ( sel:type() == "spacecraft" or sel:type() == "location") then
		reference = sel
	end
	if reference then
		if set3Dposition() and sel:name() == model3D then
			v0 = 0.0001/km -- 10 cm/s
		else
			local refpos = reference:getposition()
			local radius = reference:radius()
			local dist = obs:getposition():distanceto(refpos) - radius
			local veloc = dist
			if dist <= radius/10 then veloc = radius/10 end
			local N = 50 -- vitesse expo à partir de N*radius
			if dist > radius *N then 
				veloc = dist * (math.log((dist / radius)+1,2) - math.log(N+1,2) + 1)
			end
			v0 = math.max(veloc/km / 10, 0.00001/km) -- mini = 1cm/s
		end
	end
	return v0
end

local adaptzoom = function()
	if zoomcoef then
		fov=2*math.atan(zoomcoef*height/width)
		obs:setfov(fov) -- automatically limited to 120° by celestia
	end
end

local adjustimage = function()
	if cockpitsdata[ck] and cockpitsdata[ck]["image"]  then
		image = cockpitsdata[ck]["image"][panel]
		if image  then
			local X = (image[2] or 0);		if X<1 then X = X * width end
			local Y = (image[3] or 0);		if Y<1 then Y = Y * height end
			local W = (image[4] or 0.1);	if W<1 then W = W * width end
			local H = (image[5] or 0.1);	if H<1 then H = H * height end
			ckpictureFrame:attach(cockpitsFrame,X, Y,width-X-W,height-Y-H)
		end
	end
end

local verifcockpitsize = function()  -- check all windows' sizes = проверка размеров всех окон
	cpX = (width - cpsize)/2	-- recentre control panel

	mpX = cpX+cpsize+becart+33+186+4

	if mpX + mpsize + 6 > width then
		mpX = width - mpsize -3 
		cpX = math.max(mpX - becart - cpsize, 3)
	end

        if mpsize + 2 > width then 

                manoeuvrepanelFrame.Visible = false 
        end

	expX  = mpX + mpsize + becart

	if expX + expsize + 6 > width then 
                expX = width - expsize -3 
        end

	cpY, mpY, expY = Vmg, Vmg, Vmg

	rotationpanelFrame:attach(screenBox, cpX,cpY,width -cpX - cpsize, height - cpY - cpsize)

     if newwidth ~= width or newheight ~= height then
        newwidth, newheight = width, height;  
        if width >=1280 then
          -- manoeuvrepanelFrame:attach(screenBox, mpX-1-190,mpY-2,width -mpX - mpsize+1+190, height - mpY - mpheight-htexte+2)
          manoeuvrepanelFrame:attach(screenBox, mpX-1-190+6, mpY-2,width -mpX - mpsize+1+190-6, height - mpY - mpheight-htexte+2)
        else
           if width>=900  then
               manoeuvrepanelFrame:attach(screenBox, width-mpsize-5-190, 3, 5+190, height-mpheight-20-3) 
           else
               manoeuvrepanelFrame:attach(screenBox, width-mpsize-5, 3, 5, height-mpheight-20-3)
           end
        end

        if width >=1280 then
           extracontrolpanel:attach(screenBox, expX-190+6, expY-2,width -expX - expsize+190-6, height - expY - expheight+2)
        else
           if width>=900  then
              extracontrolpanel:attach(screenBox, width-expsize-5, 3, 5, height-expheight-3)
           else
              extracontrolpanel:attach(screenBox, width-expsize-5, 180, 5, height-expheight-180)             
           end
        end
     end

        cockpitsmenuFrame:attach(screenBox,width-ckchoiceWidth-menuRightpos+20-3,height-ckchoiceHeight-128,menuRightpos+5, 128)
	
	local mvh, mvv = math.max((width-visorsize)/2,2), math.max((height-visorsize)/2,2)
	visorFrame:attach(screenBox, mvh, mvv, mvh, mvv)
	
	adjustimage()
	adaptzoom()
end

function tourne(axe,angle)
	local rot = celestia:newrotation(axe,angle)
	obs:rotate(rot)
	if vv then
		rot = celestia:newrotation(axe,-angle)
		vv = rot:transform(vv):normalize()
	end
end

local changepanelview = function(way)
	if cockpit3D then return end
	local roth = celestia:newrotation(UP,azim*way)
	local invroth = celestia:newrotation(UP,-azim*way)
	local rotv = celestia:newrotation(DR,elev*way)
	local invrotv = celestia:newrotation(DR,-elev*way)
	
	local vdepl = celestia:newvector(deplX/m, deplY/m, -deplZ/m) * way
	
	local w = vv; if not w then w = oldvv end
	if celvv then w = celvv end
	
	if way == direct then
		local pos = obs:getposition()
		local orient = obs:getorientation()
		local vdir = orient:transform(vdepl)
		local pos2 = pos:addvector(vdir)
		obs:setposition(pos2)
		
		if w then
			obs:rotate(roth);
			w = invroth:transform(w):normalize()
			obs:rotate(rotv)
			w = invrotv:transform(w):normalize()
		end
	else
		if w then
			obs:rotate(rotv);
			w = invrotv:transform(w):normalize()
			obs:rotate(roth)
			w = invroth:transform(w):normalize()
		end
		local pos = obs:getposition()
		local orient = obs:getorientation()
		local vdir = orient:transform(vdepl)
		local pos2 = pos:addvector(vdir)
		obs:setposition(pos2)
	end

	if vv then vv = w elseif oldvv then oldvv = w end
	if celvv then celvv = w end
end

local toggleNavig = function ()
	if manoeuvrepanelFrame.Visible then
		if visorFrame.Visible then visorFrame.Visible = false
			else manoeuvrepanelFrame.Visible = false
		end
	else
		if visorFrame.Visible then 
			manoeuvrepanelFrame.Visible = true
			manoeuvrepanelFrame:orderfront()
		else 
			visorFrame.Visible = true
		end
	end
	verifcockpitsize()
end

local cockpitswitch = function()
	if ck ~= 0 then
		backview = false
		if cockpit3D then
			model:setvisible(not model:visible())
		else
			cockpitsFrame.Visible = not cockpitsFrame.Visible
		end
		if multipanel then 
			rotationpanelFrame.Visible = cockpitsFrame.Visible
		end
	end
end

local loadimage = function() -- try to load [ck,panel]
	if cockpitsdata[ck] and not loading then
		if panel == 0 then 
			panel = cockpitsdata[ck]["firstpanel"] or 1
		end
	else -- loading the entire cockpit
		local name = tostring(cockpits[ck])
		loading = true	
		if panel == 0 then
			panel = 1
			celestia:print(_("Loading cockpit ").._(name).." ...",10)
			return
		end
		if not cockpitsdata[ck] then cockpitsdata[ck] = {} end
		local tx = nil
		local viewname = cockpitdir..name..".png" -- try simple cockpit first
		if panel == 1 then
			tx = celestia:loadtexture(viewname)
			if tx then loading = false end
		end
		if not tx then -- multipanel or panel error
			viewname =  cockpitdir..name.."/"..name.."-"..panel..".png"
			tx = celestia:loadtexture(viewname)
		end
		if tx then -- the panel exists
			cockpitsdata[ck][panel] = {}
			cockpitsdata[ck][panel]["tx"] = tx

		else -- cockpit loading done
			loading = false
			if panel == 1 then 
				if not cockpitsdata[ck][panel] then cockpitsdata[ck][panel]={} end
				cockpitsdata[ck][panel]["tx"]=bug
			else
				panel = panel -1
			end
		end
		if loading then
			panel = panel + 1 -- try to load the next panel
		else  -- done build the panel description
			for p=1, panel do
				cockpitsdata[ck][p]["topanel"]={}
				for i=0, 4 do cockpitsdata[ck][p]["topanel"][i] = 0 end
			end
			-- reads the panel description if any
			local paneldata = _G[cockpits[ck]]
			if not paneldata then 
				if pcall( function() require (cockpits[ck]) end ) then
					paneldata = _G[cockpits[ck]]
				end
			end
			if paneldata then
				panelratio, cockpitfov = paneldata["panelratio"], paneldata["vfov"]
				rearpanel = paneldata["rearpanel"]
				frontpanel = paneldata["frontpanel"] or 1
				if frontpanel > panel then frontpanel = 1 end
				local firstpanel = tonumber(paneldata["firstpanel"]) or 1
				if firstpanel > panel then firstpanel = 1 end
				cockpitsdata[ck]["cockpit3D"] = paneldata["cockpit3D"]
				cockpitsdata[ck]["model3D"] = paneldata["model3D"]
				cockpitsdata[ck]["SolarSystem"] = paneldata["SolarSystem"]
				cockpitsdata[ck]["firstpanel"] = firstpanel
				cockpitsdata[ck]["rearpanel"] = tonumber(rearpanel) or 0
				cockpitsdata[ck]["frontpanel"] = frontpanel
				cockpitsdata[ck]["image"] = paneldata["image"]
				cockpitsdata[ck]["fov3D"] = paneldata["fov"]
				if panelratio and cockpitfov then 
					cockpitsdata[ck]["cfov"] = cockpitfov
				end
				if paneldata["orientation"] then -- special orientation
					for p=1, panel do
						cockpitsdata[ck][p]["azim"] =paneldata["orientation"][p][1]/degree
						cockpitsdata[ck][p]["elev"] =paneldata["orientation"][p][2]/degree
						cockpitsdata[ck][p]["vf"] =paneldata["orientation"][p][3]
					end
				end
				if paneldata["displacement"] then -- special displacement
					for p=1, panel do
						if paneldata["displacement"][p] then 
							cockpitsdata[ck][p]["deplX"] =paneldata["displacement"][p][1]
							cockpitsdata[ck][p]["deplY"] =paneldata["displacement"][p][2]
							cockpitsdata[ck][p]["deplZ"] =paneldata["displacement"][p][3]
						end
					end
				end
				
				if paneldata["viewpath"] then
					for p=1, panel do
						if paneldata["viewpath"][p][5] then
							cockpitsdata[ck][p]["topanel"][0] =paneldata["viewpath"][p][5]
						else
							cockpitsdata[ck][p]["topanel"][0]=frontpanel
						end
						for arrow=1,4 do
							cockpitsdata[ck][p]["topanel"][arrow] =paneldata["viewpath"][p][arrow]
						end
					end
				end
			end
			if panel >1 and cockpitsdata[ck][panel]["topanel"][0] == 0 then
				local to
				for p=1, panel do
					cockpitsdata[ck][p]["topanel"][0] = 1
					to= p-1; if to==0 then to = panel end
					cockpitsdata[ck][p]["topanel"][1] = to
					to= p+1; if to > panel then to = 1 end
					cockpitsdata[ck][p]["topanel"][2] = to
				end
			end
			panel = cockpitsdata[ck]["firstpanel"] or 1
			celestia:print("")
		end
	end
	if not loading then -- parameters of the cockpit
		zoomcoef = nil
		nbpanel = # cockpitsdata[ck]
		cockpit3D = cockpitsdata[ck]["cockpit3D"]
		if cockpit3D then
			SolarSystem = cockpitsdata[ck]["SolarSystem"]
			model3D = cockpitsdata[ck]["model3D"]
			engine = celestia:find("Sol/"..model3D.."_translation_gear")
			steering = celestia:find("Sol/"..model3D.."_rotation_gear")
			model = celestia:find(SolarSystem.."/"..model3D)
			model:setvisible(true)
			cockpitsFrame.Fillimage = nil
			local fov3D=cockpitsdata[ck]["fov3D"]
			if fov3D then obs:setfov(fov3D / degree) end
			if not engine:visible() then
				celestia:select(model)
			end
		else
			cockpitsFrame:fillimage(cockpitsdata[ck][panel]["tx"])
		end

		rearpanel = cockpitsdata[ck]["rearpanel"] or 0
		if rearpanel > nbpanel then rearpanel = 0 end
		frontpanel = cockpitsdata[ck]["frontpanel"] or 1
		if frontpanel > nbpanel then frontpanel = 1 end
		multipanel = (nbpanel > 1)
		for i=0,4 do btncockpitrotFrame[i].panel=0 end
		pictTex = nil
			
		if multipanel then
			local anglerot = 2*math.pi / nbpanel -- default rotation
			azim = cockpitsdata[ck][panel]["azim"] or  anglerot*(panel-1)
			elev = cockpitsdata[ck][panel]["elev"] or 0
			local vf = cockpitsdata[ck][panel]["vf"] or cockpitsdata[ck]["cfov"]
			if vf and panelratio then zoomcoef = panelratio * math.tan(vf/360*math.pi) end
			deplX = cockpitsdata[ck][panel]["deplX"] or 0
			deplY = cockpitsdata[ck][panel]["deplY"] or 0
			deplZ = cockpitsdata[ck][panel]["deplZ"] or 0
			for a=0,4 do btncockpitrotFrame[a].panel = cockpitsdata[ck][panel]["topanel"][a] end
		end
			
		local image = cockpitsdata[ck]["image"]
		if image and image[panel] then
			if not image[panel]["texture"] then
				local pictName = cockpitdir..tostring(cockpits[ck]).."/"..image[panel][1]
				cockpitsdata[ck]["image"][panel]["texture"]=celestia:loadtexture(pictName)
			end
			pictTex = image[panel]["texture"]
			ckpictureFrame:fillimage(pictTex)
			adjustimage()
		end
		
		adaptzoom()
		if newpanel then
			changepanelview(direct)
			newpanel = false
		end
	end
end

local togglecockpit = function()
	cockpitsmenuFrame.Visible = not cockpitsmenuFrame.Visible
	if cockpitsmenuFrame.Visible then 
		cockpitsmenuFrame:orderfront() 
		if lua_universal_tools_v5 then
			cockpitsCheck.Bordercolor={1,0,0,.5}
		end
	else
		if lua_universal_tools_v5 then
			cockpitsCheck.Bordercolor={0.2,0.8,1,.6}
		end
	end
end

local exit3Dcockpit = function()
	if cockpit3D  then
		cockpit3D = false
		if engine:visible() or steering:visible() then
			engine:setvisible(true)
			steering:setvisible(true)
			engine:setradius(1)
			model:setvisible(false)
		else
			if cockpitvector then
				celestia:print(_"Can't leave ".._(cockpits[ck]).."\n".. _"stop it before",10)
				cockpit3D = true
			else
				powercmd = cockpitsdata[ck]["extpwcmd"]
				cockpitsdata[ck]["intpwcmd"] = 1
			end
		end
	end
end

local nocockpit = function()
	cockpitsFrame.Visible = false;
	cockpitsFrame.Fillimage=nil
	rotationpanelFrame.Visible = false
	multipanel = false
	exit3Dcockpit()
end

local activateCockpit = function(this) -- called by the choice menu
	togglecockpit()
	exit3Dcockpit()
	if not cockpit3D then 
		cockpitsFrame.Visible = true
		backview = false
		ck=this.ck
		panel = 0
		azim, elev = 0,0
		newpanel = true
		loadimage()
		verifcockpitsize()
	end
end

local togglerot = function()
	if nbrot == 0 and oldrotangle then
		initrotation(oldrotangle,axerot)
		oldrotangle = 0
	else
		oldrotangle = nbrot*deltarot
		nbrot = 0
	end
end
		
local function doaccel(vector)
	obs:setspeed(0)
	if not vv then
		power = 0
		if multipanel then changepanelview(inverse) end
		vv= vector; powercmd=math.abs(powercmd)
		if remainingdistance == math.huge then remainingdistance = 0 end
		remainingdistance = remainingdistance + distance
		if multipanel then changepanelview(direct) end
	else
		powercmd = powercmd*impulse
	end
	requirepower()
end

local function accel() doaccel(AV) end

local function reverse()
		if celestiaspeed ~=0 then 
			obs:setspeed(-obs:getspeed())
		elseif not vv then 
			doaccel(AR)
		else
			powercmd = - powercmd
			requirepower()
			powercmd = - powercmd
		end
end

local function slow()
	if refobj then
		powercmd=powercmd/impulse
		requirepower()
	else
		ckspeed = ckspeed/impulse
	end
end

local function stop()
	obs:setspeed(0)
	power = 0
	if vv then
		vv = nil
	else
		vv = oldvv
		power=powercmd
	end
end

local stopall = function()
	if vv or nbrot ~=0 then
		if vv 
			then stop() 
			else oldvv = nil
		end
		if nbrot  ~=0
			then togglerot()
			else oldrotangle = 0
		end
	else
		stop()
		togglerot()
	end
end

local function gostraight()
	if steering then steering:setvisible(true) end 
	if multipanel then
		if cockpitsmenuFrame.Visible then togglecockpit() end
		panel=1
		loadimage()
	end
	power = 0
	if vv then vv = AV end
	powercmd=math.abs(powercmd)
	requirepower()
end

local function lookback()
	obs:rotate(celestia:newrotation(UP, math.pi))
	if vv then vv = vv*-1 end
end

-- ===========================
-- boxes functions
-- ===========================

btncockpitchoice[0].Action = function()
	nocockpit()
	togglecockpit()
end
for i=1, #cockpits do btncockpitchoice[i].Action = activateCockpit end

local verifposition = function()
	obs=celestia:getobserver()
	local obspos = obs:getposition()
	local orient = obs:getorientation()
	if cockpit3D and steering:visible() then 
		cockpitorientation = orient 
	end
	local sc = celestia:getscripttime()
	local dt = sc - scripttime
	perf = (perf*29+dt)/30
	scripttime = celestia:getscripttime()
	frame = obs:getframe()
	refobj = frame:getrefobject()
	celestiaspeed = obs:getspeed()
	if celestiaspeed~=0 then
		vv=nil oldvv=nil 
		if not celvv then celvv = AV end
	else
		celvv = nil
	end

	if acceltime>0 then
		power = power + deltapower
		if power<0 then
			power =-power; deltapower = -deltapower
			if vv then vv=vv*-1 end
		end
		acceltime = acceltime -1
	end
	
	if vv then
		oldvv = vv
		if refobj or set3Dposition() then ckspeed = initspeed() * power end
		local v =  ckspeed * dt
		if remainingdistance <= v then v = remainingdistance end
		if extracontrolpanel.Visible then 
			local dvv = vv:normalize() * v * km
			dx = dx + dvv:getx()
			dy = dy + dvv:gety()
			dz = dz + dvv:getz()
		end
		local vdir
		vdir = orient:transform(vv) * v 
		obspos = obspos:addvector(vdir) -- new position
		obs:setposition(obspos)
		remainingdistance = remainingdistance - v
		if remainingdistance <= 0 then stop() end
		if aheadposition then
			aheadposition = obspos:addvector(vdir*100)
		end
	else
		if celestiaspeed == 0 then
			if refobj or set3Dposition() then ckspeed = initspeed() * powercmd end
		else
			ckspeed=celestiaspeed
		end
	end
	------------------------------
	-- track management
        ------------------------------
	if (tracked or aheadposition) and vv then
		local trackpos
		if tracked then
			trackpos = tracked:getposition()
		else
			trackpos = aheadposition
		end
		local neworient = obspos:orientationto(trackpos, orient:transform(UP))
		neworient = orient:slerp(neworient,fracrot)
		obs:setorientation(neworient)
		if fracrot == 1 then
			aheadposition = nil
		else
			fracrot = math.min(fracrot+perf/2,1)
		end
		local vdir = orient:transform(vv):normalize()
		local invrot = inverserotation(neworient)
		vv = invrot:transform(vdir):normalize()
	end
	
	if cockpit3D and aheadposition and not vv then
		local neworient = cockpitorientation
		neworient = orient:slerp(neworient,fracrot)
		obs:setorientation(neworient)
		if fracrot == 1 then
			aheadposition = nil
		else
			fracrot = math.min(fracrot+perf/2,1)
		end
	end
	
	if tracked 
		then speedboxheight = 32
		else speedboxheight = 16
	end
	trackSpeedDisplay:attach(screenBox,0, 0,width-130,height-speedboxheight)

	-----------------------------------
	-- rotation management
        -----------------------------------
	if nbrot >0 then
		tourne(axerot, deltarot)
		nbrot = nbrot -1
		if extracontrolpanel.Visible then 
			if         axerot == GA then drotX = drotX - deltarot*degree
				elseif axerot == DR then drotX = drotX + deltarot*degree
				elseif axerot == UP then drotY = drotY + deltarot*degree
				elseif axerot == DN then drotY = drotY - deltarot*degree
				elseif axerot == AV then drotZ = drotZ - deltarot*degree
				elseif axerot == AR then drotZ = drotZ + deltarot*degree
			end
		end
	end
        -------------------------------
	-- extra control reinit
        -------------------------------
	if not extracontrolpanel.Visible then 
		dx=0; dy=0; dz=0;
		drotX = 0; drotY = 0; drotZ = 0;
    end
end   

trackSpeedDisplay.Customdraw = function(this)
	-- display tracked name if any
	_textlayout:setfont(normalfont)
	_textlayout:setlinespacing(lspace)
	_textlayout:setpos(this.lb+5,this.tb-lspace*1+2) -- position of the first line
	if tracked then
		_textlayout:setfontcolor({0.25,0.5,1,1})
		_textlayout:println("> "..getlocalname(tracked))
	end
        ---------------------------------------
	-- speed display
        ---------------------------------------
	local v= math.abs(ckspeed*km*1000)
	local u = _("m/s")
	if v>=1000  then 
		v=v/1000   u=_("km/s")
		if v>=10000 then 
			v=v/km_c   u=_("c")
			if v>=100   then 
				v=v/c_au   u=_("au/s")
				if v>=1000  then 
					v=v/au_ly  u=_("ly/s" )
				end
			end
		end
	end
	v= sround(v,3)

	if celestiaspeed ~= 0 then
		_textlayout:setfontcolor(celestiacolortext)
		_textlayout:println(_("Speed: ")..v.." "..u)
	else
		if vv then
			if set3Dposition() and cockpitvector
				then _textlayout:setfontcolor({0,1,1,1}) -- cyan: moving in a moving cockpit
				else _textlayout:setfontcolor(speedontext)
			end
			_textlayout:println(_("Speed: ")..v.." "..u)
		else
			if set3Dposition() and cockpitvector
				then _textlayout:setfontcolor({1,1,0,1}) -- yellow: cockpit is moving
				else _textlayout:setfontcolor(speedofftext)
			end
			         _textlayout:println(_("Speed: ").."("..v.." "..u..")")
		end
	end
end

cockpitsFrame.Customdraw = function()          
	ckpictureFrame.Visible = pictTex
end

nominalpowerbutton.Customdraw = function(this)
	this:textfont(normalfont)
	this:textcolor(ctext)
	this:movetext(0, 7)
	if vv 
		then this:fillcolor({0,1,0,0.25}) -- ON
		else this:fillcolor({1,0,0,0.25}) -- OFF
	end
	if refobj then
		this:text(tostring(sround(math.abs(powercmd),3)))
	else
		this:text("- - -") 
	end
end

fenangle.Customdraw = function(this)
	if not this.Highlight then
		if  cockpit3D and string.sub(this.Text,1,1) == ">" then
			local cmd = string.sub(this.Text,2)
			if cmd == "0" then
				engine:setradius(1)
				this.Text = oldangleText
			elseif cmd == "000" then
				engine:setradius(2)
				this.Text = oldangleText
			end
		end
		defaultrot= math.abs(tonumber(this.Text) or math.huge)
		if defaultrot == math.huge then
			this.Text = ">>>"
		else
			this.Text = tostring(defaultrot)
		end
	else
		vv = savevv
		obs:setspeed(savecelspeed)
	end
end

fenspeedrot.Customdraw = function(this)
	if nbrot>0 then
		this:fillcolor(rotspeedcoloron)
	else
		this:fillcolor(rotspeedcoloroff)
	end
end

local depldistance = function(x)
	local u = " km"
	local d = x
	if math.abs(x) <1 then
		d=d*1000
		u= " m"
	elseif math.abs(x) > 9.46e12 then
		d=d/km/10^6
		u = " al"
	end
	if u == " m" then
		return round(d,2)..u
	else
		return sround(d,5)..u
	end
end

extracontrolpanel.Customdraw = function(this)
	        _textlayout:setfont(normalfont)	
            _textlayout:setfontcolor({0.2,0.8,1,1})                                        
	        _textlayout:setlinespacing(lspace)
	        _textlayout:setpos(this.lb+3,this.tb-lspace*1+3-2+1) -- position of the first line
            _textlayout:println(_"Panel Extra Control:")                                    
                                                
    if refobj then            
		local obspos = obs:getposition()
		local refpos = refobj:getposition()
		local vecteur = obspos:vectorto(refpos)
		local orient = obs:getorientation()
		local invrot = inverserotation(orient)
		local vecdepl = invrot:transform(vecteur) * km
		
        _textlayout:setpos(this.lb+5+3,this.tb-lspace*1-17) -- position of the first line                                                   
        _textlayout:setfontcolor(ctext)
        _textlayout:println("pX = "..depldistance( (vecdepl.x) ))
		_textlayout:println("pY = "..depldistance( (vecdepl.y) ))
		_textlayout:println("pZ = "..depldistance( -(vecdepl.z) ))
	end

        _textlayout:setpos(this.lb+5+3,this.tb-lspace*4-8-1) -- position of the first line 
        _textlayout:setfontcolor({0.2,0.8,1,1})       
        _textlayout:println(_"")
				
		_textlayout:println("X° = "..(drotX/360)-math.fmod(drotX/360, 1)..": "..((round(drotX,5)-math.fmod(round(drotX,5),1))-((drotX/360)-math.fmod(drotX/360, 1))*360).."° "
		                           ..round(math.fmod(((round(math.fmod(drotX, 1)*60,0))/60),1)*60,0).."' "..round(math.fmod(((round(math.fmod(drotX, 1)*3600,0))/60),1)*60,0).."'' ")
		
		_textlayout:println("Y° = "..(drotY/360)-math.fmod(drotY/360, 1)..": "..((round(drotY,6)-math.fmod(round(drotY,6),1))-((drotY/360)-math.fmod(drotY/360, 1))*360).."° "
		                           ..round(math.fmod(((round(math.fmod(drotY, 1)*60,0))/60),1)*60,0).."' "..round(math.fmod(((round(math.fmod(drotY, 1)*3600,0))/60),1)*60,0).."'' ")		                           
									
		_textlayout:println("Z° = "..(drotZ/360)-math.fmod(drotZ/360, 1)..": "..((round(drotZ,6)-math.fmod(round(drotZ,6),1))-((drotZ/360)-math.fmod(drotZ/360, 1))*360).."° "
		                           ..round(math.fmod(((round(math.fmod(drotZ, 1)*60,0))/60),1)*60,0).."' "..round(math.fmod(((round(math.fmod(drotZ, 1)*3600,0))/60),1)*60,0).."'' ")
									
		_textlayout:setpos(this.lb+5+3,this.tb-lspace*8-8-7) -- position of the first line 
	    _textlayout:setfontcolor({0.2,0.8,1,1}) 
	    _textlayout:setfontcolor(ctext) 
        _textlayout:println("dX = "..depldistance(dx))
	    _textlayout:println("dY = "..depldistance(dy))
	    _textlayout:println("dZ = "..depldistance(-dz))
end   

control3Drotation.Customdraw = function(this)
	if steering then 
		if steering:visible() then
			this:fillcolor(controled3Dcolor)
		else
			this:fillcolor(free3Dcolor)
		end
	end
end


-- ==================================
-- ACTIONS
-- ==================================

control3Drotation.Action = function(this)
	if steering then steering:setvisible(not steering:visible()) end
end

control3Dtranslation.Action = function(this)
	if engine then 
		engine:setvisible(not engine:visible())
		if set3Dposition() then 
			oldcockpit3Dselection = celestia:getselection()
			cockpitvector = nil
			cockpitsdata[ck]["cockpitframe"] = obs:getframe()
			cockpitsdata[ck]["extpwcmd"] = powercmd
			powercmd = cockpitsdata[ck]["intpwcmd"] or 1
			if vv then
				cockpitvector = obs:getorientation():transform(vv)
				cockpitspeed = ckspeed * perf
				vv= nil
				power = 0
			end
			celestia:select(model)
		else
			vv = nil
			if cockpitvector then
				vv = inverserotation(obs:getorientation()):transform(cockpitvector)
			end
			cockpitsdata[ck]["intpwcmd"] = powercmd
			powercmd = cockpitsdata[ck]["extpwcmd"]
			power = powercmd
			obs:setframe(cockpitsdata[ck]["cockpitframe"])
			if celestia:getselection():name() == model3D then celestia:select(cockpitsdata[ck]["cockpitframe"]:getrefobject()) end
		end
	end
	oldvv = nil
end

local btnrotAction = function(this,pan)
	local oldpan = panel
	changepanelview(inverse)
	if pan then
		panel = pan
	else
		if this.panel == frontpanel and oldpan==frontpanel and rearpanel~=0 then
			panel = rearpanel
		else
			panel = this.panel
		end
	end
	if cockpitsmenuFrame.Visible then togglecockpit() end
	loadimage()
	changepanelview(direct)
end
for i=0,4 do btncockpitrotFrame[i].Action = btnrotAction end
	
fenangle.Action = function(this)
	oldangleText = this.Text
	nbrot = 0
	this.Text = ""
	savevv = vv
	savecelspeed = celestiaspeed
end

decspeedrot.Action = function(this)
	rotationspeed = rotationspeed / rotimpulse
	fenspeedrot.Text = tostring(round(rotationspeed))
	initrotation(0,axerot)
end

incspeedrot.Action = function(this)
	rotationspeed = rotationspeed * rotimpulse
	fenspeedrot.Text = tostring(round(rotationspeed))
	initrotation(0,axerot)
end
--[[
if lua_universal_tools_v5 then  -- place with cockpitsCheck =  = CXBox:new()
	cockpitsCheck.Action = function(this)
		togglecockpit() -- display or not display frame
	end
end
]]
local dirAction = function(this) 
	obs:setspeed(0)
	local btn = this.btn
	if btn==0 or btn==7 then stop()
	elseif btn < 8 then -- translation
		if refobj then
			power = 0
			powercmd=math.abs(powercmd)
			requirepower()	
		end
		vv = direction[btn]
		
		if remainingdistance == math.huge then remainingdistance = 0 end
		remainingdistance = remainingdistance + distance
		
	elseif btn ~= 14 then -- rotations
		initrotation(defaultrot/degree, direction[btn])
	else
		togglerot()
	end
end
for i = 0,14 do btncockpitmanFrame[i].Action = dirAction end

slowbutton.Action = slow

accelbutton.Action = function() 
	if refobj then
		powercmd=powercmd*impulse
		requirepower()
	else
		ckspeed = ckspeed*impulse
	end
end

distanceunitbutton.Action = function(this)
	unitidx = unitidx + 1
	if unitidx > #tabunitdist then unitidx = 1 end
end
----------------------------------------------------
-- program main loop
----------------------------------------------------
cockpitsSurvey.Customdraw = function(this)
	verifposition()
	oldwidth, oldheight = width, height
	width, height = celestia:getscreendimension()
	trackSpeedDisplay.Visible = displayspeed
	extracontrolpanel.Visible = showextra and manoeuvrepanelFrame.Visible 
	control3Drotation.Visible = cockpit3D
	control3Dtranslation.Visible = cockpit3D -- and (not vv) and (obs:getspeed()== 0)
	if cockpit3D then
		local sel = celestia:getselection()
		if engine:visible() then
			if sel:name() == model3D then
				celestia:select(oldcockpit3Dselection)
			else
				oldcockpit3Dselection = sel
			end
		elseif sel:name() ~= model3D then
			oldcockpit3Dselection = sel
		end
	end
	local textoverlay = celestia:getoverlayelements()
	textoverlay.Velocity = false
	celestia:setoverlayelements(textoverlay)
		
	local changescreendim = (oldwidth ~= width or oldheight ~= height)
	if cockpitsFrame.Visible then
		if loading then loadimage() end
		obs=celestia:getobserver()
		local cpvisible = false
		for i=0,4 do 
			btncockpitrotFrame[i].Visible = (btncockpitrotFrame[i].panel >0)
			cpvisible = cpvisible or btncockpitrotFrame[i].Visible
		end
		rotationpanelFrame.Visible = cpvisible
	end
	if changescreendim then 
		verifcockpitsize()
	end
end

local Track=function() 
	if tracked then
		tracked = nil
	else
		tracked = celestia:getselection()
		if tracked:name() == "?" then
			tracked = nil
		end
	end
	if tracked then
		fracrot = perf/2
		aheadposition = nil
	end
end

local Viewahead=function()
	if vv or (cockpit3D and not steering:visible()) then
		tracked = nil
		aheadposition = true
		fracrot = perf/2
	end
end
----------------------------------------------------

keymap["w"] = accel
keymap["z"] = slow
keymap["s"] = stopall
keymap["q"] = reverse
-- keymap["x"] = gostraight
keymap["*"] = lookback

keymap[manoeuvre_track_key or "T"] = Track
keymap[manoeuvre_view_ahead_key or "R"] = Viewahead

local shortcut = cockpits_shortcut or "Z"
keymap[shortcut] = togglecockpit

-- local key = visor_shorcut or "X"
-- keymap[key] = toggleNavig

if cockpit_switch_key then  -- no default key
	keymap[cockpit_switch_key] = cockpitswitch
end

celestia:log("-- cockpitsBox V3D loaded")

-- =====================================================
--  Заголовоки. Космические Манёвры / Космический полет к Звездам. Спидометр.
-- =====================================================

SpeedometerBox = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.8})
    :fillcolor({0,.4,.6,.6})
    :textfont(normalfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 6)
    :text(_(""))
    :movable(false)
    :active(true)    
    :attach(manoeuvrepanelFrame, 4, 136+3, 4, 20)

SpeedometerBox.Customdraw = function(this)  

           textlayout:setfont(normalfont);
           textlayout:setfontcolor({0.2,0.8,1,1});
           textlayout:setpos(this.lb + 0, this.tb + 7);
           textlayout:println(_("         Space flight to the stars:")); 
           textlayout:setpos(this.lb + 0, this.tb - 60-1);
           textlayout:println(_("             Space Maneuvers:"));
 
           textlayout:setfont(smallfont);
           textlayout:setfontcolor({1,1,0,0.8});
           textlayout:setpos(this.lb + 55, this.tb - 78);
           textlayout:println(_("Manag. turns. :"));  
           textlayout:setpos(this.lb + 0, this.tb - 130);
           textlayout:println(_("Speed managem. :"));  
           textlayout:setpos(this.lb + 87, this.tb - 130);
           textlayout:println(_("/ Travel distance. :")); 
   
          ------------------------------------------
           -- display tracked name if any
          ------------------------------------------
	_textlayout:setfont(normalfont)
	_textlayout:setlinespacing(lspace)	
        _textlayout:setpos(this.lb+7-4, this.tb - 10) 

	if tracked then
		_textlayout:setfontcolor({0.25,0.5,1,1})
		_textlayout:println("> "..getlocalname(tracked))
	end

	-- speed display
	local v= math.abs(ckspeed*km*1000)
	local u = _("m/s")
	if v>=1000  then 
		v=v/1000   u=_("km/s")
		if v>=10000 then 
			v=v/km_c   u=_("c")
			if v>=100   then 
				v=v/c_au   u=_("au/s")
				if v>=1000  then 
					v=v/au_ly  u=_("ly/s" )
				end
			end
		end
	end
	v= sround(v,3)

	if celestiaspeed ~= 0 then
		_textlayout:setfontcolor(celestiacolortext)
		_textlayout:println(_("Speed: ")..v.." "..u)
	else
		if vv then
			if set3Dposition() and cockpitvector
				then _textlayout:setfontcolor({0,1,1,1}) -- cyan: moving in a moving cockpit
				else _textlayout:setfontcolor(speedontext)
			end
			_textlayout:println(_("Speed: ")..v.." "..u)
		else
			if set3Dposition() and cockpitvector
				then _textlayout:setfontcolor({1,1,0,1}) -- yellow: cockpit is moving
				else _textlayout:setfontcolor(speedofftext)
			end
			_textlayout:println(_("Speed: ").."("..v.." "..u..")")
		end
	end

end;

-- ==================
-- Увеличение скор. полета
-- ==================

FasterButton = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :fillcolor(cFrameFill) 
    :textfont(normalfont)
    :textcolor(cbutextoff) 
    :textpos("center") 
    :movetext(0, 7)
    :text(_(" Faster"))
    :movable(false)
    :active(true)  
    :attach(manoeuvrepanelFrame, 26*0+4, 17*(gg-3)+2, 26*4+4, 3+17*3)  
 
FasterButton.Action = (function()
       return
         function()    
           obs = celestia:getobserver()         
           actual = obs:getspeed() * uly_to_km
           obs:setspeed(actual*2/uly_to_km) 
           actual2 = obs:getspeed() * uly_to_km          
         end
      end) ();
   
-- ==================
-- Уменьшение cкор. полёта
-- ==================

SlowerButton = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :fillcolor(cFrameFill) 
    :textfont(normalfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 6)
    :text(_("Slower "))
    :movable(false)
    :active(true)  
    :attach(manoeuvrepanelFrame,  26*3+4, 17*(gg-3)+2, 26*2+4, 3+17*3)

SlowerButton.Action = (function()
       return
         function()    
           obs = celestia:getobserver()         
           actual = obs:getspeed() * uly_to_km
           obs:setspeed(actual*0.5/uly_to_km) 
           actual2 = obs:getspeed() * uly_to_km          
           end
      end) ();

-- ================
--  Стоп 
-- ================

StopButton = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :fillcolor(cFrameFill) 
    :textfont(normalfont)
    :textcolor({1,0,0,1})
    :textpos("center")
    :movetext(0, 6+1-1)
    :text(_("Stop "))
    :movable(false)
    :active(true) 
    :attach(manoeuvrepanelFrame,  26*5+4, 17*(gg-3)+2, 4, 3+17*3)

StopButton.Action = (function()
       return
         function()        
             obs = celestia:getobserver()
             obs:setspeed(0/uly_to_km)     
         end
      end) ();
-- ==================
-- Скорость 1 км/сек
-- ==================

Speed1Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :fillcolor(cFrameFill) 
    :textfont(normalfont)
    :textcolor(cbutextoff)   
    :textpos("center")
    :movetext(0, 7)
    :text(_("1"))
    :movable(false)
    :active(true)  
    :attach(manoeuvrepanelFrame, 26*0+4, 17*(gg-2)+2, 26*6+4, 3+17*2)

Speed1Button.Action = (function()
       return
         function()        
             obs = celestia:getobserver()
             obs:setspeed(1/uly_to_km)     
         end
      end) ();

-- ==================
-- Скорость 1000 км/сек
-- ==================

Speed2Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :fillcolor(cFrameFill) 
    :textfont(normalfont)
    :textcolor(cbutextoff)    
    :textpos("center")
    :movetext(0, 7)
    :text(_("2"))
    :movable(false)    
    :active(true)  
    :attach(manoeuvrepanelFrame, 26*1+4, 17*(gg-2)+2, 26*5+4, 3+17*2)

Speed2Button.Action = (function()
       return
         function()        
             obs = celestia:getobserver()
             obs:setspeed(1000/uly_to_km)     
         end
      end) ();

-- ==================
-- Скорость 1 скорость света
-- ==================

Speed3Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :fillcolor(cFrameFill) 
    :textfont(normalfont)
    :textcolor(cbutextoff)    
    :textpos("center")
    :movetext(0, 7)
    :text(_("3"))
    :movable(false)
    :active(true)  
    :attach(manoeuvrepanelFrame, 26*2+4, 17*(gg-2)+2, 26*4+4, 3+17*2)

Speed3Button.Action = (function()
       return
         function()        
             obs = celestia:getobserver()
             obs:setspeed(299792.458/uly_to_km)     
         end
      end) ();
-- ==================
-- Скорость 1 а. единица /сек.
-- ==================

Speed4Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :fillcolor(cFrameFill) 
    :textfont(normalfont)
    :textcolor(cbutextoff)    
    :textpos("center")
    :movetext(0, 7)
    :text(_("4"))
    :movable(false)
    :active(true)  
    :attach(manoeuvrepanelFrame, 26*3+4, 17*(gg-2)+2, 26*3+4, 3+17*2)

Speed4Button.Action = (function()
       return
         function()        
           --  obs = celestia:getobserver()
           --  obs:setspeed(2997924.58/uly_to_km)      -- 10 скоростей света
               obs:setspeed(149597870.7/uly_to_km)   
         end
      end) ();

-- ==================
-- Скорость 1 св. год / сек.
-- ==================

Speed5Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :fillcolor(cFrameFill) 
    :textfont(normalfont)
    :textcolor(cbutextoff)    
    :textpos("center")
    :movetext(0, 7)
    :text(_("5"))
    :movable(false)
    :active(true)  
    :attach(manoeuvrepanelFrame, 26*4+4, 17*(gg-2)+2, 26*2+4, 3+17*2)

Speed5Button.Action = (function()
       return
         function()        
             obs = celestia:getobserver()          
             obs:setspeed(9460730472580.8/uly_to_km)  
         end
      end) ();

-- ==================
-- Скорость 10 св. / сек.
-- ==================

Speed6Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :fillcolor(cFrameFill) 
    :textfont(normalfont)
    :textcolor(cbutextoff)
    --:textpos("left")
    :textpos("center")
    :movetext(0, 7)
    :text(_("6"))
    :movable(false)
    :active(true)   
    :attach(manoeuvrepanelFrame, 26*5+4, 17*(gg-2)+2, 26*1+4, 3+17*2)

Speed6Button.Action = (function()
       return
         function()       
             obs = celestia:getobserver()
             obs:setspeed(94607304725808/uly_to_km) 
         end
      end) ();
-- ==================
-- Реверс
-- ==================

Speed7Button = pCXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(normalfont)
    :textcolor({1,0,0,.8})
    :textpos("center")
    :movetext(0, 7)
    :text(_("R"))
    :movable(false)
    :active(true)    
    :attach(manoeuvrepanelFrame, 26*6+4, 17*(gg-2)+2, 26*0+4, 3+17*2)

Speed7Button.Action = (function()
       return
         function() 

		if celestiaspeed ~=0 then 
			obs:setspeed(-obs:getspeed())
		elseif not vv then 
			doaccel(AR)
		else
			powercmd = - powercmd
			requirepower()
			powercmd = - powercmd
		end
         end
      end) ();
