-- The table can include the following values:
--    >    objects = { string:object1path, string:object2path, ... }
--    Defines the list of objects whose visibility will be enabled/disabled.
--    >    labelcolor = {number:red, number:green, number:blue, number:alpha}
--    Defines the color of the addon labels. The name of the addon will be then displayed using
--    this same color in the 'Addon Visibility' window.
--    >    locationtypes = {string:locationtype1, string:locationtype2, ...}
--    Defines the types of location that will be enabled/disabled simultaneously with the objects visibility.
--    List of all location types: http://en.wikibooks.org/wiki/Celestia/SSC_File#Type_.22string.22
--    >    script = string:scriptfilename
--    Defines the filename of the script that is run whenever the addon checkbox is clicked (either checked or unchecked)
--    The script path is relative to the addon's directory.

Comets01 =
{
labelcolor = {1, 1, 0, 1},

    objects =
        {
"Sol/100P",
"Sol/103P",
"Sol/104P",
"Sol/105P",
"Sol/10P",
"Sol/116P",
"Sol/118P",
"Sol/11P",
"Sol/124P",
"Sol/125P",
"Sol/127P",
"Sol/141P",
"Sol/141P-A",
"Sol/141P-D",
"Sol/157P",
"Sol/15P",
"Sol/162P",
"Sol/169P",
"Sol/16P",
"Sol/175P",
"Sol/1766 G1",
"Sol/1770 L1",
"Sol/182P",
"Sol/185P",
"Sol/1884 O1",
"Sol/1886 K1",
"Sol/189P",
"Sol/1952 B1",
"Sol/1978 R1",
"Sol/197P",
"Sol/1999 J6",
"Sol/2000 R2",
"Sol/2002 R5",
"Sol/2002 S7",
"Sol/2003 T12",
"Sol/2004 T1",
"Sol/2005 JN",
-- "Sol/2005 W4", -- delete 1119
"Sol/2006 S1",
"Sol/2007 R2",
"Sol/2007 T2",
"Sol/2008 QP20",
"Sol/2008 WZ96",
"Sol/2008 Y12",
"Sol/2009 Q4",
"Sol/2009 WX51",
"Sol/2010 A2",
"Sol/2010 B2",
-- "Sol/2010 N1", -- delete 1119
"Sol/2011 A2",
"Sol/2011 VJ5",
"Sol/2012 T1",
"Sol/2013 CU129",
"Sol/2013 R3",
"Sol/2013 R3-A",
"Sol/2013 R3-B",
"Sol/2013 T2",
-- "Sol/2013 US10", -- move cotetsXYZV
"Sol/2013 W1",
"Sol/2013 YG46",
"Sol/2014 C1",
"Sol/2014 U2",
"Sol/2014 U4",
"Sol/2015 J3",
"Sol/2015 Q1",
"Sol/2015 X6",
"Sol/2016 BA14",
"Sol/201P",
"Sol/206P",
"Sol/209P",
"Sol/210P",
"Sol/213P",
"Sol/213P-B",
"Sol/218P",
"Sol/220P",
"Sol/221P",
"Sol/222P",
"Sol/224P",
"Sol/22P",
"Sol/230P",
"Sol/233P",
"Sol/238P",
"Sol/249P",
"Sol/251P",
"Sol/252P",
"Sol/253P",
"Sol/255P",
"Sol/259P",
"Sol/25D",
"Sol/263P",
"Sol/267P",
"Sol/26P",
"Sol/289P",
"Sol/294P",
"Sol/297P",
"Sol/298P",
"Sol/2P",
"Sol/300P",
"Sol/304P",
"Sol/306P",
"Sol/311P",
"Sol/312P",
"Sol/313P",
"Sol/317P",
"Sol/320P",
"Sol/321P",
"Sol/322P",
"Sol/323P",
"Sol/324P",
"Sol/325P",
"Sol/331P",
"Sol/332P",
"Sol/337P-WISE",
"Sol/338P-McNaught",
"Sol/342P-SOHO",
"Sol/37P",
"Sol/41P",
"Sol/43P",
"Sol/45P",
"Sol/46P",
"Sol/57P",
"Sol/57P-A",
"Sol/5D",
-- "Sol/67P",  -- move cotetsXYZV
"Sol/71P",
--[[
"Sol/73P", -- включено в comets09.lua
"Sol/73P-AA",
"Sol/73P-AB",
"Sol/73P-AC",
"Sol/73P-AD",
"Sol/73P-AE",
"Sol/73P-AF",
"Sol/73P-AG",
"Sol/73P-AH",
"Sol/73P-AI",
"Sol/73P-AK",
"Sol/73P-AL",
"Sol/73P-AM",
"Sol/73P-AN",
"Sol/73P-AO",
"Sol/73P-AP",
"Sol/73P-AQ",
"Sol/73P-AR",
"Sol/73P-AS",
"Sol/73P-AT",
"Sol/73P-AU",
"Sol/73P-AV",
"Sol/73P-AW",
"Sol/73P-AX",
"Sol/73P-AY",
"Sol/73P-AZ",
"Sol/73P-B",
"Sol/73P-BA",
"Sol/73P-BB",
"Sol/73P-BC",
"Sol/73P-BD",
"Sol/73P-BE",
"Sol/73P-BF",
"Sol/73P-BG",
"Sol/73P-BH",
"Sol/73P-BI",
"Sol/73P-BJ",
"Sol/73P-BK",
"Sol/73P-BL",
"Sol/73P-BM",
"Sol/73P-BN",
"Sol/73P-BO",
"Sol/73P-BP",
"Sol/73P-BQ",
"Sol/73P-BR",
"Sol/73P-BS",
"Sol/73P-C",
"Sol/73P-E",
"Sol/73P-G",
"Sol/73P-H",
"Sol/73P-K",
"Sol/73P-L",
"Sol/73P-M",
"Sol/73P-N",
"Sol/73P-Q",
"Sol/73P-R",
"Sol/73P-S",
"Sol/73P-T",
"Sol/73P-U",
"Sol/73P-V",
"Sol/73P-W",
"Sol/73P-X",
"Sol/73P-Y",
"Sol/73P-Z",
]]
"Sol/76P",
"Sol/79P",
"Sol/7P",
"Sol/81P",
"Sol/83D",
"Sol/87P",
"Sol/88P",
"Sol/96P",
"Sol/9P",

-- add 1119
"Sol/128P-A",
"Sol/128P-B",
--[[ -- move comets09
"Sol/332P-A",
"Sol/332P-B",
"Sol/332P-C",
"Sol/332P-D",
"Sol/332P-E",
"Sol/332P-F",
"Sol/332P-G",
"Sol/332P-H",
"Sol/332P-I",
]]
"Sol/337P-WISE",
"Sol/338P-McNaught",
"Sol/342P-SOHO",
"Sol/2016 BA14",
        }
}