------------------------------------------------------------------------------------------------------------------------------
-- ObjectVisibilityButton for asteroids and comets managed by Vidiba
-- by P. Ziegler aka Gironde 16/08/2018
-- edit by Lygin Gennady a.k.a. Croc 19.08.2018
---------------------------------------------
local actualobj
local objname
local ObjNamePrecedClic
local ClicObj = false

ObjectVisibilityButton = CXBox:new() -- New1Button by Croc
	:init(0, 0, 0, 0)
	:bordercolor(cbubordmenuoff)
	:fillcolor(cFrameFill)
	:textfont(normalfont)
	:textcolor(color2)
	:textpos("center")
	:movetext(-3, 10)
	:text(_("Obj.View"))
	:movable(false)
	:active(true)
	:attach(menuLine3Box, -44-4, 0, 0, 0)

ObjectVisibilityButton.Customdraw = function(this)--+

	if ClicObj == true then -- ObjectVisibilityButton has been used previously--+
		actualobj = celestia:find(ObjNamePrecedClic) -- find the previous object--+
		celestia:select(actualobj) --  and select it again--+
		objname = actualobj:name()--+
		ClicObj = false -- clears the history--+
		ObjNamePrecedClic = "" -- clears the history--+
	else
		-- gets the selection, old or new, to redo the cycle
		actualobj = celestia:getselection() -- get the actual selected object, ObjNamePrecedClic or new--+
		ObjNamePrecedClic = "" -- clears the history--+
	end
	
	objclass = actualobj:type ()
	--ClicObj = false -- clears the history--+
	--ObjNamePrecedClic = "" -- clears the history--+
	--------------------------------------------------
	if objclass == "asteroid" or objclass == "comet" then -- clickable for asteroid and comet
		ObjectVisibilityButton.Clickable = true--+
		ObjectVisibilityButton.Textcolor = color4	-- textcolor green--+
		---------------------------
		--ObjNamePrecedClic = objname -- save the name of selected object--+
		---------------------------
	else -- not clickable for other class
		ObjectVisibilityButton.Clickable = false--+
		ObjectVisibilityButton.Textcolor = color2	-- textcolor yellow--+
	end
	--------------------------------------------------
	if actualobj:visible() == true then			-- change the function of button--+
		ObjectVisibilityButton.Text = "Obj.Hide"--+
	else
		ObjectVisibilityButton.Text = "Obj.View"--+
	end
	--------------------------------------------------
end

ObjectVisibilityButton.Action = (function() -- clickable only for asteroid and comet
	return
		function()
			--actualobj = celestia:getselection() -- get the actual selected object
			objname = actualobj:name() -- the name of selection in Customdraw--+
			ClicObj = true--+
			ObjNamePrecedClic = objname--+
			
			if actualobj:visible() == true then--+
				actualobj:setvisible(false)
				actualobj = celestia:find(objname) -- reselectionne l'objet precedent--+
				celestia:select(actualobj)		-- confirm the selection to avoid the loss of the selection found some times--+
				ClicObj = true--+
				ObjNamePrecedClic = objname -- keep the name of the object to be able to recover it in case of loss of the selection--+
			else
				actualobj:setvisible(true)--+
				actualobj = celestia:find(objname) -- reselectionne l'objet precedent--+
				celestia:select(actualobj)		-- confirm the selection to avoid the loss of the selection found some times--+
				ClicObj = true--+
				ObjNamePrecedClic = objname--+
			end
		end
end) ()

------------------------------------------------------------------------------------------------------------------------------