---------------------------------------------------
-- menuLine1_1Box.lua
-- code copied from panelAll2Box.lua by Lygin Gennady a.k.a Croc 18.03.2017
-- edit Patrick Ziegler a.k.a. Gironde 10-04-2017
-- edit Lygin Gennady a.k.a. Croc 19.08.2018
-- coding by Patrick Ziegler a.k.a. Gironde 01-09-2018
---------------------------------------------------

menuLine1_1Box = CXBox:new() 
	:init(0, 0, 0, 0)
	:movable(false)
	:attach(screenBox, width, height, 0, 0)

--========================================================
	--- button's description in menuLine1_1 ---
--========================================================
local actual_timescale = 1

local setCurrentTime = function()
	local UTCtime = os.date("!*t")
	celestia:settime(celestia:utctotdb(UTCtime.year, UTCtime.month, UTCtime.day, UTCtime.hour, UTCtime.min, UTCtime.sec))
end

----------------------------------------------
-- Load images for manipulation of time loaded before panel7
----------------------------------------------
timeRevImage = celestia:loadtexture("../images/time_rev_button.png")
time1xImage = celestia:loadtexture("../images/time_1x_button.png")
timeDiv2Image = celestia:loadtexture("../images/time_div2_button.png")
timeDiv10Image = celestia:loadtexture("../images/time_div10_button.png")
timeMult2Image = celestia:loadtexture("../images/time_mult2_button.png")
timeMult10Image = celestia:loadtexture("../images/time_mult10_button.png")
timeCurImage = celestia:loadtexture("../images/time_cur_button.png")
timePauseImage = celestia:loadtexture("../images/time_paus_button.png")

------------------------------------------------------------------
-- timescale control buttons
------------------------------------------------------------------
-- Строка пиктограмм
-- "<->"
-- reverse time: forward / backward
-- обратное время: вперед / назад
-----------------------------------------------------
revTimeButton = CXBox:new()
	:init(0, 0, 0, 0)
 	:bordercolor({1,1,0,.8})
	:fillimage(timeRevImage)
	:movable(false)
	:active(true)  
	:attach(menuLine1_1Box, -27, 0, 29*6, -14) 

revTimeButton.Action = (function()
	return
		function()
		   if math.abs(celestia:gettimescale()) >=0 then
			  celestia:settimescale(-celestia:gettimescale())
              revTimeButton.Bordercolor = {0,1,0,0.8}			  
		   else	
              revTimeButton.Bordercolor = {1,1,0,0.8}		   
           end		   
		end
	end) ()
	
-------------------------------------------------
-- Строка пиктограмм
--  "<<<"
-- 10 times slower
-- Замедление в 10 раз
-------------------------------------------------
divTimeBy10Button = CXBox:new()
	:init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6})
	:fillimage(timeDiv10Image)
	:movable(false)
	:active(true)  
	:attach(menuLine1_1Box, -27, 0, 29*5, -14)

divTimeBy10Button.Action = (function()
	return
		function()
			celestia:settimescale(celestia:gettimescale() / 10)
		end
	end) ()
	
-------------------------------------------------
-- Строка пиктограмм
--  "<<"
-- Slowing down 2 times
-- Замедление в 2 раза
-------------------------------------------------
divTimeBy2Button = CXBox:new()
	:init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6})
	:fillimage(timeDiv2Image)
	:movable(false)
	:active(true)  
	:attach(menuLine1_1Box, -27, 0, 29*4, -14) 
	
divTimeBy2Button.Action = (function()
	return
		function()
			celestia:settimescale(celestia:gettimescale() / 2)
		end
	end) ()

-------------------------------------------------
-- Строка пиктограмм 
-- ">"
-- Switching to the normal time mode 1x / Stopping time
-- Переход в нормальный режим времени 1х / Остановка времени 
-------------------------------------------------
realTime2Button = CXBox:new()   
    :bordercolor({0,1,0,0.8})  -- зелёный 
    :fillimage(time1xImage)    
    :visible(true)
    :active(true)    
 	:attach(menuLine1_1Box, -27, 0, 29*3, -14)
	
realTime2Button.Action = (function()
    return
        function()
           display_realTime2 = not display_realTime2
           if display_realTime2 then
               realTimeButton.Bordercolor = {1,0,0,.8}  -- красный		   
               realTime2Button.Bordercolor = {1,0,0,.8}  -- красный
               celestia:settimescale(0)
            else
               realTimeButton.Bordercolor = {0,1,0,.8} -- зелёный 			
               realTime2Button.Bordercolor = {0,1,0,.8} -- зелёный   
               celestia:settimescale(1)        
            end
        end
    end) ()
	
-------------------------------------------------
-- Строка пиктограмм
--  ">>"
-- Acceleration in 2 times
-- Ускорение в 2 раза
-------------------------------------------------
multTimeBy2Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0.2,0.8,1,.6})
	:fillimage(timeMult2Image)
	:movable(false)
	:active(true)  
    :attach(menuLine1_1Box, -27, 0, 29*2, -14)

multTimeBy2Button.Action = (function()
	return
		function()
			celestia:settimescale(celestia:gettimescale() * 2)
			if celestia:gettimescale() >= limitTimerate then
				celestia:settimescale(limitTimerate)
			end
		end
	end) ()
	
-------------------------------------------------
-- Строка пиктограмм
-- ">>>"
-- Acceleration 10 times
-- Ускорение в 10 раз
-------------------------------------------------
multTimeBy10Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0.2,0.8,1,.6})
	:fillimage(timeMult10Image)
	:movable(false)
	:active(true)  
    :attach(menuLine1_1Box, -27, 0, 29*1, -14)

multTimeBy10Button.Action = (function()
	return
		function()
			celestia:settimescale(celestia:gettimescale() * 10)
			if celestia:gettimescale() >= limitTimerate then
				celestia:settimescale(limitTimerate)
			end
		end
	end) ()
	
-------------------------------------------------
-- Строка пиктограмм
--  "Т"
-- Current time
-- Текущее время
-------------------------------------------------
currentTimeButton = CXBox:new()
	:init(0, 0, 0, 0)
    :bordercolor({0,0.2,1,1})
	:fillimage(timeCurImage)
	:movable(false)
	:active(true)  
    :attach(menuLine1_1Box, -27, 0, 29*0, -14)  
	
currentTimeButton.Action = (function()
	return
		function()
			setCurrentTime()
		end
	end) ()	
-------------------------------------------------	
	