---------------------------------------------------
-- menuLine3Box.lua
-- by Gironde 08-04-2017
-- edit Patrick Ziegler a.k.a. Gironde 10-04-2017
-- edit Lygin Gennady a.k.a. Croc 19.08.2018
---------------------------------------------------
require "locale"

menuLine3Box = CXBox:new() -- solarSystemBox ViDiBaBox legendBox renderLocsBox
    :init(0, 0, 0, 0)
    :movable(false)
    :attach(screenBox, width, height, 0, 0)    

--- button's description in menuLine3 --------------

solsysButton = CXBox:new()                 
    :init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6}) 
    :fillcolor(cFrameFill)
    :textfont(smallfont)  
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-3, 10)  
    :text(_("Solar System Browser")) 
    :movable(false)
    :active(true) 
    :attach(menuLine3Box, -99, 0, 102, 0) 

solsysButton.Action = (function()
    return
        function()
            starName = nil;
            solsysFrame.Visible = not(solsysFrame.Visible)
            if solsysFrame.Visible then
                solsysFrame:orderfront()
                solsysButton.Bordercolor = {1,0,0,.6}
            else
                solsysButton.Bordercolor = {0.2,0.8,1,.6}
            end
        end
    end) ()
    
setViDiBaButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10)   
    :text(_("Vi.Di.Ba.")) 
    :movable(false)
    :active(true)   
    :attach(menuLine3Box, -48, 0, 51, 0) 

setViDiBaButton.Action = function()
	ViDiBaFrame.Visible = not(ViDiBaFrame.Visible)
	if ViDiBaFrame.Visible then
		ViDiBaFrame:orderfront()
        setViDiBaButton.Bordercolor = {1,0,0,.6}
	else
		setViDiBaButton.Bordercolor = {0.2,0.8,1,.6}  
	end
end

------------------------------------------------------------------------------------------------------------------------------
-- ObjectVisibilityButton for asteroids and comets managed by Vidiba
-- by P. Ziegler aka Gironde 16-08-2018 
-- edit by Lygin Gennady a.k.a. Croc 27.08.2018
---------------------------------------------
local actualobj
local objname
local ObjNamePrecedClic
local ClicObj = false

ObjectVisibilityButton = CXBox:new()
	:init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6}) 
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor(color2)
    :textpos("center")
    :movetext(-3, 10)
	:text(_(""))-- by Croc
	:movable(false)
    :active(true)
	:attach(menuLine3Box, -48, 0, 0, 0)	

ObjectVisibilityButton.Customdraw = function(this)

	if ClicObj == true then -- ObjectVisibilityButton has been used previously
		actualobj = celestia:find(ObjNamePrecedClic) -- find the previous object
		celestia:select(actualobj) -- and select it again
		objname = actualobj:name()
		ClicObj = false -- clears the history
		ObjNamePrecedClic = "" -- clears the history
	else
	
		-- gets the selection, old or new, to redo the cycle
		actualobj = celestia:getselection() -- get the actual selected object, ObjNamePrecedClic or new
		ObjNamePrecedClic = "" -- clears the history
	end
	
	objclass = actualobj:type ()

	--------------------------------------------------
	if objclass == "asteroid" or objclass == "comet" -- clickable for asteroid and comet and spacecraft
	                          or objclass == "planet" -- by Croc 
							  or objclass == "dwarfplanet" -- by Croc							  
							  or objclass == "moon" -- by Croc
							  or objclass == "minormoon" -- by Croc
	                          or objclass == "spacecraft" 
							  then 
		ObjectVisibilityButton.Active = true
		ObjectVisibilityButton.Textcolor = color4
	elseif objclass == "null" then 
		ObjectVisibilityButton.Active = false 
 		ObjectVisibilityButton.Textcolor = color0 -- by Croc
		ObjectVisibilityButton.Text = "No Object"
	else
		ObjectVisibilityButton.Active = false 
		ObjectVisibilityButton.Textcolor = color2 
	end	
	--------------------------------------------------
	if actualobj:visible() == true then	-- change the function of button
		ObjectVisibilityButton.Text = "Obj.VIEW" -- by Croc
	elseif objclass ~= "null" then
		ObjectVisibilityButton.Text = "Obj.HIDE" -- by Croc
	end
	--------------------------------------------------
end

ObjectVisibilityButton.Action = (function() -- clickable only for asteroid and comet
	return
		function()
			objname = actualobj:name() -- the name of selection in Customdraw
			ClicObj = true
			ObjNamePrecedClic = objname
			
			if actualobj:visible() == true then
				actualobj:setvisible(false)
				actualobj = celestia:find(objname) -- reselectionne l'objet précédent
				celestia:select(actualobj)		-- confirm the selection to avoid the loss of the selection found some times
				ClicObj = true
				ObjNamePrecedClic = objname -- keep the name of the object to be able to recover it in case of loss of the selection
			else
				actualobj:setvisible(true)
				actualobj = celestia:find(objname) -- reselectionne l'objet précédent
				celestia:select(actualobj)		-- confirm the selection to avoid the loss of the selection found some times
				ClicObj = true
				ObjNamePrecedClic = objname
			end
		end
end) ()

-----------------------------------------------------------
