---------------------------------------------------
-- menuLine5Box.lua
-- by Gironde 08-04-2017
-- edit Patrick Ziegler a.k.a. Gironde 10-04-2017
-- edit Lygin Gennady a.k.a. Croc 19.08.2018
---------------------------------------------------
require "locale"

cKeplerParam = ctext -- global variable use here and KeplerParamBox

---------------------------------------------------

menuLine5Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :movable(false)
    :attach(screenBox, width, height, 0, 0)
    
--- button's description in menuLine5 --------------

KeplerParamButton = CXBox:new() -- дополнительная рамка
    :init(0, 0, 0, 0)   
    :bordercolor({0.2,0.8,1,.6})  
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor(cKeplerParam) -- add by Gironde 08-04-2017
    :text(_("Kepler Parameters"))  -- by Croc -- :text(_("Kepler Param."))
    :movetext(6, 10)            -- add by Gironde 08-04-2017
    :movable(false)
    :active(true)  
    :attach(menuLine5Box, -91-8, 0, 96+6, -11)  -- by Croc -- :attach(menuLine5Box, -91, 0, 96, -11)

KeplerParamButton.Customdraw =
    function(this)
            KeplerParamButton.Textcolor = cKeplerParam      -- add by Gironde 08-04-2017
    end

KeplerParamCheck = CXBox:new() -- button box for displays ("" or "o") the frame
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,0.8}) -- color for "o" rot
        :textpos("left")
        :movetext(-2, 11)
        :text("")
        :movable(false)
        :active(true)   
        :attach(KeplerParamButton, 0, 0, 0, 0) 

KeplerParamCheck.Action = (function()
        return
            function()
                display_Kepler_param = not display_Kepler_param
                if display_Kepler_param then
                    KeplerParamFrame.Visible = true                
                    KeplerParamCheck.Text = "o"
                else
                    KeplerParamFrame.Visible = false
                    KeplerParamCheck.Text = ""
                end
            end
        end) ()

-- KeplerParamCheck.Customdraw is in KeplerParamBox

----------------------------------------------------------

LagrangeSwitch = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 10) -- by Croc -- :movetext(0, 10)
    :text(_("Lagrange")) -- by Croc -- :text(_("Lagrange Points"))
    :movable(false)
    :active(true) 
    :attach(menuLine5Box, -48, 0, 51, -11) -- by Croc  -- :attach(menuLine5Box, -93-6, 0, 0, -11)
	
LagrangeSwitch.Action = function(this)
	LagrangeCmd.Visible = not LagrangeCmd.Visible
	if LagrangeCmd.Visible then 
		celestia_save_state() -- global function in LagrangeBox
		celestia_set_state()   -- global function in LagrangeBox
        LagrangeSwitch.Bordercolor={1,0,0,.6}
		LagrangeSwitch.Fillcolor = {cbubordon[1]*2/3, cbubordon[2]*2/3, cbubordon[3]*2/3, cbubordon[4]/2}             
 		LagrangeCmd:orderfront() 
 	else
		celestia_restore_state()   -- global function in LagrangeBox
        LagrangeSwitch.Bordercolor={0.2,0.8,1,.6}
		LagrangeSwitch.Fillcolor = nil
		resetButton.Action()
        celestia:hide("orbits")   -- добавка 19/3/2014
	end
end

-------------------------------------------------------------------

renderLocsButton = CXBox:new() -- transferred from line 2
    :init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(1, 10)   
    :text(_("Location"))
    :movable(false)
    :active(true)   
	:attach(menuLine5Box, -48, 0, 0, -11)
	
renderLocsButton.Action = (function()
    return
        function()
            renderLocsFrame.Visible = not(renderLocsFrame.Visible)
                    if renderLocsFrame.Visible then
                        renderLocsFrame:orderfront()
                        renderLocsButton.Bordercolor = {1,0,0,.6}
                    else
                        renderLocsButton.Bordercolor = {0.2,0.8,1,.6}
                    end
       end
  end) ()

-------------------------------------------------------------




 