--======================================
-- ViDiBaBox.lua
-- clone of addsBox.lua
-- Author - Vincent Giangiulio a.k.a Vincent
-- Edit by Joёl a.k.a Jogad 
-- Integration by Lygin Gennady a.k.a Croc 21.12.2013 и  28.08.2016
-- Edit by Patrick Ziegler a.k.a. Gironde 07-04-2017
--======================================
require "config"
require "locale"
require "closeButton"
require "scrollButton"

----------------------------------------------
-- Set initial values
----------------------------------------------
local newwidth1, newheight1;
local ViDiBa_list_nlines = ViDiBa_list_nlines or 4 
local nViDiBa = table.getn(ViDiBa) 
local nViDiBaLinesMax = math.max(4, math.min(ViDiBa_list_nlines, nViDiBa)) 
local ViDiBaFrameWidth, ViDiBaFrameHeight = 250, 50+ (20 * nViDiBaLinesMax) 
local ViDiBaScrollbarFrameW, ViDiBaScrollbarFrameH = 9, ViDiBaFrameHeight - 50 - 20 
local nViDiBaLines = nViDiBa 
local ViDiBaScroll = 0 
local ViDiBaScrollCoeff = 6 
--local ViDiBaScrollbarBoxH = 0 -- не используется
local ViDiBaLeftOffset= 10 
local ViDiBaAllBox = {} 
local ViDiBaAllCheckBox= {}
local ViDiBaVisible= {} 
local ViDiBaLabelColor = {} 
local ViDiBa_firstTickDone = false   
local ViDiBaCloseButtonDone = false 

-- celestia:setlabelflags{locations = true}   

----------------------------------------------
-- Define local functions -- not used in ViDiBaBox see setVidibaCheckBoxText
----------------------------------------------

local setViDiBaCheckBoxText = function(box, k, flag) 
    if flag then
        box[k].Text = "v"
    else
        box[k].Text = ""
    end
end

----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------

-- comand's button ---------------------------
ViDiBaBox = CXBox:new()                                       
    :init(0, 0, 0, 0)
    --:fillcolor(cFrameFill)
    :movable(false)
    :attach(screenBox, width, height, 0, 0)

-- frame -------------------------------------

ViDiBaFrame = CXBox:new()
    :init(0, 0, 0, 0)
    :fillcolor(csetbofill)
    :bordercolor(cbubordoff)
    :movable(true)
    :visible(false)
    :attach(screenBox, width/2+1, height-ViDiBaFrameHeight-2, width/2-ViDiBaFrameWidth-3, 2)

ViDiBaFrame.Customdraw = function(this)
            textlayout:setfont(normalfont)
            textlayout:setfontcolor({0,1,0,0.8})  
            textlayout:setpos(this.lb+ViDiBaLeftOffset, this.tb-20)
            textlayout:println(_("Vi. Di. Ba. visibility:"))

        if ViDiBa_firstTickDone then 
            if not(ViDiBaCloseButtonDone) then
                ViDiBaCloseButtonDone = true
                makeCloseButton(ViDiBaCloseButton, ViDiBaFrame, setViDiBaButton)
            end
        else
            ViDiBa_firstTickDone = true 
        end
        if newwidth1 ~= width or newheight1 ~= height then
            newwidth1, newheight1 = width, height        
            ViDiBaFrame:attach(screenBox, width/2+1, height-ViDiBaFrameHeight-10, width/2-ViDiBaFrameWidth-3, 10)
        end
    end;
----------------------------------------------

local makeViDiBaBox = function(k, v, ViDiBaLeftOffset, color) 

ViDiBaAllBox[k] = CXBox:new() 
        :init(0, 0, 0, 0)
        --:bordercolor(cbubordoff)
        --:fillcolor({1,1,0,.2})
        :textfont(normalfont)
        :textcolor(color)
        :movetext(0, 8)    
        :text(_(v))
        :movable(false)
        :attach(ViDiBaFrame, ViDiBaLeftOffset+15, ViDiBaFrameHeight-25-(20*k), ViDiBaFrameWidth-ViDiBaLeftOffset-100, 14+(20*k)) 
end

local makeViDiBaCheckBox= function(k, ViDiBaLeftOffset) 
    ViDiBaAllCheckBox[k] = CXBox:new() 
        :init(0, 0, 0, 0)
        :bordercolor(checkBcolor)
        :fillcolor({1,1,0,.2})
        :textfont(smallfont)
        :textcolor(cbutextoff)
        :textpos("center")
        :movetext(0, 10)
        :text("")
        :movable(false)
        :active(true)
        :attach(ViDiBaFrame, ViDiBaLeftOffset, ViDiBaFrameHeight-25-(20*k), ViDiBaFrameWidth-ViDiBaLeftOffset-11+2, 14+(20*k)) 
end

for k, v in ipairs(ViDiBa) do

    if pcall( function() require (v) end ) then
        require(v)

        ViDiBaLabelColor[k] = cbutextoff
        if _G[v].labelcolor then
            ViDiBaLabelColor[k] = _G[v].labelcolor
        end
      
	    makeViDiBaBox(k, string.gsub(v, "_", " "), ViDiBaLeftOffset, ViDiBaLabelColor[k])
        makeViDiBaCheckBox(k, ViDiBaLeftOffset)

        local vv, kk = v, k

        if _G[v].objects then
            ViDiBaVisible[k] = celestia:find(_G[v].objects[1]):visible()
        else
            ViDiBaVisible[k] = false
        end

        ViDiBaAllBox[k].Visible = k <= nViDiBaLinesMax 
        ViDiBaAllCheckBox[k].Visible = k <= nViDiBaLinesMax

        ViDiBaAllCheckBox[k].Customdraw =
            function(this)
	        setViDiBaCheckBoxText(ViDiBaAllCheckBox, kk, ViDiBaVisible[k + ViDiBaScroll])
                ViDiBaAllBox[k].Text = _(string.gsub(ViDiBa[k + ViDiBaScroll], "_", " "))
                ViDiBaAllBox[k].Textcolor = ViDiBaLabelColor[k + ViDiBaScroll]
            end

            ViDiBaAllCheckBox[k].Action = (function()
                return
                    function()
                        local vViDiBaScroll = ViDiBa[k + ViDiBaScroll]
                        ViDiBaVisible[k + ViDiBaScroll] = not(ViDiBaVisible[k + ViDiBaScroll])
                        if _G[vViDiBaScroll].objects then
                            for n, obj in pairs(_G[vViDiBaScroll].objects) do
                                local ViDiBaObj = celestia:find(obj)
                                ViDiBaObj:setvisible(not ViDiBaObj:visible())
                            end
                        end

                        if _G[vViDiBaScroll].locationtypes then
                            for n, loctype in pairs(_G[vViDiBaScroll].locationtypes) do
                                ViDiBaLocType = string.lower(loctype)
                                local obs = celestia:getobserver()
                                local locFlags = obs:getlocationflags()
                                if locFlags[ViDiBaLocType] ~= ViDiBaVisible[k + ViDiBaScroll] then
                                    locFlags[ViDiBaLocType] = ViDiBaVisible[k + ViDiBaScroll]
                                    obs:setlocationflags(locFlags)
                                end
                            end
                        end

                        if _G[vViDiBaScroll].script then
                            local scriptfile = "../ViDiBa/"..vViDiBaScroll.."/".._G[vViDiBaScroll].script
                            celestia:runscript(scriptfile)
                            if _G[vViDiBaScroll].objects then
                               ViDiBaVisible[k + ViDiBaScroll] = celestia:find(_G[vViDiBaScroll].objects[1]):visible()
							   setViDiBaCheckBoxText(ViDiBaAllCheckBox, kk, ViDiBaVisible[k + ViDiBaScroll])
                            end
                        end
                    end
                end) ()
    end
end

----------------------------------------------------------------
ViDiBaScrollbarFrame = CXBox:new()
    :bordercolor(cbubordoff) 
    --:fillcolor({1, 0, 0, 1})
    :visible(nViDiBaLines > nViDiBaLinesMax)
    :attach(ViDiBaFrame, ViDiBaFrameWidth-ViDiBaScrollbarFrameW-3+2, ViDiBaFrameHeight-40-ViDiBaScrollbarFrameH, 3, 40)

ViDiBaScrollbarFrame.Customdraw =
    function(this)
        -- We add the scrollButton on the second tick
        -- when bounds are getting updated.
        if ViDiBaScroll_firstTickDone then
            if not(ViDiBaScrollButtonDone) then
                ViDiBaScrollButtonDone = true
                makeScrollButton(ViDiBaScrollUpButton, ViDiBaScrollDownButton, ViDiBaScrollbarFrame)
            end
        else
            ViDiBaScroll_firstTickDone = true
        end

        local lb3,bb3,rb3,tb3 =ViDiBaScrollbarFrame:bounds()
        local lb4,bb4,rb4,tb4 = ViDiBaScrollbarBox:bounds()
        ViDiBaScroll = math_round((tb3-tb4-3)/ViDiBaScrollCoeff)
        ViDiBaScrollbarFrame:attach(ViDiBaFrame, ViDiBaFrameWidth-ViDiBaScrollbarFrameW-3+2, ViDiBaFrameHeight-40-ViDiBaScrollbarFrameH, 3, 40)
    end

ViDiBaScrollbarBox = CXBox:new()
    :bordercolor(checkBcolor)
    :fillcolor(cscrollfill)
    :visible(true)
    :movable(true)
    :attach(ViDiBaScrollbarFrame, 0, (nViDiBaLines-nViDiBaLinesMax)*ViDiBaScrollCoeff, 0, 3)

------------------------------------------------------------------------------------------------------