----------------------------------------------
-- helpBox.lua
-- Edit by Lygin Gennady a.k.a Croc 18.01.2017
-- Edit by Patrick Ziegler a.k.a. Gironde 07.04.2017
---------------------------------------------
require "locale";
require "closeButton";
----------------------------------------------
-- Set initial values
----------------------------------------------
local newwidth, newheight;
local gn=23
local gg=gn-1
local helpFrameWidth, helpFrameHeight = 186*2, 20*gn+10;
----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------

helpBox = CXBox:new()    
    :init(0, 0, 0, 0)
    :fillcolor(cFrameFill)
    :movable(false)
    :attach(screenBox, width, height, 0, 0)

helpFrame = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(csetbofill)      
    :textfont(normalfont)   
    :textcolor({0.2,0.8,1,1})
    :textpos("center")
    :movetext(0, 5)
    :active(false)
    :text(_("")) 
    :movable(true)
    :clickable(false)    
    :visible(false) 
    :attach(screenBox, (width-helpFrameWidth)/2, height-helpFrameHeight-2, (width-helpFrameWidth)/2, 2)
    
 helpFrame.Customdraw = function(this) 

-- Этих команд нет в графическом интерфейсе Lua Universal Tools:
            textlayout:setfont(normalfont);              
            textlayout:setfontcolor({1,1,0,1}); 
            textlayout:setpos(this.lb+10-5, this.tb-17 - 20*0);       
            textlayout:println(_("These teams do not have a graphical interface Lua Universal Tools:"));  

-- Поисковая система целей:
            textlayout:setfontcolor({0.2,0.8,1,0.7}); 
            textlayout:setpos(this.lb+10, this.tb-22+5 - 20*1); 
            textlayout:println(_("The search engine purposes:")) 

            textlayout:setfontcolor(cbutextoff); 

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*1);
            textlayout:println(_("[Enter] - Login")) 

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*2);
            textlayout:println(_("[Esc]    - Refusal to search")) 

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*3);
            textlayout:println(_("[Enter] - Confirm selection")) 
 
            textlayout:setpos(this.lb+10, this.tb-17 - 20*2); 
            textlayout:println(_("[Tab] - According to the list forward"))

            textlayout:setpos(this.lb+10, this.tb-17 - 20*3); 
            textlayout:println(_("[Shift] + [Tab] - ... or backwards"))

            textlayout:setfontcolor({0,1,0,0.8});
            textlayout:setpos(this.lb+10, this.tb-17 - 20*4); 
            textlayout:println(_("Search deep-sky object in Russian begin with an asterisk *"))

            textlayout:setpos(this.lb+10, this.tb-17 - 20*5); 
            textlayout:println(_("and comment in Russian with the = sign.")) 

-- Фото/Видео: 
            textlayout:setfontcolor({0.2,0.8,1,0.7}); 
            textlayout:setpos(this.lb+10, this.tb-17 - 20*6); 
            textlayout:println(_("Photo/Video:"))

            textlayout:setfontcolor(cbutextoff); 

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*6);
            textlayout:println(_("[ ` ]           -"))
            textlayout:setpos(this.lb+70+50+140, this.tb-17 - 20*6);
            textlayout:println(_("frames/sec")) 

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*7);
            textlayout:println(_("[F11]        -"))
            textlayout:setpos(this.lb+70+50+140, this.tb-17 - 20*7);
            textlayout:println(_("record/pause"))

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*8);
            textlayout:println(_("[F12]        -"))
            textlayout:setpos(this.lb+70+50+140, this.tb-17 - 20*8);
            textlayout:println(_("end record")) 

            textlayout:setpos(this.lb+10, this.tb-17 - 20*7); 
            textlayout:println(_("[F10]               -"))
            textlayout:setpos(this.lb+10+80, this.tb-17 - 20*7); 
            textlayout:println(_("Photo"))          
            
            textlayout:setpos(this.lb+10, this.tb-17 - 20*8);
            textlayout:println(_("[Shift]+[F10]  -"))
            textlayout:setpos(this.lb+10+80, this.tb-17 - 20*8);
            textlayout:println(_("Video"))

-- Мультиэкранный режим:                        
            textlayout:setfontcolor({0.2,0.8,1,0.7});
            textlayout:setpos(this.lb+10, this.tb-17 - 20*9); 
            textlayout:println(_("Multi-Camera mode:")) 

            textlayout:setfontcolor(cbutextoff); 

            textlayout:setpos(this.lb+10, this.tb-17 - 20*10);
            textlayout:println(_("[Ctrl]+[R] -"))
            textlayout:setpos(this.lb+70, this.tb-17 - 20*10);
            textlayout:println(_("windows horizont."))

            textlayout:setpos(this.lb+10, this.tb-17 - 20*11);
            textlayout:println(_("[Ctrl]+[U] -"))
            textlayout:setpos(this.lb+70, this.tb-17 - 20*11);
            textlayout:println(_("windows vertical."))

            textlayout:setpos(this.lb+10, this.tb-17 - 20*12);
            textlayout:println(_("[Tab] -"))
            textlayout:setpos(this.lb+50-5, this.tb-17 - 20*12);
            textlayout:println(_("switching windows"))

            textlayout:setpos(this.lb+10, this.tb-17 - 20*13);
            textlayout:println(_("[Ctrl]+[D] -"))
            textlayout:setpos(this.lb+70, this.tb-17 - 20*13);
            textlayout:println(_("Deleting windows"))            

            textlayout:setpos(this.lb+10, this.tb-17 - 20*14);
            textlayout:println(_("[Del] -"))
            textlayout:setpos(this.lb+50-5, this.tb-17 - 20*14);
            textlayout:println(_("Remove the act. window")) 
         
-- Другие команды:
            textlayout:setfontcolor({0.2,0.8,1,0.7}); 
            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*9);
            textlayout:println(_("Other commands:")) 

            textlayout:setfontcolor(cbutextoff); 

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*10);
            textlayout:println(_("[0] ").._("(Zero) - Nearest star"))

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*11);
            textlayout:println(_("[1]-[9] - ").._("Planets from the star"))

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*12);
            textlayout:println(_("[Ctrl] + [C]  - ").._("Copy URL")) 

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*13);
            textlayout:println(_("[Shift] + [?] - ").._("Lightdelay"))

            textlayout:setpos(this.lb+50+140+10, this.tb-17 - 20*14);
            textlayout:println(_("[Ctrl] + [V]   - ").._("Rendering")) 
------------------------------------------------------------------------------------------------

-- Объявления:          
            textlayout:setfontcolor({0.2,0.8,1,0.7});
            textlayout:setpos(this.lb+10, this.tb-17 - 20*15);
            textlayout:println(_("A complete list of keyboard shortcuts, see Menu (Celestia) / Help"))

            textlayout:setfontcolor({1,0,0,0.8});
            textlayout:setpos(this.lb+10, this.tb-17 - 20*16);
            textlayout:println(_("LUT on/off - [Shift] + [ I ] or left-click near the right edge of the screen")) 

            textlayout:setfontcolor({0.2,0.8,1,0.7});
            textlayout:setpos(this.lb+10, this.tb-17 - 20*21);
            textlayout:println(_("See the manual for that program - Cockpits."))             
-------------------------------------------------------------------------
        
-- Космический полет. Управление. Клавиатурные команды.

            textlayout:setfontcolor({0,1,0,0.8});    
            textlayout:setpos(this.lb+10, this.tb-17 - 20*17);
            textlayout:println(_("Space flight:")) 

            textlayout:setfontcolor(cbutextoff);
            textlayout:setpos(this.lb+10, this.tb-17 - 20*18);
            textlayout:println(_("                                    - [Shift]+[W]"))

            textlayout:setfontcolor({1,1,0,0.8});             
            textlayout:setpos(this.lb+10, this.tb-17 - 20*18);
            textlayout:println(_("Hide/show cabin"))

            textlayout:setfontcolor(cbutextoff);
            textlayout:setpos(this.lb+10, this.tb-17 - 20*19);
            textlayout:println(_("                                    - [Shift]+ [R]")) 

            textlayout:setfontcolor({1,1,0,0.8});
            textlayout:setpos(this.lb+10, this.tb-17 - 20*19);
            textlayout:println(_("Back view"))

            textlayout:setfontcolor(cbutextoff);
            textlayout:setpos(this.lb+10, this.tb-17 - 20*20);
            textlayout:println(_("                                                  - [X]"))
        
            textlayout:setfontcolor({1,1,0,0.8});
            textlayout:setpos(this.lb+10, this.tb-17 - 20*20);
            textlayout:println(_("Motion to current view"))   

            textlayout:setfontcolor(cbutextoff);
            textlayout:setpos(this.lb+10+190, this.tb-17 - 20*18);
            textlayout:println(_("                                                - [Q]"))          

            textlayout:setfontcolor({1,1,0,0.8});
            textlayout:setpos(this.lb+10+190, this.tb-17 - 20*18);
            textlayout:println(_("Motion back"))

            textlayout:setfontcolor(cbutextoff);
            textlayout:setpos(this.lb+10+190, this.tb-17 - 20*19);
            textlayout:println(_("                                                - [W]"))           

            textlayout:setfontcolor({1,1,0,0.8});
            textlayout:setpos(this.lb+10+190, this.tb-17 - 20*19);
            textlayout:println(_("Move forward to a cabin"))

            textlayout:setfontcolor(cbutextoff);
            textlayout:setpos(this.lb+10+190, this.tb-17 - 20*20);
            textlayout:println(_("                                    - [Shift]+[T]"))

            textlayout:setfontcolor({1,1,0,0.8});  
            textlayout:setpos(this.lb+10+190, this.tb-17 - 20*20);
            textlayout:println(_("Motion. Look guide"))
--------------------------------------------------------------
            textlayout:setfontcolor(cbutextoff);
            textlayout:setpos(this.lb+10, this.tb-17 - 20*22);
            textlayout:println(_("Current screen size: width / height -")..width.." x "..height.." pix.")
---------------------------------------------------------------------------------
 
           if newwidth ~= width or newheight ~= height then
                    newwidth, newheight = width, height;               
                    helpFrame:attach(screenBox, width-helpFrameWidth-35, height-helpFrameHeight-128-35, 35, 128+35 )           
            end  
              
end;

