--------------------------------------------------------
-- liftBox.lua
-- by Lygin Gennady a.k.a Croc 04.09.2016
-- Edit by Patrick Ziegler a.k.a. Gironde 07.04.2017
--------------------------------------------------------

require "locale";
require "closeButton";

----------------------------------------------
-- Set initial values
----------------------------------------------
local obs = celestia:getobserver();
local newwidth, newheight;
local gn=5
local gg=gn-1
local liftFrameWidth, liftFrameHeight = 186, 17*gn+3;

----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------


liftBox = CXBox:new()    
    :init(0, 0, 0, 0)
    --:bordercolor({0.2,0.8,1,.6})
    :fillcolor(cFrameFill)
    :movable(false)
    :attach(screenBox, width, height, 0, 0)

--[[
-- command's button ----------------------------------------------------
liftButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({0,1,1,0.8})
    :textpos("lift")    
    :movetext(0, 10)  
    :text(_("Lift"))
    :movable(false)
    :active(true)  
    :attach(menuLine4Box, -44, 0, 49, 0) -- -44, 0 ,49 ,0

liftButton.Action = (function()
        return
            function()
              display_lift = not display_lift;
                if display_lift then                
                   liftFrame.Visible = true; 
                   liftButton.Bordercolor = {1,0,0,.5}                     
                else          
                   liftFrame.Visible = false; 
                    liftButton.Bordercolor = {0.2,0.8,1,.6}              
                end
            end
        end) ()
]]

-- frame --------------------------------------------------

liftFrame = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,1,0,.8}) 
    :fillcolor(csetbofill)
    :textfont(normalfont)   
    :textcolor({0,1,0,.8})
    :textpos("center")
    :movetext(0, 5)
    :active(false)
    :text(_("Space lift:")) 
    :movable(true)
    :clickable(false)    
    :visible(false)
    :attach(screenBox, (width-liftFrameWidth)/2, height-liftFrameHeight-2, (width-liftFrameWidth)/2, 2)

closeliftButton = CXBox:new()
        :init(0, 0, 0, 0) 
        :textfont(smallfont)
        :textcolor({1,0,0,0.5})
        :textpos("center")
        :movetext(0, 12)
        :text("x")
        :movable(false)
        :active(true)
        :attach(liftFrame, 170, 75, 2, 2);

closeliftButton.Action = (function()
        return
            function()   
             display_lift = not display_lift;
                if liftFrame.Visible then                   
                    liftFrame.Visible = false;                                  
                    liftCheck.Text = "";             
                end             
           end
      end) ();

 liftFrame.Customdraw = function(this) 

            if newwidth ~= width or newheight ~= height then
                    newwidth, newheight = width, height;            
                    liftFrame:attach(screenBox, width-liftFrameWidth-35,  height-liftFrameHeight-590, 35, 590)                 
            end                
end;

-- Подключение команд 
-- ===============
-- 1-01 
-- ===============
lift101Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0.2,0.8,1,1})
    :textpos("left")    
    :movetext(-2, 8)
    :text(_(" 1"))
    :movable(false)
    :active(true)
    :attach( liftFrame, 3+20*0, 2+17*(gg-1), 186-3-20*1, 3+17*1)

lift101Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station01");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 1-02 
-- ===============
lift102Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_(" 2"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*1, 2+17*(gg-1), 186-3-20*2, 3+17*1)

lift102Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station02");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 1-03 
-- ===============
lift103Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_(" 3"))
    :movable(false)
    :active(true)   
    :attach( liftFrame, 3+20*2, 2+17*(gg-1), 186-3-20*3, 3+17*1)

lift103Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station03");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 1-04 
-- ===============
lift104Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_(" 4"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*3, 2+17*(gg-1), 186-3-20*4, 3+17*1)

lift104Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station04");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 1-05
-- ===============
lift105Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_(" 5"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*4, 2+17*(gg-1), 186-3-20*5, 3+17*1)

lift105Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station05");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 1-06 
-- ===============
lift106Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_(" 6"))
    :movable(false)
    :active(true)   
    :attach( liftFrame, 3+20*5, 2+17*(gg-1), 186-3-20*6, 3+17*1)

lift106Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station06");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 1-07
-- ===============
lift107Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)

    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_(" 7"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*6, 2+17*(gg-1), 186-3-20*7, 3+17*1)

lift107Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station07");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 1-08
-- ===============
lift108Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_(" 8"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*7, 2+17*(gg-1), 186-3-20*8, 3+17*1)

lift108Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station08");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 1-09
-- ===============
lift109Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_(" 9"))
    :movable(false)
    :active(true)  
    :attach( liftFrame, 3+20*8, 2+17*(gg-1), 186-3-20*9, 3+17*1)

lift109Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station09");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 2-10 
-- ===============
lift210Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("10"))
    :movable(false)
    :active(true)     
    :attach( liftFrame, 3+20*0, 2+17*(gg-2), 186-3-20*1, 3+17*2)

lift210Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station10");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 2-11 
-- ===============
lift211Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_("11"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*1, 2+17*(gg-2), 186-3-20*2, 3+17*2)

lift211Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station11");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 2-12 
-- ===============
lift212Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("12"))
    :movable(false)
    :active(true)   
    :attach( liftFrame, 3+20*2, 2+17*(gg-2), 186-3-20*3, 3+17*2)

lift212Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station12");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 2-13 
-- ===============
lift213Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("13"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*3, 2+17*(gg-2), 186-3-20*4, 3+17*2)

lift213Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station13");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 2-14
-- ===============
lift214Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_("14"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*4, 2+17*(gg-2), 186-3-20*5, 3+17*2)

lift214Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station14");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 2-15 
-- ===============
lift215Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("15"))
    :movable(false)
    :active(true)   
    :attach( liftFrame, 3+20*5, 2+17*(gg-2), 186-3-20*6, 3+17*2)

lift215Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station15");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 2-16
-- ===============
lift216Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("16"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*6, 2+17*(gg-2), 186-3-20*7, 3+17*2)

lift216Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station16");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 2-17
-- ===============
lift217Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_("17"))
    :movable(false)
    :active(true)     
    :attach( liftFrame, 3+20*7, 2+17*(gg-2), 186-3-20*8, 3+17*2)

lift217Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station17");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 2-18
-- ===============
lift218Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("18"))
    :movable(false)
    :active(true)  
    :attach( liftFrame, 3+20*8, 2+17*(gg-2), 186-3-20*9, 3+17*2)

lift218Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station18");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 3-19 
-- ===============
lift319Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
   -- :fillcolor({1,1,0,.2})
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("19"))
    :movable(false)
    :active(true)     
   :attach( liftFrame, 3+20*0, 2+17*(gg-3), 186-3-20*1, 3+17*3)

lift319Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station19");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 3-20 
-- ===============
lift320Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_("20"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*1, 2+17*(gg-3), 186-3-20*2, 3+17*3)

lift320Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station20");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 3-21 
-- ===============
lift321Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("21"))
    :movable(false)
    :active(true)   
    :attach( liftFrame, 3+20*2, 2+17*(gg-3), 186-3-20*3, 3+17*3)

lift321Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station21");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 3-22 
-- ===============
lift322Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("22"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*3, 2+17*(gg-3), 186-3-20*4, 3+17*3)

lift322Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station22");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 3-23
-- ===============
lift323Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_("23"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*4, 2+17*(gg-3), 186-3-20*5, 3+17*3)

lift323Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station23");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 3-24 
-- ===============
lift324Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("24"))
    :movable(false)
    :active(true)   
    :attach( liftFrame, 3+20*5, 2+17*(gg-3), 186-3-20*6, 3+17*3)

lift324Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station24");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 3-25
-- ===============
lift325Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("25"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*6, 2+17*(gg-3), 186-3-20*7, 3+17*3)

lift325Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station25");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 3-26
-- ===============
lift326Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_("26"))
    :movable(false)
    :active(true)     
    :attach( liftFrame, 3+20*7, 2+17*(gg-3), 186-3-20*8, 3+17*3)

lift326Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station26");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 3-27
-- ===============
lift327Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("27"))
    :movable(false)
    :active(true)  
    :attach( liftFrame, 3+20*8, 2+17*(gg-3), 186-3-20*9, 3+17*3)

lift327Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station27");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 4-28 
-- ===============
lift428Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("28"))
    :movable(false)
    :active(true)     
    :attach( liftFrame, 3+20*0, 2+17*(gg-4), 186-3-20*1, 3+17*4)

lift428Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station28");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 4-29 
-- ===============
lift429Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_("29"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*1, 2+17*(gg-4), 186-3-20*2, 3+17*4)

lift429Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station29");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 4-30
-- ===============
lift430Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("30"))
    :movable(false)
    :active(true)   
    :attach( liftFrame, 3+20*2, 2+17*(gg-4), 186-3-20*3, 3+17*4)

lift430Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station30");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 4-31 
-- ===============
lift431Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("31"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*3, 2+17*(gg-4), 186-3-20*4, 3+17*4)

lift431Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station31");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 4-32
-- ===============
lift432Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_("32"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*4, 2+17*(gg-4), 186-3-20*5, 3+17*4)

lift432Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station32");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 4-33 
-- ===============
lift433Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    --:fillcolor({1,1,0,.2})
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("33"))
    :movable(false)
    :active(true)   
    :attach( liftFrame, 3+20*5, 2+17*(gg-4), 186-3-20*6, 3+17*4)

lift433Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station33");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 4-34
-- ===============
lift434Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("34"))
    :movable(false)
    :active(true)    
    :attach( liftFrame, 3+20*6, 2+17*(gg-4), 186-3-20*7, 3+17*4)

lift434Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station34");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 4-35
-- ===============
lift435Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-2, 8)
    :text(_("35"))
    :movable(false)
    :active(true)     
    :attach( liftFrame, 3+20*7, 2+17*(gg-4), 186-3-20*8, 3+17*4)

lift435Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/station35");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();
-- ===============
-- 4-36
-- ===============
lift436Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.7})
    :textpos("center")    
    :movetext(-3, 8)
    :text(_("36"))
    :movable(false)
    :active(true)  
    :attach( liftFrame, 3+20*8, 2+17*(gg-4), 186-3-20*9, 3+17*4)

lift436Box.Action = (function()
    return 
        function()      
            local obj = celestia:find("Sol/Earth/Orbital station");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) ();