--------------------------------------------------------
-- panel1Box.lua
-- Author panel - Lygin Gennady a.k.a Croc
-- Author of tools - Vincent Giangiulio a.k.a Vincent
-- Edit by Lygin Gennady a.k.a Croc 05.03.2015
-- Integration by Lygin Gennady a.k.a Croc 30.08.2016
--------------------------------------------------------

----------------------------------------------
-- Панель # 1 Космическая навигация
----------------------------------------------

require "locale";                                                 
require "closeButton";
----------------------------------------------
-- Set initial values
----------------------------------------------
local gn=10
local gg=gn-1
local obs = celestia:getobserver();
local newwidth, newheight;
local panel1FrameWidth, panel1FrameHeight = 186, 173;

----------------------------------------------
-- Define local function
----------------------------------------------
local getObsMode = function(o)
    local obsCoordSys = o:getframe():getcoordinatesystem();
    local obj = o:getframe():getrefobject();
    return obsCoordSys, obj;
end

local getTrackedObjName = function()
    if not (empty(trackedObj)) then
        trackedObjName = getlocalname(trackedObj);
    else
        trackedObjName = nil;
    end
    return trackedObjName;
end
local uly_to_km = 9460730.4725808
----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------
panel1Box = CXBox:new()    
      :init(0, 0, 0, 0)
      :movable(false)
      :attach(screenBox, width, height, 0, 0);

panel1Frame = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.8}) 
    :fillcolor(csetbofill) 
    :textfont(normalfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("center")
    :movetext(0, 5)
    :active(false)
    :text(_("Space navigation:"))
    :movable(true)
    :clickable(false)    
    :visible(false)
    :attach(screenBox, (width-panel1FrameWidth)/2, height-panel1FrameHeight-2, (width-panel1FrameWidth)/2, 2)  

closepanel1Button = CXBox:new()
        :init(0, 0, 0, 0) 
        :textfont(smallfont)
        :textcolor({1,0,0,0.5})
        :textpos("left")
        :movetext(1, 12)
        :text("x")
        :movable(false)
        :active(true)
        :attach(panel1Frame, 172, 160, 2, 2);

    closepanel1Button.Action = (function()
        return
            function()   
             display_panel1 = not display_panel1;
                if panel1Frame.Visible then 
                    panel1Frame.Visible = false;				
                    panelAll21Check.Text = "";                             
                end             
           end
      end) (); 	 
 
panel1Frame.Customdraw = function(this)  
       if newwidth ~= width or newheight ~= height then
       newwidth, newheight = width, height;

       if width >=1280 then               
           panel1Frame:attach(screenBox, (width-panel1FrameWidth)/2-541, 3, (width-panel1FrameWidth)/2+541, height-panel1FrameHeight-3) 
        else
          if width>=900  then
              panel1Frame:attach(screenBox, 6, 180, width-panel1FrameWidth-6, height-panel1FrameHeight-180) 
          else
              panel1Frame:attach(screenBox, 6, 361+9-13, width-panel1FrameWidth-6, height-panel1FrameHeight-361-9+13)
          end
       end
    end
end;

--===================
panel113Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({1,1,0,1})
    :textpos("left") 
    :movetext(-2, 8)  
    :text(_("Sol "))
    :movable(false)
    :active(true)  
    :attach( panel1Frame, 3, 3+17*6, 135, 3+17*3)

panel113Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local obj = celestia:find("Sol");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
--------------------------------------
panel114Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({1,1,0,1})      
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("Milky Way"))
    :movable(false)
    :active(true)  
    :attach( panel1Frame, 3, 3+17*5, 91, 3+17*4)

panel114Button.Action = (function()
    return 
        function()      
            local obj = celestia:find("Milky Way");           
            celestia:select(obj); 
            if not(empty(obj)) then
                obs:follow(obj);
                obs:goto(obj); 
            end
        end
    end) (); 
-------------------------------------------------
trackButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0,1,0,0.8})
    :textpos("left")
    :movetext(-3, 8)
    :text(_("Track"))
    :movable(false)
    :active(true)  
    :attach(panel1Frame,  3, 3+17*4, 135, 3+17*5) 

trackButton.Customdraw =
    function(this)
        local obs = celestia:getobserver();
        trackedObj = obs:gettrackedobject();
        trackedObjName = getTrackedObjName();
        if not(empty(trackedObj)) then
            trackButton.Bordercolor = cbubordon;
          --  trackButton.Fillcolor = {cbubordon[1]*2/3, cbubordon[2]*2/3, cbubordon[3]*2/3, cbubordon[4]/2};
        else
            trackButton.Bordercolor = cbubordoff;
          --  trackButton.Fillcolor = nil;
        end
    end;

trackButton.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local sel = celestia:getselection();
            if not(empty(trackedObj)) or (empty(trackedObj) and empty(sel)) then
                -- Stop tracking the current tracked object.
                obs:track(nil);
            else
                -- Track the current selection.
                obs:track(sel);
            end
        end
    end) ();
-------------------------------------
panel116Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0,1,0,0.8})
    :textpos("left")    
    :movetext(-3, 8)
    :text(_("Follow"))  -- Наблюдение
    :movable(false)
    :active(true)     
   :attach(panel1Frame, 3, 3+17*3, 135, 3+17*6) 

panel116Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local sel = celestia:getselection();
            if not(empty(sel)) then
                obs:follow(sel);
            end
        end
    end) ();
-------------------------------------
panel117Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0,1,0,1})
    :textpos("left")    
    :movetext(-3, 8)
    :text(_("Synchron."))  -- Синхронное вращение
    :movable(false)
    :active(true)     
   :attach(panel1Frame, 3, 3+17*2, 135, 3+17*7) 

panel117Button.Action = (function()
    return
        function()
            celestia:hide("boundaries");
            local obs = celestia:getobserver();
            local sel = celestia:getselection();
            if selection then
                obs:synchronous(sel);
            end
        end
    end) ();
--------------------------------------
panel118Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont) 
    :textcolor({0,1,0,1})
    :textpos("left")    
    :movetext(-3, 8)
    :text(_("Chase "))  -- Сопровождение
    :movable(false)
    :active(true)     
   :attach(panel1Frame, 3, 3+17*1, 135, 3+17*8) 

panel118Button.Action =  (function()
return
function()
     local obs = celestia:getobserver()
     local sel = celestia:getselection()
         if not(empty(sel)) then
            obs:chase(sel)
         end
     end
end) ();
--------------------------------------
panel119Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0,1,0,1})
    :textpos("left")    
    :movetext(-3, 8)
    :text(_("Lock"))   -- захват
    :movable(false)
    :active(true)     
   :attach(panel1Frame, 3, 3+17*0, 135, 3+17*9) 

panel119Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local sel = celestia:getselection();
            if selection then
                obs:lock(sel);
            end
        end
    end) ();
-- =====================
panel123Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})  
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("Mercury"))
    :movable(false)
    :active(true)  
    :attach( panel1Frame, 53, 3+17*6, 91, 3+17*3)

panel123Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local obj = celestia:find("Sol");
            celestia:select(obj);
            obs:follow(obj);  
            local obj = celestia:find("Mercury");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
-----------------------------------------
panel125Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0,1,0,1})   
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("> center"))
    :movable(false)
    :active(true)  
    :attach( panel1Frame, 53, 3+17*4, 91, 3+17*5)

panel125Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local sel = celestia:getselection();
            if not(empty(sel)) then
                obs:follow(sel);
                obs:center(sel);
            end
        end
    end) (); 
-------------------------------------
panel126Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0,1,0,1}) 
    :textpos("left")
    :movetext(-2, 8) 
    :text(_("Go To"))
    :movable(false)
    :active(true)  
    :attach( panel1Frame, 53, 3+17*3, 91, 3+17*6)

panel126Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local sel = celestia:getselection();
            if not(empty(sel)) then
                obs:follow(sel);
                obs:goto(sel);
            end
        end
    end) (); 

-- ================
-- cross
-- ================
crossButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({0,1,0,1}) 
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("cross"))
    :movable(false)
    :active(true) 
    :attach( panel1Frame, 53, 3+17*2, 91, 3+17*7)

crossButton.Customdraw = function(this)             
         
	    textlayout:setfont(normalfont);
            textlayout:setfontcolor({1,0,0,0.8});        
	    textlayout:setpos(this.lb+33, this.tb-10);       
            textlayout:println(_("|"));
            textlayout:setpos(this.lb+30, this.tb-9);       
            textlayout:println(_("---"));

end;

crossButton.Action = (function()
        return
            function()
              display_cross = not display_cross;
                if display_cross then
                    visorFrame.Visible = true;
                else 
                    visorFrame.Visible = false;     
                end
            end
        end) ();

-------------------------------------
panel128Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({1,0,1,1})
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("Avatar"))
    :movable(false)
    :active(true)     
    :attach( panel1Frame, 53, 3+17*1, 91, 3+17*8)

panel128Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local obj = celestia:find("Avatar");
            celestia:select(obj);
            obs:follow(obj);          
            obs:goto(obj); 
        end
    end) ();  
-------------------------------------
panel129Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({1,0,1,1})
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("TOR"))
    :movable(false)
    :active(true)  
    :attach( panel1Frame, 53, 3+17*0, 91, 3+17*9)

panel129Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();           
            local obj = celestia:find("Sol/TOR");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
-- ===================
panel133Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})   
    :textpos("left")    
    :movetext(-2, 8)
    :text(_("Venus"))
    :movable(false)
    :active(true)   
    :attach( panel1Frame, 97, 3+17*6, 47, 3+17*3)

panel133Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();           
            local obj = celestia:find("Venus");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
--------------------------------------
panel114Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont) 
    :textcolor({1,1,1,1})   
    :textpos("left")    
    :movetext(-2, 8)
    :text(_("Moon"))
    :movable(false)
    :active(true)     
   :attach(panel1Frame, 97, 3+17*5, 47, 3+17*4) 

panel114Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local obj = celestia:find("Moon");          
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
--------------------------------------
panel135Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({1,1,1,0.4})  
    :textpos("left")    
    :movetext(-2, 8)
    :text(_("Ceres"))
    :movable(false)
    :active(true)   
    :attach( panel1Frame, 97, 3+17*4, 47, 3+17*5)

panel135Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();           
            local obj = celestia:find("Ceres");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
--------------------------------------
panel136Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({1,1,1,0.4}) 
    :textpos("left")    
    :movetext(-2, 8)
    :text(_("Pluto"))
    :movable(false)
    :active(true)   
    :attach( panel1Frame, 97, 3+17*3, 47, 3+17*6)

panel136Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();           
            local obj = celestia:find("Pluto");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
--------------------------------------
panel137Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({1,1,1,0.4})  
    :textpos("left")    
    :movetext(-2, 8)
    :text(_("Haumea"))
    :movable(false)
    :active(true)   
    :attach( panel1Frame, 97, 3+17*2, 47, 3+17*7)

panel137Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();           
            local obj = celestia:find("Haumea");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
--------------------------------------
panel138Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({1,1,1,0.4})   
    :textpos("left")    
    :movetext(-2, 8)
    :text(_("Makem."))
    :movable(false)
    :active(true)   
    :attach( panel1Frame, 97, 3+17*1, 47, 3+17*8)

panel138Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();           
            local obj = celestia:find("Makemake");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
--------------------------------------
panel139Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({1,1,1,0.4}) 
    :textpos("left")    
    :movetext(-2, 8)
    :text(_("Eris"))
    :movable(false)
    :active(true)   
    :attach( panel1Frame, 97, 3+17*0, 47, 3+17*9)

panel139Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();           
            local obj = celestia:find("Eris");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();

-- ===================
panel143Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})   
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("Earth"))
    :movable(false)
    :active(true)      
    :attach( panel1Frame, 141, 3+17*6, 3, 3+17*3)

panel143Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local obj = celestia:find("Earth");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj);
        end
    end) ();
--------------------------------------
panel144Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("Mars"))
    :movable(false)
    :active(true)      
    :attach( panel1Frame, 141, 3+17*5, 3, 3+17*4)

panel144Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local obj = celestia:find("Mars");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
-------------------------------------
panel145Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("Jupiter"))
    :movable(false)
    :active(true)      
    :attach( panel1Frame, 141, 3+17*4, 3, 3+17*5)

panel145Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local obj = celestia:find("Jupiter");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
-------------------------------------
panel146Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("Saturn"))
    :movable(false)
    :active(true)      
    :attach( panel1Frame, 141, 3+17*3, 3, 3+17*6)

panel146Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local obj = celestia:find("Saturn");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
-------------------------------------
panel147Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("Uranus"))
    :movable(false)
    :active(true)      
    :attach( panel1Frame, 141, 3+17*2, 3, 3+17*7)

 panel147Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local obj = celestia:find("Uranus");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
-------------------------------------
panel148Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("Neptune"))
    :movable(false)
    :active(true)      
    :attach( panel1Frame, 141, 3+17*1, 3, 3+17*8)

panel148Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
            local obj = celestia:find("Neptune");
            celestia:select(obj);
            obs:follow(obj);          
            obs:center(obj); 
        end
    end) ();
-------------------------------------
panel149Button = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill) 
    :textfont(smallfont)
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-2, 8)  
    :text(_("Nine"))
    :movable(false)
    :active(true)      
    :attach( panel1Frame, 141, 3+17*0, 3, 3+17*9)

panel149Button.Action = (function()
    return
        function()
            local obs = celestia:getobserver();
          --  local obj = celestia:find("Planet Nine");
          --  celestia:select(obj);
          --  obs:follow(obj);          
          --  obs:center(obj); 
        end
    end) ();
-- =============================
-- Рамка для дисплея Космической навигации
-- =============================
navigationFrame = CXBox:new()
   :init(0, 0, 0, 0)
   :bordercolor(cbubordoff) 
   :fillcolor({0.2,0.5,1,.3})  
   :textfont(normalfont)
   :textcolor({1,0,0,1})
   :textpos("center")
   :movetext(0, 6-1)
   :text(_(""))
   :movable(false)
   --:active(true)
   :attach( panel1Frame, 3, 3+2+17*7, 3, 3+17*1)

navigationFrame.Customdraw =

    function(this)
        -- Display the observer Frame of reference.

        local obs = celestia:getobserver();
        local obsCoordSys, obj = getObsMode(obs);
        if not(empty(obj)) then
            objname = getlocalname(obj);

            if obsCoordSys == "ecliptic" then
                obsMode = _("Follow ")..objname;       -- наблюдение

            elseif obsCoordSys == "planetographic" or obsCoordSys == "bodyfixed" then
                obsMode = _("Sync Orbit ")..objname;   -- синхронное вращение

            elseif obsCoordSys == "chase" then
                obsMode = _("Chase ")..objname;        -- сопровождение

            elseif obsCoordSys == "lock" then
                obsMode = _("Lock ")..objname..' -> '..getlocalname(obs:getframe():gettargetobject());

            else
                obsMode = _("Free flight");           -- свободный полёт
            end
        
        else
                obsMode = _("Free flight");           -- свободный полёт
        end
 
        textlayout:setfont(normalfont);
        textlayout:setfontcolor(ctext);

if trackedObjName then
            textlayout:setfontcolor({1,0,0,0.99});         
            textlayout:setpos(this.lb + 4, this.tb - 25);
            textlayout:println(_("Track ")..trackedObjName); 

        end
           textlayout:setfontcolor({0,1,0,0.99});         
           textlayout:setpos(this.lb + 4, this.tb - 12);
           textlayout:println(obsMode);    
    end;
--------------------------------------------------
