----------------------------------------------------------------
-- panel2Box.lua
-- Author panel - Lygin Gennady a.k.a Croc
-- Author of tools - Vincent Giangiulio a.k.a Vincent
-- Edit by Lygin Gennady a.k.a Croc 13.01.2017
-- Integration by Lygin Gennady a.k.a Croc 30.08.2016
----------------------------------------------------------------
require "locale";                                                 
require "closeButton";
------------------------------------
-- Set initial values
-----------------------------------
local gn=10
local gg=gn-1

local newwidth, newheight;
local panel2FrameWidth, panel2FrameHeight = 186, 173;

-----------------------------------
-- Set up and Draw the boxes
-----------------------------------
panel2Box = CXBox:new()    
      :init(0, 0, 0, 0)
      :movable(false)
      :attach(screenBox, width, height, 0, 0);

panel2Frame = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.8})
    :fillcolor(csetbofill)
    :textfont(titlefont)
    :textcolor({0.8, 0.8, 0.8, 0.9})
    :textpos("center")
    :movetext(0, -10)
    :movable(true)
    :clickable(false)    
    :visible(false)
    :attach(screenBox, (width-panel2FrameWidth)/2, height-panel2FrameHeight-2, (width-panel2FrameWidth)/2, 2) 

closepanel2Button = CXBox:new()
        :init(0, 0, 0, 0) 
       :textfont(smallfont)
        :textcolor({1,0,0,0.5})
        :textpos("left")
        :movetext(1, 12)
        :text("x")
        :movable(false)
        :active(true)
        :attach(panel2Frame, 172, 160, 2, 2);

    closepanel2Button.Action = (function()
        return
            function() 
            display_panel2 = not display_panel2;
                if panel2Frame.Visible then                   
                    panel2Frame.Visible = false;                                 
                      panelAll22Check.Text = "";  
                end             
           end
end) ();

panel2Frame.Customdraw = function(this)  
       if newwidth ~= width or newheight ~= height then
       newwidth, newheight = width, height;

       if width >=1280 then 
         panel2Frame:attach(screenBox, (width-panel2FrameWidth)/2-351, 3, (width-panel2FrameWidth)/2+351, height-panel2FrameHeight-3)
       else
          if width>=900  then
             panel2Frame:attach(screenBox, 6, 3, width-panel2FrameWidth-6, height-panel2FrameHeight-3)
          else
             panel2Frame:attach(screenBox, 6, 180, width-panel2FrameWidth-6, height-panel2FrameHeight-180)
          end
       end
    end

           textlayout:setfont(normalfont);
           textlayout:setfontcolor({0.2,0.8,1,1});
           textlayout:setpos(this.lb + 3+10+5, this.tb - 14+1);
           textlayout:println(_(" Objects  /"));          

           textlayout:setfontcolor(cbutextoff);
           textlayout:setpos(this.lb + 52+15+5, this.tb - 14+1);
           textlayout:println(_(" Orbits  /"));          

           textlayout:setfontcolor({1,1,0,0.8});
           textlayout:setpos(this.lb +101+10+5+3, this.tb - 14+1);
           textlayout:println(_(" Other :")); 
end;

-- ====================
-- 11 Звезды-объект 
-- ====================
starsObjectButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(normalfont)
        :textcolor({0,1,1,.8})       
        :textpos("Left")
        :movetext(10+5, 7)
        :text(_("STARS"))
        :movable(false)
        :active(true)      
       :attach(panel2Frame, 3, 2+17*(gg-1), 95, 3+17*1)

starsObjectCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(0, 9)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 3, 2+17*(gg-1), 95+75, 3+17*1)

starsObjectButton.Action = (function()
        return
            function()
              display_starsObject = not display_starsObject;
                if display_starsObject then
                    celestia:show("stars");
                    celestia:setstarstyle("disc")  
                    starsObjectCheck.Text = "|||";
                else 
                    celestia:hide("stars");
                    starsObjectCheck.Text = "";
                end
            end
        end) ();

-- ================
-- 12 Звезды/имена звёзд
-- ================
starsButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor(cbutextoff)    
        :textpos("Left")
        :movetext(-1, 7)
        :text(_("Stars"))
        :movable(false)
        :active(true)      
        :attach(panel2Frame, 33, 2+17*(gg-2), 95, 3+17*2)

starsCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 33+2, 2+17*(gg-2), 95+50, 3+17*2)

starsButton.Action = (function()
        return
            function()
              display_stars = not display_stars;
                if display_stars then                 
                    celestia:setorbitflags{Star = true}             
                    starsCheck.Text =  "|";
                else 
                    celestia:setorbitflags{Star = false}                  
                    starsCheck.Text = "";
                end
            end
        end) ();
----
starsNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})        
        :textpos("Left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)   
        :attach(panel2Frame, 3, 2+17*(gg-2), 155, 3+17*2) 

starsNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 3+2, 2+17*(gg-2), 155+20, 3+17*2)

starsNButton.Action = (function()
        return
            function()
              display_starsN = not display_starsN;
                if display_starsN then  
                     celestia:setlabelflags{stars = true}             
                     starsNCheck.Text =  "|";
                else 
                     celestia:setlabelflags{stars = false}    
                     starsNCheck.Text = "";
                end
            end
        end) ();

-- ===========================
-- 13 Созвездия на русском и на латинском 
-- ===========================
constellationsNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})    
        :textpos("Left")
        :movetext(-1, 7)
        :text(_("Constelat."))
        :movable(false)
        :active(true)      
       :attach(panel2Frame, 33, 2+17*(gg-3), 95, 3+17*3)

constellationsNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 33+2, 2+17*(gg-3), 95+50, 3+17*3)

constellationsNButton.Action = (function()
        return
            function()
              display_constellationsN = not display_constellationsN;
                if display_constellationsN then                   
                    celestia:showlabel("constellations")
                    constellationsNCheck.Text =   "|";
                else                    
                    celestia:hidelabel("constellations")
                    constellationsNCheck.Text = "";
                end
            end
        end) ();
---------------
constellationsNLButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})    
        :textpos("Left")
        :movetext(-2, 7)     
        :text(_("Latin"))
        :movable(false)
        :active(true)    
        :attach(panel2Frame, 3, 2+17*(gg-3), 155, 3+17*3)

constellationsNLCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)
        :attach(panel2Frame, 3+2, 2+17*(gg-3), 155+20, 3+17*3)

constellationsNLButton.Action = (function()
        return
            function()
                display_constellationsNL = not display_constellationsNL;             
                if display_constellationsNL then               
                    celestia:hidelabel("i18nconstellations") 
                    constellationsNLCheck.Text =  "|";
                else                 
                    celestia:showlabel("i18nconstellations") 
                    constellationsNLCheck.Text = "";
                end
            end
        end) ();

-- ======================
-- 14 Границы -- работает  /Фигуры 
-- ======================
constellationsButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,1,1,.8})    
        :textpos("Left")
        :movetext(-1, 7)
        :text(_("Constelat."))
        :movable(false)
        :active(true)      
       :attach(panel2Frame, 33, 2+17*(gg-4), 95, 3+17*4)

constellationsCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 33+2, 2+17*(gg-4), 95+50, 3+17*4)

constellationsButton.Action = (function()
        return
            function()
              display_constellations = not display_constellations;
                if display_constellations then
                    celestia:setrenderflags{constellations = true}
                    celestia:hideconstellations()
                    celestia:showconstellations()
                    celestia:show("constellations");  

                    celestia:showlabel("i18nconstellations") 
                    constellationsCheck.Text =    "|";
                else 
                    celestia:hide("constellations"); 
                    celestia:hidelabel("i18nconstellations") 
                    celestia:hidelabel("constellations")
                    constellationsCheck.Text = "";
                end
            end
        end) ();

boundariesButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor(color2)     
        :textpos("Left")
        :movetext(-2, 7)
        :text(_("Bord."))
        :movable(false)
        :active(true)     
       :attach(panel2Frame, 3, 2+17*(gg-4), 155, 3+17*4)

boundariesCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 3+2, 2+17*(gg-4), 155+20, 3+17*4)

boundariesButton.Action = (function()
        return
            function()
              display_boundaries = not display_boundaries;
                if display_boundaries then
                    celestia:show("boundaries");
                    celestia:setstarstyle("disc")        
                    boundariesCheck.Text =  "|";
                else 
                    celestia:hide("boundaries");  
                    boundariesCheck.Text = "";
                end
            end
        end) ();

-- =========================
-- 15. Объект Галактики/Имена галактик 
-- =========================
galaxButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,1,1,.8})    
        :textpos("Left")
        :movetext(-1, 7)
        :text(_("Galaxy"))
        :movable(false)
        :active(true)      
        :attach(panel2Frame, 33, 2+17*(gg-5), 95, 3+17*5)

galaxCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 33+2, 2+17*(gg-5), 95+50, 3+17*5)

galaxButton.Action = (function()
        return
            function()
              display_galax = not display_galax;
                if display_galax then
                    celestia:show("galaxies");              
                    galaxCheck.Text =  "|";
                else 
                    celestia:hide("galaxies");  
                    galaxCheck.Text = "";
                end
            end
        end) ();
----
galaxNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})        
        :textpos("Left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)   
        :attach(panel2Frame, 3, 2+17*(gg-5), 155, 3+17*5) 

galaxNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 3+2, 2+17*(gg-5), 155+20, 3+17*5)

galaxNButton.Action = (function()
        return
            function()
              display_galaxN = not display_galaxN;
                if display_galaxN then  
                    celestia:setlabelflags{galaxies = true}             
                    galaxNCheck.Text =  "|";
                else 
                    celestia:setlabelflags{galaxies = false}    
                    galaxNCheck.Text = "";
                end
            end
        end) ();

-- ===========================
-- 16. Объект Скопления/ Имема Скоплений 
-- ===========================
globulButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)      
        :textcolor({0,1,1,.8})    
        :textpos("Left")
        :movetext(-1, 7)
        :text(_("Clusters "))
        :movable(false)
        :active(true)      
        :attach(panel2Frame, 33, 2+17*(gg-6), 95, 3+17*6)

globulCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 33+2, 2+17*(gg-6), 95+50, 3+17*6)

globulButton.Action = (function()
        return
            function()
              display_globul = not display_globul;
                if display_globul then                   
                    celestia:show("globulars");   
                    celestia:show("openclusters");          
                    globulCheck.Text =   "|";
                else 
                    celestia:hide("globulars"); 
                    celestia:hide("openclusters"); 
                    globulCheck.Text = "";
                end
            end
        end) ();
----
globulNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})        
        :textpos("Left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)   
        :attach(panel2Frame, 3, 2+17*(gg-6), 155, 3+17*6) 

globulNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 3+2, 2+17*(gg-6), 155+20, 3+17*6)

globulNButton.Action = (function()
        return
            function()
              display_globulN = not display_globulN;
                if display_globulN then  
                     celestia:setlabelflags{globulars = true} 
                     celestia:setlabelflags{openclusters = true} 
                     globulNCheck.Text =  "|";
                else 
                     celestia:setlabelflags{globulars = false} 
                     celestia:setlabelflags{openclusters = false} 
                     globulNCheck.Text = "";
                end
            end
        end) ();

-- ===========================
-- 17 Имена туманности/Объект Туманности
-- ===========================
nebulaeButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)      
        :textcolor({0,1,1,.8})    
        :textpos("Left")
        :movetext(-2, 7)
        :text(_("Nebulae ")) 
        :movable(false)
        :active(true)      
        :attach(panel2Frame, 33, 2+17*(gg-7), 95, 3+17*7)

nebulaeCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 33+2, 2+17*(gg-7), 95+50, 3+17*7)

nebulaeButton.Action = (function()
        return
            function()
              display_nebulae = not display_nebulae;
                if display_nebulae then                   
                    celestia:show("nebulae"); 
                    nebulaeCheck.Text =  "|";
                else 
                    celestia:hide("nebulae");                    
                    nebulaeCheck.Text = "";
                end
            end
        end) ();
----------
nebulaeNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})        
        :textpos("Left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)   
        :attach(panel2Frame, 3, 2+17*(gg-7), 155, 3+17*7) 

nebulaeNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 3+2, 2+17*(gg-7), 155+20, 3+17*7)

nebulaeNButton.Action = (function()
        return
            function()
              display_nebulaeN = not display_nebulaeN;
                if display_nebulaeN then  
                     celestia:setlabelflags{nebulae = true}             
                     nebulaeNCheck.Text =   "|";
                else 
                     celestia:setlabelflags{nebulae = false}    
                     nebulaeNCheck.Text = "";
                end
            end
        end) ();

----------------------------------------------
-- OverviewOrbitsBox.lua - функция  Lagrange Points Tool v1.1
-- Phil Batchelor (aka Chuft-Captain) - автор дополнения Lagrange Points Tool v1.1
-- Edit by Lygin Gennady a.k.a Croc 20.08.2016
---------------------------------------------
	require "locale"
	require "lp_config"

--	Some constants and useful unit conversions:
--
-- Time 
	secs_in_day			= 60 * 60 * 24
	secs_in_week			= secs_in_day * 7
	secs_in_yr		        	= secs_in_day * 365.25
-- Velocity
	lightspeed_mps 	= 300000000
-- Distance
	au_km		= 150000000
	m_per_km		= 1000
	au_per_ss		= 100
	auSol2Pluto	= 32.3
	auSol2Earth	= 1
        au_m			= au_km * m_per_km
	ly_m			= secs_in_yr * lightspeed_mps
	ly_km		= ly_m / m_per_km
	uly_km 		= ly_km / 1000000
--	ly_au			= ly_m / au_m

--------------------------------------------
--	S C R I P T   F U N C T I O N S
--------------------------------------------
	local function celestia_set_state()
		local context = "celestia_set_state(): ";
		celestia:log( context )
		celestia:setorbitflags{ Planet = true, Moon = true,}
		celestia:setrenderflags{markers = true,	orbits = true, planets = true, }
	end

	local function do_Orrery()
		local context = "do_Orrery(): ";
		celestia:log( context )

		celestia_set_state()
		sel = celestia:getselection();
		obs = celestia:getobserver()
		if sel:name() == "?" then
			exception = err_nullselection
			celestia:flash( exception, 3 )	
		else
			celestia:log( "sel:name() = "..sel:name() )
			if sel:name() == "Sol" then return end
			now=obs:gettime()
			info = sel:getinfo()
			parent = info.parent
			celestia:log( "parent:name() = "..parent:name() )
			parent_pos=parent:getposition(now)
			object_pos=sel:getposition(now)
			distance_vec=parent_pos-object_pos
			distance = (distance_vec:length()*uly_km) / math.tan( obs:getfov() / 2.5 )  
			orr_transition = math.min( math.max( orr_transition, 0 ), 5 )
			obs:gotolonglat(parent, 0, math.rad(90.0), distance, orr_transition, celestia:newvector(0,1,0))
			if ( parent:name() == "Pluto" ) then
				-- celestia:log( "looking for Pluto_bary..." )
				parent = celestia:find("Pluto_bary")
				-- celestia:log( "parent = "..parent:name() )
				if parent:name() == "?" then
					parent = celestia:find("Pluto-Charon")
					-- celestia:log( "looking for Pluto-Charon, parent:name() = "..parent:name() )
				end
			end
			obs:follow(parent)
		end
	end -- FUNCTION	

-- =======================
-- Set up and Draw the boxes
----------------------------------------------
OverviewOrbitsButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("left")
    :movetext(1, 7)  
    :text(_("Overview Orbits"))
    :movable(false)
    :active(true) 
    :attach(panel2Frame, 3, 2+17*(gg-8), 95, 3+17*8)

OverviewOrbitsCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true) 
        :attach(panel2Frame, 5, 2+17*(gg-8), 175, 3+17*8)

OverviewOrbitsButton.Action = (function()
        return
            function()                 
                if OverviewOrbitsCheck.Text == "" then
                   OverviewOrbitsCheck.Text = "|"; 

		orig_renderflags                 = celestia:getrenderflags()
		orig_labelflags                  = celestia:getlabelflags()
		orig_orbitflags                  = celestia:getorbitflags()
		orig_amb                         = celestia:getambient()
		orig_maglimit                    = celestia:getfaintestvisible()
		orig_minorbit                    = celestia:getminorbitsize()
		orig_stardistance              = celestia:getstardistancelimit()
		orig_minfeature                = celestia:getminfeaturesize()
		orig_starstyle                   = celestia:getstarstyle()
		orig_galaxylight                 = celestia:getgalaxylightgain()
		orig_fov                            = celestia:getobserver():getfov() 
		orig_locationflags               = celestia:getobserver():getlocationflags()
		orig_overlay                       = celestia:getoverlayelements()
		orig_altazimuthmode           = celestia:getaltazimuthmode()
                --------------------------------------------------------------------------
		-- Comment next line if NOT using Celestia v1.6.0 or later
                --------------------------------------------------------------------------
		orig_textres                     = celestia:gettextureresolution()
                --------------------------------------------------------------------------
		-- Comment next line if NOT using Celestia v1.6.1 or later
                --------------------------------------------------------------------------
		orig_txt_r,orig_txt_g,orig_txt_b = celestia:gettextcolor()
		obs			                     = celestia:getobserver()
		orig_pos		             	     = celestia:geturl(obs)

-- ==============================
	local context = "OrreryButton.Action (): ";
	celestia:log( context )		
	do_Orrery()
-- ==============================

           else  
                    OverviewOrbitsCheck.Text = "";  

	   celestia:setrenderflags(orig_renderflags)
	   celestia:setlabelflags(orig_labelflags)
	   celestia:setorbitflags(orig_orbitflags)
	   celestia:setambient(orig_amb)
	   celestia:setfaintestvisible(orig_maglimit)
	   celestia:setminorbitsize(orig_minorbit)
	   celestia:setstardistancelimit(orig_stardistance)
	   celestia:setminfeaturesize(orig_minfeature)
	   celestia:setstarstyle(orig_starstyle)
	   celestia:setgalaxylightgain(orig_galaxylight)
	   celestia:getobserver():setfov(orig_fov)
	   celestia:getobserver():setlocationflags(orig_locationflags)
	   celestia:getobserver():singleview()
	   celestia:setoverlayelements(orig_overlay)
	   celestia:setaltazimuthmode(orig_altazimuthmode)
	   -- Comment next line if NOT using Celestia v1.6.0 or later
	   celestia:settextureresolution(orig_textres)

            local obs = celestia:getobserver();
            local obj = celestia:find("Earth");
            celestia:select(obj);
            obs:follow(obj);          
            obs:goto(obj); 

                end
            end
        end) ();

-- =======================
-- Увеличение планет
-- =======================
-- magnificationBox.lua
----------------------------------------------
require "locale";
----------------------------------------------
-- Define local functions
----------------------------------------------
local getRadius = function(obj_t)
    local radius_t = {};
    for k, obj in pairs(obj_t) do
        radius_t[k] = obj:radius();
    end
    return radius_t;
end 

local getSolChildrenFromType = function(magType)
    local magChildren = {};
    local allChildren = magSol:getchildren();
    for k, child in pairs(allChildren) do
        if child:type() == magType then
            magChildren[k] = child;
        end
    end
    return magChildren;
end

local getSolsysMoons = function()
    local magMoons = {};
    local magPlanets = getSolChildrenFromType("planet");
    for k, planet in pairs(magPlanets) do
        local magPlanetChildren = planet:getchildren();
        for i, child in pairs(magPlanetChildren) do
            if child:type() == "moon" then
                magMoons[k*10 + i] = child;
            end
        end
    end
    return magMoons;
end

local toggleMagnification = function(magnify)
    magRadius = getRadius(magObjects)
    if magnify then
        -- Magnify objects (increase the size of objects).
        for k, magObj in pairs(magObjects) do
            magObj:setradius(magRadius[k] * magCoeff)
            celestia:print(magStr..string.format(" %gx", magCoeff), 3)
        end
        -- Move the observer outside of the selected object.
        if selection then
            local obs = celestia:getobserver();
            local sel = celestia:getselection();
            local mag_distfromsel = celutil.get_dist(obs, sel);
            local mag_sel_radius = sel:radius();
            if mag_distfromsel < mag_sel_radius then
                local fov = obs:getfov();
                obs:gotodistance(sel, 5.5 * sel:radius() / (fov / 0.4688), 0.01)
            end
        end
    else
        -- Bring objects back to their original size.
        for k, magObj in pairs(magObjects) do
            magObj:setradius(magRadius[k] / magCoeff)
            celestia:print(_("Magnification disabled"), 3)
        end
    end
end
----------------------------------------------
-- Set initial values
----------------------------------------------
cMagnification = cbutextoff;
magnification_first_tick = true;

magSol = celestia:find("Sol");
magEarth = celestia:find("Sol/Earth");
magMoon = celestia:find("Sol/Earth/Moon");

-- List of objects which shouldn't be magnified
magExceptions = {"Sol/Red Giant"}
--------------------------------------------------------------
-- Get magnification elements from 'config.lua'.
--------------------------------------------------------------
if magnified_objects == "planets" then
    magObjects = getSolChildrenFromType("planet");
    magCoeff = planets_magnification;
    magStr = _("Planets Magnified");
elseif magnified_objects == "asteroids" then
    magObjects = getSolChildrenFromType("asteroid");
    magCoeff = asteroids_magnification;
    magStr = _("Asteroids Magnified");
elseif magnified_objects == "comets" then
    magObjects = getSolChildrenFromType("comet");
    magCoeff = comets_magnification;
    magStr = _("Comets Magnified");
elseif magnified_objects == "moons" then
    magObjects = getSolsysMoons();
    magCoeff = moons_magnification;
    magStr = _("Moons Magnified")
elseif magnified_objects == "earth_moon" then
    magObjects = {magEarth, magMoon};
    magCoeff = earth_moon_magnification;
    magStr = _("Earth and Moon Magnified")
end

-- Remove exceptions from the list of objects to magnify
for k1, obj in pairs(magObjects) do
    for k2, v2 in pairs(magExceptions) do
        local exceptobj = celestia:find(v2)
        if obj:name() == exceptobj:name() then
            magObjects[k1] = nil;
        end
    end
end
----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------
magnificationButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :fillcolor(cFrameFill)
    :textfont(normalfont)  
    :textcolor(color2)
    :textpos("left")
    :movetext(1, 7)  
    :text(_("Magnification"))
    :movable(false) 
    :active(true)  
    :attach(panel2Frame, 3, 2+17*(gg-9), 95, 3+17*9) 

magnificationCheck = CXBox:new()
        :init(0, 0, 0, 0)      
        :textfont(smallfont)
        :textcolor({1,0,0,1})        
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 5, 2+17*(gg-9), 175, 3+17*9) 

magnificationButton.Customdraw =
    function(this)
        -- Set the initial state of the check-box from 'config.lua'.
        if magnification_first_tick and enable_magnification then
            magnificationCheck.Action();
        end
        magnification_first_tick = false;
    end

magnificationButton.Action = (function()
        return
            function()
                magnify = not(magnify);
                toggleMagnification(magnify);
                if magnify then
                    magnificationCheck.Text = "|";
                    -- Disable atmospheres in magnification mode to avoid
                    -- flickering issue with OpenGL 2.0 render path.
                    atm_flag = celestia:getrenderflags()["atmospheres"];
                    celestia:setrenderflags{atmospheres = false}
                else
                    magnificationCheck.Text = "";
                    -- Set atmospheres renderflag back to its initial state.
                    celestia:setrenderflags{atmospheres = atm_flag};
                end
            end
        end) ();

-- ======================
-- 21. Планеты-объекты
-- ======================
planetObjectButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(normalfont)
        :textcolor({0,1,1,.8})       
        :textpos("Left")
        :movetext(8, 7)       
        :text(_("PLANETS+"))  
        :movable(false)
        :active(true)      
        :attach(panel2Frame, 93+2, 2+17*(gg-1), 3, 3+17*1)

planetObjectCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(0, 9)
        :text("")
        :movable(false)
        --:active(true)  
        :attach(panel2Frame, 93, 2+17*(gg-1), 93, 3+17*1)

planetObjectButton.Action = (function()
        return
            function()
              display_planetObject = not display_planetObject;
                if display_planetObject then
                    celestia:show("planets");                 
                    planetObjectCheck.Text = "|||";
                else 
                    celestia:hide("planets");                 
                    planetObjectCheck.Text = "";
                end
            end
        end) ();

-- =========================
-- 22. Планеты-орбиты / Планеты имена 
-- =========================
planetButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor(cbutextoff)    
        :textpos("Left")
        :movetext(-2, 7)
        :text(_("Planets "))
        :movable(false)
        :active(true)      
       :attach(panel2Frame, 126, 2+17*(gg-2), 3, 3+17*2)

planetCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 126+2, 2+17*(gg-2), 3+50, 3+17*2)

planetButton.Action = (function()
        return
            function()
              display_planet = not display_planet;
                if display_planet then
                    celestia:setorbitflags{Planet = true}  
                    planetCheck.Text = "|";
                else 
                    celestia:setorbitflags{Planet = false}  
                    planetCheck.Text = "";
                end
            end
        end) ();
------
planetNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)      
        :textcolor({0,0.4,1,1})     
        :textpos("left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)    
        :attach(panel2Frame, 93+2, 2+17*(gg-2), 60+2, 3+17*2) 

planetNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)     
        :attach(panel2Frame, 97, 2+17*(gg-2), 82, 3+17*2)

planetNButton.Action = (function()
        return
            function()
              display_planetN = not display_planetN;
                if display_planetN then                  
                    celestia:showlabel("planets")                  
                    planetNCheck.Text = "|";
                else                  
                    celestia:hidelabel("planets")                  
                    planetNCheck.Text = "";
                end
            end
        end) ();

-- ====================
-- 23. Малые планеты / МП-имена 
-- ====================
dwarfPlanetButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor(cbutextoff)    
        :textpos("left")
        :movetext(-2, 7)
        :text(_("Dw.Planets"))
        :movable(false)
        :active(true)      
        :attach(panel2Frame, 126, 2+17*(gg-3), 3, 3+17*3)

dwarfPlanetCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 126+2, 2+17*(gg-3), 3+50, 3+17*3)

dwarfPlanetButton.Action = (function()
        return
            function()
              display_dwarfPlanet = not display_dwarfPlanet;
                if display_dwarfPlanet then                 
                    celestia:setorbitflags{DwarfPlanet = true}             
                    dwarfPlanetCheck.Text = "|";
                else 
                    celestia:setorbitflags{DwarfPlanet = false}                  
                    dwarfPlanetCheck.Text = "";
                end
            end
        end) ();

dwarfPlanetNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})       
        :textpos("Left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)     
       :attach(panel2Frame, 93+2, 2+17*(gg-3), 60+2, 3+17*3)
      
dwarfPlanetNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)     
        :attach(panel2Frame, 97, 2+17*(gg-3), 82, 3+17*3)

dwarfPlanetNButton.Action = (function()
        return
            function()
              display_dwarfPlanetN = not display_dwarfPlanetN;
                if display_dwarfPlanetN then                  
                     celestia:showlabel("dwarfplanets")                  
                    dwarfPlanetNCheck.Text = "|";
                else                  
                    celestia:hidelabel("dwarfplanets")                                    
                    dwarfPlanetNCheck.Text = "";
                end
            end
        end) ();

-- =====================
-- 24. Луны-орбиты / Луны-имена 
-- =====================
moonButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor(cbutextoff)    
        :textpos("Left")
        :movetext(-2, 7)
        :text(_("Moons "))
        :movable(false)
        :active(true)      
       :attach(panel2Frame, 126, 2+17*(gg-4), 3, 3+17*4)

moonCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 126+2, 2+17*(gg-4), 3+50, 3+17*4)

moonButton.Action = (function()
        return
            function()
              display_moon = not display_moon;
                if display_moon then                 
                    celestia:setorbitflags{Moon = true}             
                    moonCheck.Text = "|";
                else 
                    celestia:setorbitflags{Moon = false}                  
                    moonCheck.Text = "";
                end
            end
        end) ();
----------
MoonNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})        
        :textpos("Left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)     
        :attach(panel2Frame, 93+2, 2+17*(gg-4), 60+2, 3+17*4)

MoonNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 93+2+2, 2+17*(gg-4), 60+2+20, 3+17*4)

MoonNButton.Action = (function()
        return
            function()
              display_MoonN = not display_MoonN;
                if display_MoonN then               
                    celestia:showlabel("moons")
                    MoonNCheck.Text = "|";
                else 
                    celestia:hidelabel("moons")   
                    MoonNCheck.Text = "";
                end
            end
        end) ();
-- ==========================
-- 25. Малые луны - орбиты / МЛ - имена
-- ==========================
MinorMoonButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor(cbutextoff)     
        :textpos("Left")
        :movetext(-2, 7)
        :text(_("MinorMoon"))
        :movable(false)
        :active(true)      
        :attach(panel2Frame, 126, 2+17*(gg-5), 3, 3+17*5)

MinorMoonCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 126+2, 2+17*(gg-5), 3+50, 3+17*5)

MinorMoonButton.Action = (function()
        return
            function()
              display_MinorMoon = not display_MinorMoon;
                if display_MinorMoon then                 
                    celestia:setorbitflags{MinorMoon = true}             
                    MinorMoonCheck.Text = "|";
                else 
                    celestia:setorbitflags{MinorMoon = false}                  
                    MinorMoonCheck.Text = "";
                end
            end
        end) ();
---------------
MinorMoonNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})        
        :textpos("Left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)     
        :attach(panel2Frame, 93+2, 2+17*(gg-5), 60+2, 3+17*5)

MinorMoonNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 93+2+2, 2+17*(gg-5), 60+2+20, 3+17*5)

MinorMoonNButton.Action = (function()
        return
            function()
              display_MinorMoonN = not display_MinorMoonN;
                if display_MinorMoonN then               
                    celestia:showlabel("minormoons")
                    MinorMoonNCheck.Text = "|";
                else 
                    celestia:hidelabel("minormoons")   
                    MinorMoonNCheck.Text = "";
                end
            end
        end) ();

-- ============================
-- 26. Астероиды-орбиты  / Астероиды имена  
-- ============================
asteroidButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor(cbutextoff)    
        :textpos("Left")
        :movetext(-2, 7)
        :text(_("Asteroids "))
        :movable(false)
        :active(true)      
       :attach(panel2Frame, 126, 2+17*(gg-6), 3, 3+17*6)

asteroidCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 126+2, 2+17*(gg-6), 3+50, 3+17*6)

asteroidButton.Action = (function()
        return
            function()
              display_asteroid = not display_asteroid;
                if display_asteroid then                 
                      celestia:setorbitflags{Asteroid = true}       
                      asteroidCheck.Text = "|";
                else 
                      celestia:setorbitflags{Asteroid = false}  
                      asteroidCheck.Text = "";
                end
            end
        end) ();
---------------
asteroidNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})        
        :textpos("Left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)     
        :attach(panel2Frame, 93+2, 2+17*(gg-6), 60+2, 3+17*6)

asteroidNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 93+2+2, 2+17*(gg-6), 60+2+20, 3+17*6)

asteroidNButton.Action = (function()
        return
            function()
              display_asteroidN = not display_asteroidN;
                if display_asteroidN then                 
                   -- celestia:showlabel("spacecraft")
                    celestia:showlabel("asteroids")
                    asteroidNCheck.Text = "|";
                else 
                   -- celestia:hidelabel("spacecraft")  
                    celestia:hidelabel("asteroids")   
                    asteroidNCheck.Text = "";
                end
            end
        end) ();

-- =======================
-- 27. Кометы-орбиты / Кометы-имена
-- =======================
CometButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor(cbutextoff)     
        :textpos("Left")
        :movetext(-2, 7)
        :text(_("Comets "))
        :movable(false)
        :active(true)      
        :attach(panel2Frame, 126, 2+17*(gg-7), 3, 3+17*7)

CometCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 126+2, 2+17*(gg-7), 3+50, 3+17*7)

CometButton.Action = (function()
        return
            function()
              display_Comet = not display_Comet;
                if display_Comet then                 
                    celestia:setorbitflags{Comet = true}             
                    CometCheck.Text = "|";
                else 
                    celestia:setorbitflags{Comet = false}                  
                    CometCheck.Text = "";
                end
            end
        end) ();

CometNButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        --:fillcolor({1,1,0,.2})
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})        
        :textpos("Left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)     
        :attach(panel2Frame, 93+2, 2+17*(gg-7), 60+2, 3+17*7)

CometNCheck = CXBox:new()
        :init(0, 0, 0, 0)
        --:bordercolor(cbubordoff)
        --:fillcolor({1,1,0,.2})
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 93+2+2, 2+17*(gg-7), 60+2+20, 3+17*7)

CometNButton.Action = (function()
        return
            function()
              display_CometN = not display_CometN;
                if display_CometN then                 
                    celestia:showlabel("comets")
                    CometNCheck.Text = "|";
                else 
                     celestia:hidelabel("comets")   
                    CometNCheck.Text = "";
                end
            end
        end) ();

-- ==================================
-- 28 Космические корабли - орбиты / спутники-имена
-- ==================================
class28Button = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor(cbutextoff)     
        :textpos("Left")
        :movetext(-2, 7)
        :text(_("Spacecraft "))
        :movable(false)
        :active(true)      
        :attach(panel2Frame, 126, 2+17*(gg-8), 3, 3+17*8)

class28Check = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 126+2, 2+17*(gg-8), 3+50, 3+17*8)

class28Button.Action = (function()
        return
            function()
              display_class28 = not display_class28;
                if display_class28 then                 
                    celestia:setorbitflags{Spacecraft = true}             
                    class28Check.Text = "|";
                else 
                    celestia:setorbitflags{Spacecraft = false}                  
                    class28Check.Text = "";
                end
            end
        end) ();

class282Button = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(smallfont)
        :textcolor({0,0.4,1,1})           
        :textpos("Left")
        :movetext(-3, 7)
        :text(_("name"))
        :movable(false)
        :active(true)     
       :attach(panel2Frame, 93+2, 2+17*(gg-8), 60+2, 3+17*8)

class282Check = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-6, 8)
        :text("")
        :movable(false)
        :active(true)  
        :attach(panel2Frame, 93+2+2, 2+17*(gg-8), 60+2+20, 3+17*8)

class282Button.Action = (function()
        return
            function()
              display_class282 = not display_class282;
                if display_class282 then                 
                    celestia:showlabel("spacecraft")         
                    class282Check.Text = "|"; 
                else 
                    celestia:hidelabel("spacecraft")             
                    class282Check.Text = "";
                end
            end
        end) ();

-- =======================
-- 29. Включение/Отключение орбит
-- =======================
orbitAllButton = CXBox:new()
        :init(0, 0, 0, 0)
        :bordercolor(cbubordoff)
        :fillcolor(cFrameFill)
        :textfont(normalfont)
        :textcolor(cbutextoff)    
        :textpos("Left")
        :movetext(6, 7)
        :text(_("ORBITS all"))
        :movable(false)
        :active(true)     
        :attach(panel2Frame, 93+2, 2+17*(gg-9), 3, 3+17*9)

orbitAllCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(0, 9)
        :text("")
        :movable(false)
        :attach(panel2Frame, 93, 2+17*(gg-9), 93, 3+17*9)

orbitAllButton.Action = (function()
        return
            function()
              display_orbitAll = not display_orbitAll;
                if display_orbitAll then
                    celestia:show("orbits")                               
                    orbitAllCheck.Text = "|||";
                else 
                    celestia:hide("orbits")              
                    orbitAllCheck.Text = "";
                end
            end
        end) ();