--------------------------------------------------------
-- panel3Box.lua
-- Author of panel - Lygin Gennady a.k.a Croc
-- Author of tools - Vincent Giangiulio a.k.a Vincent
-- Integration by Lygin Gennady a.k.a Croc 30.08.2016
-- modified by Gironde 31-08-2018 : connecting command
--------------------------------------------------------
----------------------------------------------
-- Set initial values
----------------------------------------------
local newwidth, newheight
local gn=10
local gg=gn-1
local panel3FrameWidth, panel3FrameHeight = 186, 17*gn+3
width, height  = celestia:getscreendimension()
local coordinates1_first_tick = true 																					  
local coordinates2_first_tick = true 																					  
local coordinates3_first_tick = true 

local clearCoordinatesCheck = function ()
	coordinates1Check.Text = ""
	coordinates2Check.Text = ""
	coordinates3Check.Text = ""
end
----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------
panel3Box = CXBox:new()
	--:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:init(0, 0, 0, 0)
	:movable(false)
	:attach(screenBox, width, height, 0, 0)
-----------------------------------------------
panel3Frame = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.8})
	:fillcolor(csetbofill)
	:textfont(normalfont)
	:textcolor({0.2,0.8,1,1})
	:textpos("center")
	:movetext(0, 5)
	:active(false)				  
	:text(_("Coordinates. Options settings:"))
	:movable(true)
	:clickable(false)
	:visible(false)
	:attach(screenBox, (width-panel3FrameWidth)/2, height-panel3FrameHeight-2, (width-panel3FrameWidth)/2, 2)

closepanel3Button = CXBox:new()
		:init(0, 0, 0, 0)
	   -- :bordercolor(cbubordoff)
		:textfont(smallfont)
		:textcolor({1,0,0,0.5})
		:textpos("left")
		:movetext(1, 12)
		:text("x")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 172, 160, 2, 2)

	closepanel3Button.Action = (function()
		return
			function()
			 display_panel3 = not display_panel3
				if panel3Frame.Visible then
					panel3Frame.Visible = false
					panel3Check.Text = "o"
					panel3Check.Text = ""
				end
		   end
	  end) ()

panel3Frame.Customdraw = function(this)
	   if newwidth ~= width or newheight ~= height then
			   newwidth, newheight = width, height
	   if width >=1280 then
			   panel3Frame:attach(screenBox, (width-panel3FrameWidth)/2-161, 3, (width-panel3FrameWidth)/2+161, height-panel3FrameHeight-3)
	   else
		  if width>=900  then
			 panel3Frame:attach(screenBox, 195, 3, width-panel3FrameWidth-195, height-panel3FrameHeight-3)
		  else
			 panel3Frame:attach(screenBox, 6, 3, width-panel3FrameWidth-6, height-panel3FrameHeight-3)
		  end
	   end
	end
end
--======================================================
-- Connecting commands -- modified by Gironde 31-08-2018
--======================================================
-- =====================================
-- Equatorial coordinates # 1
-- =====================================
----------------------------------------
-- Set initial values
----------------------------------------
cCoordinates = {1,1,0,1}

coordinates1Box = CXBox:new() 
	:init(0, 0, 0, 0)
	:bordercolor({0, 0.5, 0.5, 0.5})
	:fillcolor(cFrameFill)
	:movable(false)
	:active(true)
	:attach(panel3Frame, 3, 2+17*(gg-2), 125, 3+17*2)

coordinates1Box.Customdraw =
	function(this)
		textlayout:setfont(smallfont)
		textlayout:setfontcolor(cCoordinates)
		textlayout:setpos(this.lb+6, this.tb-11)
		textlayout:println(_("Eq. coord."))
	end

coordinates1Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor(cbutextoff)
		:textpos("left")
		:movetext(-3, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(coordinates1Box, 0,0,0,0)

coordinates1Check.Customdraw =
	function(this)
		if selection then
			if newselection then
				-- Get Distance to Earth, RA, and Dec.
				local sel = celestia:getselection()
				local dist_to_earth = celutil.get_dist_to_earth(sel)
				if dist_to_earth < 0 then
					disableCheckBox(coordinates1Check)
					cCoordinates = {1,1,0,1} -- yellow text
				else
					enableCheckBox(coordinates1Check)
					cCoordinates = {0,1,0,1} -- green text
				end
			end
		else
			disableCheckBox(coordinates1Check)
			cCoordinates = {1,1,0,1} -- yellow text
		end
	end
	
coordinates1Check.Action = (function() -- вставил в редакции gironde 29-09-2018
	return
		function()
			display_coordinates1 = not display_coordinates1 -- choice or not display_coordinates1
			display_coordinates2 = false -- others are false
			display_coordinates3 = false -- others are false
			if display_coordinates1 then
				clearCoordinatesCheck () -- clear all check
				coordinates1Check.Text = "|"
				-- coordinates1Check.Text = ""
            else 
                coordinates1Check.Text = ""
	        end
		end
	 end) ()
	
--======================================
-- Ecliptic coordinates # 2
--======================================
coordinates2Box = CXBox:new() 
	:init(0, 0, 0, 0)
	:bordercolor({0, 0.5, 0.5, 0.5})
	:fillcolor(cFrameFill)
	:movable(false)
	:active(true)
	:attach( panel3Frame, 64, 2+17*(gg-2), 64, 3+17*2)

coordinates2Box.Customdraw =
	function(this)
		textlayout:setfont(smallfont)
		textlayout:setfontcolor(cCoordinates)
		textlayout:setpos(this.lb+6, this.tb-11)
		textlayout:println(_("Ecl. coord."))
	end

coordinates2Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor(cbutextoff)
		:textpos("left")
		:movetext(-3, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(coordinates2Box, 0,0,0,0)

coordinates2Check.Customdraw =
	function(this)
		if selection then
			if newselection then
				-- Get Distance to Earth, RA, and Dec.
				local sel = celestia:getselection()
				local dist_to_earth = celutil.get_dist_to_earth(sel)
				if dist_to_earth < 0 then
					disableCheckBox(coordinates2Check)
					cCoordinates = {1,1,0,1} -- yellow text
				else
					enableCheckBox(coordinates2Check)
					cCoordinates = {0,1,0,1} -- green text
				end
			end
		else
			disableCheckBox(coordinates2Check)
			cCoordinates = {1,1,0,1} -- yellow text
		end
	end
	
coordinates2Check.Action = (function() -- вставил в редакции gironde 29-09-2018
	return
		function()
			display_coordinates2 = not display_coordinates2 -- choice or not display_coordinates2
			display_coordinates1 = false -- others are false
			display_coordinates3 = false -- others are false
			if display_coordinates2 then
				clearCoordinatesCheck () -- clear all check
				coordinates2Check.Text = "|"				
			else
				coordinates2Check.Text = ""
			end
		end
	end) ()

-- =====================================
-- Galactic coordinates # 3
-- =====================================
coordinates3Box = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0, 0.5, 0.5, 0.5})
	:fillcolor(cFrameFill)
	:movable(false)
	:active(true)
	:attach( panel3Frame, 125, 2+17*(gg-2), 3, 3+17*2)

coordinates3Box.Customdraw =
	function(this)
		textlayout:setfont(smallfont)
		textlayout:setfontcolor(cCoordinates)
		textlayout:setpos(this.lb+6, this.tb-11)
		textlayout:println(_("Gal. coord."))
	end

coordinates3Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor(cbutextoff)
		:textpos("left")
		:movetext(-3, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(coordinates3Box, 0,0,0,0)

coordinates3Check.Customdraw =
	function(this)
		if selection then
			if newselection then
				-- Get Distance to Earth, RA, and Dec.
				local sel = celestia:getselection()
				local dist_to_earth = celutil.get_dist_to_earth(sel)
				if dist_to_earth < 0 then
					disableCheckBox(coordinates3Check)
					cCoordinates = {1,1,0,1} -- yellow text
				else
					enableCheckBox(coordinates3Check)
					cCoordinates = {0,1,0,1} -- green text
				end
			end
		else
			disableCheckBox(coordinates3Check)
			cCoordinates = {1,1,0,1} -- yellow text
		end
	end

coordinates3Check.Action = (function() -- вставил в редакции gironde 29-09-2018
	return
		function()
			display_coordinates3 = not display_coordinates3 -- choice or not display_coordinates3
			display_coordinates1 = false -- others are false
			display_coordinates2 = false -- others are false
			if display_coordinates3 then
				clearCoordinatesCheck () -- clear all check
				coordinates3Check.Text = "|"
			else
				coordinates3Check.Text = ""
			end
		end
	end) ()

-- =====================================
-- Display coordinates
-- =====================================
local ra,dec -- как у Gironde
local ecliptic_long, ecliptic_lat -- как у Gironde
local galactic_long, galactic_lat -- как у Gironde

displayBox = CXBox:new() -- left window
    :init(0, 0, 0, 0)
    :bordercolor({0, 0.5, 0.5, 0.5})
    :fillcolor({0.2,0.5,1,.3}) 
    :movable(false)
    :active(false)
    :attach(panel3Frame, 3, 2+17*(gg-1), 93+2, 3+17*1)

display2Box = CXBox:new() -- right window
    :init(0, 0, 0, 0)
    :bordercolor({0, 0.5, 0.5, 0.5})
    :fillcolor({0.2,0.5,1,.3})  
    :movable(false)
    :active(false)
    :attach( panel3Frame, 95, 2+17*(gg-1), 3, 3+17*1)

displayBox.Customdraw =
    function(this)
        if selection then
            local sel = celestia:getselection()
            local obs = celestia:getobserver()
            local dist_to_earth = celutil.get_dist_to_earth(sel)
            if dist_to_earth >= 0 then
----------------------------------------------
              if display_coordinates1 then
                -- Equatorial Coordinates (Ra, Dec).
                ra,dec = celutil.get_ra_dec(sel)
                ra_str = format:deghms(ra)
                dec_str = format:degdms(dec)

                textlayout:setfont(smallfont)
                textlayout:setfontcolor({1,0,0,1})
                textlayout:setpos(this.lb + 1, this.tb - 11)
                textlayout:println(_("RA:"))
                textlayout:setpos(this.lb + 95, this.tb - 11)
                textlayout:println(_("Dec:"))
                textlayout:setfont(normalfont)
                textlayout:setfontcolor({1,1,1,0.8})
                textlayout:setpos(this.lb + 17, this.tb - 11)
                textlayout:println(ra_str)
                textlayout:setpos(this.lb + 120-6, this.tb - 11)
                textlayout:println(dec_str)
              end
-----------------------------------------------
              if display_coordinates2 then
                -- Ecliptic Coordinates (Ecliptic Long, Ecliptic Lat).
                ecliptic_long, ecliptic_lat = celutil.get_ecliptic_long_lat(sel)
                ecliptic_long_str = format:deg(ecliptic_long)
                ecliptic_lat_str = format:deg(ecliptic_lat)

                textlayout:setfont(smallfont)
                textlayout:setfontcolor({1,0,0,1})
                textlayout:setpos(this.lb + 4, this.tb - 10)
                textlayout:println(_("E.Long:"))
                textlayout:setpos(this.lb + 95, this.tb - 10)
                textlayout:println(_("E.Lat:"))
                textlayout:setfont(normalfont)
                textlayout:setfontcolor({1,1,1,0.8})
                textlayout:setpos(this.lb + 47-3, this.tb - 11)
                textlayout:println(ecliptic_long_str)
                textlayout:setpos(this.lb + 140-5, this.tb - 11)
                textlayout:println(ecliptic_lat_str)
              end
-------------------------------------------------	  
              if display_coordinates3 then
                -- Galactic Coordinates (Galactic Long, Galactic Lat).
                galactic_long, galactic_lat = celutil.get_galactic_long_lat(sel)
                galactic_long_str = format:deg(galactic_long)
                galactic_lat_str = format:deg(galactic_lat)
                textlayout:setfont(smallfont)
                textlayout:setfontcolor({1,0,0,1})
                textlayout:setpos(this.lb + 4, this.tb - 10)
                textlayout:println(_("G.Long:"))
                textlayout:setpos(this.lb + 95, this.tb - 10)
                textlayout:println(_("G.Lat:"))
	            textlayout:setfont(normalfont)
                textlayout:setfontcolor({1,1,1,0.8})
                textlayout:setpos(this.lb + 47-3, this.tb - 11)
                textlayout:println(galactic_long_str)
                textlayout:setpos(this.lb + 140-5, this.tb - 11)
                textlayout:println(galactic_lat_str)
              end
           end
       end
   end
		
-- =====================================
-- Equatorial grid
-- =====================================
panel313Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({0.2,0.8,1,1})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Equat. grid"))
	:movable(false)
	:active(true)
	:attach(panel3Frame, 3, 2+17*(gg-3), 125, 3+17*3)

panel313Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 5, 2+17*(gg-3), 175, 3+17*3)

panel313Button.Action = (function()
		return
			function()
			  display_panel313 = not display_panel313
				if display_panel313 then
					celestia:show("equatorialgrid")
					panel313Check.Text = "|"
				else
					celestia:hide("equatorialgrid")
					panel313Check.Text = ""
				end
			end
		end) ()
-- =====================================
-- The horizontal grid
-- =====================================
panel314Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({0.2,0.8,1,1})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Horiz. grid"))
	:movable(false)
	:active(true)
	:attach(panel3Frame, 3, 2+17*(gg-4), 125, 3+17*4)

panel314Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 5, 2+17*(gg-4), 175, 3+17*4)

panel314Button.Action = (function()
		return
			function()
			  display_panel314 = not display_panel314
				if display_panel314 then
					celestia:show("horizontalgrid")
					panel314Check.Text = "|"
				else
					celestia:hide("horizontalgrid")
					panel314Check.Text = ""
				end
			end
		end) ()			
--======================================
-- Info - Property details
-- =====================================
-- infoBox.lua
----------------------------------------------
require "infoImage"
----------------------------------------------
-- Load images.
----------------------------------------------
local infoButton1 = celestia:loadtexture("../images/button1.png")
local infoButton2 = celestia:loadtexture("../images/button2.png")
----------------------------------------------
-- Define local functions
----------------------------------------------
local setInfoScrollbarVisibility = function(nLines)
	if nLines > nLinesMax then
		infoScrollbarFrame.Visible = true
	else
		infoScrollbarFrame.Visible = false
	end
end

local getTextWidth = function(text)
	local lineWidthMax = 0
	for textline in string.gfind(text,"([^\n]*)\n") do
		local lineWidth = normalfont:getwidth(textline)
		if lineWidth > lineWidthMax then
			lineWidthMax = lineWidth
		end
	end
	local textWidth = math.ceil(lineWidthMax)
	return textWidth
end

local getImageSize = function(image)
	local iWidth = image:getwidth()
	local iHeight = image:getheight()

	if iWidth > 128 * photo_size or iHeight > 128 * photo_size then
		if iHeight >= 128 * photo_size then
			iWidth = iWidth * 128 * photo_size / iHeight
			iHeight = 128 * photo_size
		else
			--  iWidth = iWidth * 512 / iHeight
			--  iHeight = 512
		end
	end

	return iWidth, iHeight
end

local setInfoButtonVisibility = function(imageIndexMax)

	if imageIndexMax > 1 then
		infoPreviousButton.Visible = true
		infoNextButton.Visible = true
	else
		infoPreviousButton.Visible = false
		infoNextButton.Visible = false
	end
end

local getImageIndexMax = function(selname)
	iMax = 0
	if infoImage[selname] then
		iMax = table.getn(infoImage[selname])
	end
	return iMax
end

--==============================================================
-------------------- infoText and infoImage---------------------
----------------------------------------------
-- Set initial values
----------------------------------------------
cInfo = ctext
seltextline = {}
nLines = 0
nLinesMax = 32-12 -- infoTextFrame  32-12
infoScroll = 0
infoScrollCoeff = 10
infoScrollbarBoxH = 0
local newwidth2, newheight2 -- for infoText
local newwidth3, newheight3 -- for infoImage

--infoTextFrameWidth, infoTextFrameHeight = 350-150, (nLinesMax+1)*14 +7
infoTextFrameWidth, infoTextFrameHeight = 370-150, (nLinesMax+1)*14 +7 -- 220
infoScrollbarFrameW, infoScrollbarFrameH = 9, ( nLinesMax+1)*14-23

image = {}
for objname, v in pairs(infoImage) do
	image[objname] = {}
end

--imageWidth, imageHeight = 256, 256
imageWidth, imageHeight = 128 * photo_size, 128 * photo_size

imdx, imdy = 0, 0
-- Move up image if obsModeBox is disabled.

-- obsModeBox

if not(obsModeBox) then
   -- imdy = 50
	  imdy = 0
end
----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------
infoButton = CXBox:new()
	  :init(0, 0, 0, 0)
	  :bordercolor(cbubordoff)
	  :fillcolor(cFrameFill)
	  :textfont(smallfont)
	  :textcolor({1,0,0,0.8})
	  :textpos("left")
	  :movetext(1, 7)
	  :text(_("More Info"))
	  :active(true)
	  :attach(panel3Frame, 3, 2+17*(gg-5), 125, 3+17*5)

infoButton.Customdraw =
	function(this)
		-- Set the initial state of the check-box from 'config.lua'.
		if not info_firstTickDone then
			info_firstTickDone = true
			if enable_info then
				infoCheck.Action()
			end
		end

		local sel = celestia:getselection()

		if selection then
			if newselection then
				if infoText[sel:name()] or getImageIndexMax(sel:name()) ~= 0 then
					enableCheckBox(infoCheck)
					cInfo = csetbofill
				else
					disableCheckBox(infoCheck)
					cInfo = cchetextoff
				end
			end
		else
			disableCheckBox(infoCheck)
			cInfo = cchetextoff
		end
	end

infoCheck = CXBox:new()
	:init(0, 0, 0, 0)
	:textfont(smallfont)
	:textcolor({1,0,0,1})
	:textpos("left")
	:movetext(-3, 8)
	:text("")
	:active(true)
	:attach(infoButton, 0,0,0,0)

infoCheck.Action = (function() -- start marker - marqueur de mise en fonction
	return
		function()
			display_info = not display_info
			selname = nil
			imageIndex = 1
			infoTextFrame.Visible = not(infoTextFrame.Visible)
			infoImageFrame.Visible = not(infoImageFrame.Visible)

			if infoCheck.Text == "|" then
				infoCheck.Text = ""
			else
				infoCheck.Text = "|"
			end

		end
	end) ()

------------- infoTextFrame ---------------------- -- window of displayed text
infoTextFrame = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.8})
	:fillcolor(csetbofill)
	:movable(false) -- ok
	:clickable(false) -- ok
	:visible(false) -- ok
	:attach(screenBox, 0, 30, width-infoTextFrameWidth, height-infoTextFrameHeight-30)

infoTextFrame.Customdraw =
	function(this)
----------added 04-05-2018 Gironde ---------------------------------------------
		if infoTextFrame_firstTickDone then
			if not(infoTextFrameCloseButtonDone) then
				infoTextFrameCloseButtonDone = true
				-- replaced the action by infoCheck.Action to close infoText and infoImage in the same time
				makeCloseButton(infoTextFrameCloseButton, infoTextFrame, infoCheck)
			end
		else
			infoTextFrame_firstTickDone = true
		end

		local sel = celestia:getselection()
		if selection then

			if newselection then
				seltext = infoText[selname]

				if seltext then

					if string.find(seltext, "\n") then
						-- Split the text into lines.
						if string.sub(seltext, -1) ~= "\n" then
							seltext = seltext.."\n"
						end
						seltext, nLines = string.gsub(seltext, "\n", "\n")
					end

					setInfoScrollbarVisibility(nLines)
					infoTextFrameWidth = getTextWidth(seltext) 
					infoTextFrameH = infoTextFrameHeight
				else
					infoScrollbarFrame.Visible = false
					infoTextFrameWidth = 0
					infoTextFrameH = 0
					if getImageIndexMax(sel:name()) == 0 then
						disableCheckBox(infoCheck)
					end
				end

				resetInfoScrollPos = true
				infoScroll = 0
			else
				resetInfoScrollPos = false
			end

			if seltext then
				lineCount = 0
				-- Display info Text.
				textlayout:setfont(smallfont)
				textlayout:setpos(this.lb+5, this.tb-15)
				textlayout:setlinespacing(normalfont:getheight())
				textlayout:setfontcolor(ctextinfo)

				for seltextline in string.gfind(seltext,"([^\n]*)\n") do

					if lineCount >= infoScroll and lineCount < nLinesMax+infoScroll then
						textlayout:println(seltextline)
					end
					lineCount = lineCount+1
				end
			end
		else
			disableCheckBox(infoCheck)

			if infoScrollbarFrame.Visible then
				infoScrollbarFrame.Visible = false
			end

			infoTextFrameWidth = 0
			infoTextFrameH = 0
		end

		infoTextFrame:attach(screenBox, 6, 390, width-infoTextFrameWidth-6, height-infoTextFrameH-390)
	end

infoScrollbarFrame = CXBox:new()
	:visible(true)
	:attach(infoTextFrame, infoTextFrameWidth-infoScrollbarFrameW-3, 10, 3, infoTextFrameHeight-10-infoScrollbarFrameH)

infoScrollbarFrame.Customdraw =
	function(this)
		-- We add the scrollButton on the second tick
		-- when bounds are getting updated.
		if infoScroll_firstTickDone then
			if not(infoScrollButtonDone) then -- here beginning secondTickDone
				infoScrollButtonDone = true -- put the value as true
				makeScrollButton(infoScrollUpButton, infoScrollDownButton, infoScrollbarFrame) -- display the buttons boutons
			end
		else
			infoScroll_firstTickDone = true
		end

		local lb3,bb3,rb3,tb3 =infoScrollbarFrame:bounds()
		local lb4,bb4,rb4,tb4 = infoScrollbarBox:bounds()
		infoScroll = math_round((tb3-tb4-3)/infoScrollCoeff)
		-- modified by Gironde 04-05-2018
		-- infoScrollbarFrame:attach(infoTextFrame, infoTextFrameWidth-infoScrollbarFrameW-3, 10, 3, infoTextFrameHeight-10-infoScrollbarFrameH)
		infoScrollbarFrame:attach(infoTextFrame, infoTextFrameWidth-infoScrollbarFrameW-3, 15, 3, infoTextFrameHeight-5-infoScrollbarFrameH)
	end

infoScrollbarBox = CXBox:new()
	:bordercolor(cbubordoff)
	:fillcolor(cscrollfill)
	:visible(true)
	:movable(true)
	:attach(infoScrollbarFrame, 0, (nLines-nLinesMax+1)*infoScrollCoeff, 0, 3)

infoScrollbarBox.Customdraw =
	function(this)
		if resetInfoScrollPos then
			if nLines < 100 then
				infoScrollCoeff = 10
			elseif nLines < 1000 then
				infoScrollCoeff = 85*math.log(nLines)/(nLines-nLinesMax)
			else
				infoScrollCoeff = 200/(nLines-nLinesMax)
			end
			infoScrollbarBoxH = infoScrollbarFrameH-6-(nLines-nLinesMax+2)*infoScrollCoeff
			infoScrollbarBox:attach(infoScrollbarFrame, 0, infoScrollbarFrameH-infoScrollbarBoxH-3-20, 0, 3)
		end
	end

------------------- infoImageFrame ---------------------

infoImageFrame = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.8})
	:movable(false)
	:active(false)
	:visible(false)
	:attach(screenBox, width-imageWidth-2, 0, 2, height-imageHeight)

infoImageFrame.Customdraw =
	function(this)

	local sel = celestia:getselection()
		if selection then
			if newselection then
				selname = sel:name()
				imageIndex = 1
				imageIndexMax = getImageIndexMax(sel:name())
				setInfoButtonVisibility(imageIndexMax)
				if imageIndexMax > 0 then
					displayimage = true
				else
					displayimage = false
				end
			end
		else
			displayimage = false
		end

		if displayimage then
			-- Move image out of the toolbar if there's no room.
			if virtualPadBox and padFrame.Visible and not(centerPad) then
				padHeight = padFrameH
			else
				padHeight = 0
			end
			if imageHeight > height - toolBoxHeight - padHeight then
				-- imdx = boxWidth + 4
				imdx = 40
			else
				imdx = 40
			end

			-- Load and display image.
			if not image[selname][imageIndex] then
				image[selname][imageIndex] = celestia:loadtexture(infoImage[selname][imageIndex])
			end
			if image[selname][imageIndex] then
				infoImageFrame:fillimage(image[selname][imageIndex])
				imageWidth, imageHeight = getImageSize(image[selname][imageIndex])
				infoImageFrame:attach(screenBox, 6, 0+imdy+3, width-imageWidth-6, height-imageHeight-imdy-3)
				infoPreviousButton:attach(infoImageFrame, 0, 0, imageWidth - 40, imageHeight - 40)
				infoNextButton:attach(infoImageFrame, imageWidth - 40, 0, 0, imageHeight - 40)
			end
		else
			if infoPreviousButton.Visible then
				infoPreviousButton.Visible = false
				infoNextButton.Visible = false
			end
			if infoImageFrame.Fillimage then
				infoImageFrame.Fillimage = nil
			end
			infoImageFrame:attach(screenBox, width, 0, 0, height)
		end
	end

infoPreviousButton = CXBox:new()
	:init(0,0,0,0)
	--  :bordercolor(cbubordoff)
	:fillimage(infoButton1)
	:movable(false)
	:active(true)
	:visible(true)
	:attach(infoImageFrame, 0, 0, imageWidth - 40, imageHeight - 40)

infoPreviousButton.Action = (function()
	return
		function()
			imageIndex = imageIndex - 1
			if not(infoImage[selname][imageIndex]) then
				imageIndex = imageIndexMax
			end
		end
	end) ()

infoNextButton = CXBox:new()
	:init(0,0,0,0)
	--:bordercolor(cbubordoff)
	:fillimage(infoButton2)
	:movable(false)
	:active(true)
	:visible(true)
	:attach(infoImageFrame, imageWidth - 40, 0, 0, imageHeight - 40)

infoNextButton.Action = (function()
	return
		function()
			imageIndex = imageIndex + 1
			if not(infoImage[selname][imageIndex]) then
				imageIndex = 1
			end
		end
	end) ()

closeInImButton = CXBox:new()
	:init(0, 0, 0, 0)
	-- :bordercolor(cbubordoff)
	:textfont(smallfont)
	:textcolor({1,0,0,0.8})
	:textpos("left")
	:movetext(1, 12)
	:text("x")
	:movable(false)
	:active(true)
	:attach(infoImageFrame, 0, imageHeight-15, 2, 2)

-- Can not use the CloseButton function because the images change size by the right here, the close button should be on the left.
closeInImButton.Action = (function()
	return
		function()
		-- replaced by infoCheck.Action to close infoText and infoImage in the same time
		-- modified by Gironde 04-05-2018  
			infoCheck.Action ()
		end
	end) ()

--===============================================================================

-- =====================================
-- information angle
-- =====================================
AnglesButton = CXBox:new()
		:init(0, 0, 0, 0)
		:bordercolor(cbubordoff)
		:fillcolor(cFrameFill)
		:textfont(smallfont)
		:textcolor(cbutextoff)
		:textpos("left")
		:movetext(1, 7)
		:text(_("Angles"))
		:movable(false)
		:active(true)
	:attach(panel3Frame, 3, 2+17*(gg-6), 125, 3+17*6)

AnglesCheck = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 5, 2+17*(gg-6), 175, 3+17*6)

AnglesButton.Action = (function()
		return
			function()
			  display_Angles = not display_Angles
				if display_Angles then
					actual_overlaytab = celestia:getoverlayelements()
					-- create and initialize table first
					overlaytab = {}
					overlaytab.Selection = true	-- the upper left
					overlaytab.Velocity = true	-- speed
					overlaytab.Frame = false	-- fov
					overlaytab.Time = false 	-- time
					celestia:setoverlayelements(overlaytab)
					AnglesCheck.Text = "|"
				else
					celestia:setoverlayelements{Velocity = false, Selection = false, Frame = false}
					AnglesCheck.Text = ""
				end
			end
		end) ()

-- =====================================
-- Atmosphere
-- =====================================
panel317Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor(cbubordoff)
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({1,1,1,0.7})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Atmospher."))
	:movable(false)
	:active(true)
	:attach(panel3Frame, 3, 2+17*(gg-7), 125, 3+17*7)

panel317Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 5, 2+17*(gg-7), 175, 3+17*7)

panel317Button.Action = (function()
		return
			function()
			  display_panel317 = not display_panel317
				if display_panel317 then
					celestia:hide("atmospheres")
					panel317Check.Text = "|"
				else
					celestia:show("atmospheres")
					panel317Check.Text = ""
				end
			end
		end) ()

-- =====================================
-- Clouds
-- =====================================
panel318Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor(cbubordoff)
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({1,1,1,0.7})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Cloud maps"))
	:movable(false)
	:active(true)
	:attach(panel3Frame, 3, 2+17*(gg-8), 125, 3+17*8)

panel318Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 5, 2+17*(gg-8), 175, 3+17*8)

panel318Button.Action = (function()
		return
			function()
			  display_panel318 = not display_panel318
				if display_panel318 then
					celestia:hide("cloudmaps")
					panel318Check.Text = "|"
				else
					celestia:show("cloudmaps")
					panel318Check.Text = ""
				end
			end
		end) ()

-- =====================================
-- cloud Shadows
-- =====================================
panel319Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor(cbubordoff)
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({1,1,1,0.7})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Cloud shadows"))
	:movable(false)
	:active(true)
	:attach(panel3Frame, 3, 2+17*(gg-9), 95, 3+17*9)

panel319Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 5, 2+17*(gg-9), 175, 3+17*9)

panel319Button.Action = (function()
		return
			function()
			  display_panel319 = not display_panel319
				if display_panel319 then
					celestia:show("cloudshadows")
					panel319Check.Text = "|"
				else
					celestia:hide("cloudshadows")
					panel319Check.Text = ""
				end
			end
		end) ()

-- =====================================
-- Ecliptic grid
-- =====================================
panel323Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({0.2,0.8,1,1})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Ecl. grid"))
	:movable(false)
	:active(true)
	:attach( panel3Frame, 64, 2+17*(gg-3), 64, 3+17*3)

panel323Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 64+2, 2+17*(gg-3), 64+50, 3+17*3)

panel323Button.Action = (function()
		return
			function()
			  display_panel323 = not display_panel323
				if display_panel323 then
					celestia:show("eclipticgrid")
					panel323Check.Text = "|"
				else
					celestia:hide("eclipticgrid")
					panel323Check.Text = ""
				end
			end
		end) ()
-- =====================================
-- Ecliptic
-- =====================================
panel324Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({0.2,0.8,1,1})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Ecliptic "))
	:movable(false)
	:active(true)
	:attach( panel3Frame, 64, 2+17*(gg-4), 64, 3+17*4)

panel324Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 64+2, 2+17*(gg-4), 64+50, 3+17*4)

panel324Button.Action = (function()
		return
			function()
			  display_panel324 = not display_panel324
				if display_panel324 then
					celestia:show("ecliptic")
					panel324Check.Text = "|"
				else
					 celestia:hide("ecliptic")
					panel324Check.Text = ""
				end
			end
		end) ()

-- =====================================
-- North Pole
-- =====================================
NorthButton = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(normalfont)
	:textcolor({0.3,0.3,1,1})
	:textpos("left")
	:movetext(-3, 7)
	:text("N")
	:movable(false)
	:active(true)
	:attach(panel3Frame, 64, 2+17*(gg-5), 110, 3+17*5)

NorthButton.Action = (function()
		return
			function()
				  -- Positioning at longitude = 0° latitude = 90° of selected object
				 if selection then
					local now = celestia:gettime() -- celestia actual time
					local sel = celestia:getselection() -- the actual selected object
					local objectpos = sel:getposition(now) -- object position
					local obs = celestia:getobserver()  -- camera
					local obspos = obs:getposition()	-- camera position
					obs:synchronous(sel) -- coordinate system
					local longitude = math.rad(180) -- longitude in radian
					local latitude = math.rad(90) -- latitude in radian
					obs:gotolonglat(sel, longitude, latitude, obspos:distanceto(objectpos), 1.0,celestia:newvector(0,1,0)) -- vector of movement
				obs:setlocationflags{observatory = true}
			  --  celestia:setlabelflags{locations = true} -- enable locations
				end
			end
		end) ()
	
-- =====================================
-- Zero Positioning at longitude = 0° 
-- latitude = 0° of selected object
-- =====================================
ZeroButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,0.5,0.5,.5})
    :fillcolor(cFrameFill)
    :textfont(normalfont)						
    :textcolor({0.2,0.8,1,1})
    :textpos("left")
    :movetext(-1, 7) 					
    :text("0°0°")  
    :movable(false)
    :active(true)
    :attach(panel3Frame, 64+20-6, 2+17*(gg-5), 64+20-6, 3+17*5)

ZeroButton.Action = (function()
        return
            function()
                  -- Positioning at longitude = 0° latitude = 0° of selected object
                 if selection then
                    local now = celestia:gettime() -- celestia actual time
                    local sel = celestia:getselection() -- the actual selected object
                    local objectpos = sel:getposition(now) -- object position
                    local obs = celestia:getobserver()  -- camera
                    local obspos = obs:getposition()    -- camera position
                    obs:synchronous(sel) -- coordinate system                  
                    local longitude = math.rad(0.001) -- longitude in radian
                    local latitude = math.rad(0.001) -- latitude in radian
                    obs:gotolonglat(sel, longitude, latitude, obspos:distanceto(objectpos), 1.0,celestia:newvector(0,1,0)) -- vector of movement
                obs:setlocationflags{observatory = true} -- point location 0° - 0° in Earth-Cities_locs.ssc type = observatory
              --  celestia:setlabelflags{locations = true} -- enable locations
                end
            end
        end) (); 
-- =====================================
-- South Pole
-- =====================================
SouthButton = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(normalfont)
	:textcolor({1,0,0,0.8})
	:textpos("left")
	:movetext(-2, 7)
	:text("S")
	:movable(false)
	:active(true)
	:attach(panel3Frame, 110, 2+17*(gg-5), 64, 3+17*5)

SouthButton.Action = (function()
	return
		function()
		-- Positioning at longitude = 0° latitude = -90° of selected object
			if selection then
				local now = celestia:gettime() -- celestia actual time
				local sel = celestia:getselection() -- the actual selected object
				local objectpos = sel:getposition(now) -- object position
				local obs = celestia:getobserver()  -- camera
				local obspos = obs:getposition()	-- camera position
				obs:synchronous(sel) -- coordinate system
				local longitude = math.rad(180) -- longitude in radian
				local latitude = math.rad(-90) -- latitude in radian
				obs:gotolonglat(sel, longitude, latitude, obspos:distanceto(objectpos), 1.0,celestia:newvector(0,1,0)) -- vector of movement
				obs:setlocationflags{observatory = true}
				--  celestia:setlabelflags{locations = true} -- enable locations
			end
		end
	end) ()

-- =====================================
-- Color stars
-- =====================================
starcolorButton = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({1,1,1,0.7})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Color stars"))
	:movable(false)
	:active(true)
	:attach( panel3Frame, 64, 2+17*(gg-6), 64, 3+17*6)

starcolorCheck = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 64+2, 2+17*(gg-6), 64+50, 3+17*6)

starcolorButton.Action = (function()
		return
			function()
				  display_starcolor = not display_starcolor
				  if display_starcolor then
				--  if celestia:getstarscolor() == "enhanced" then
					celestia:setstarscolor("blackbody_d65")
					starcolorCheck.Text = "|"
				else
					celestia:setstarscolor("enhanced")
					starcolorCheck.Text = ""
				end
			end
		end) ()

-- =====================================
-- Eclipse
-- =====================================
panel327Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({1,1,1,0.7})
	:textpos("left")
	:movetext(2, 7)
	:text(_("Eclipse"))
	:movable(false)
	:active(true)
	:attach( panel3Frame, 64, 2+17*(gg-7), 64, 3+17*7)

panel327Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 64+2, 2+17*(gg-7), 64+50, 3+17*7)

panel327Button.Action = (function()
		return
			function()
			  display_panel327 = not display_panel327
			   if display_panel327 then
					panel327Check.Text = "|"
					celestia:show("eclipseshadows")
				else
					 celestia:hide("eclipseshadows") -- ???? ????????
					panel327Check.Text = ""
				end
			end
		end) ()

-- ====================================
-- The tails of comets
-- ====================================
panel328Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor(cbubordoff)
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({1,1,1,0.7})
	:textpos("left")
	:movetext(2, 7)
	:text(_("Comet tails"))
	:movable(false)
	:active(true)
	:attach( panel3Frame, 64, 2+17*(gg-8), 64, 3+17*8)

panel328Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 64+2, 2+17*(gg-8), 64+50, 3+17*8)

panel328Button.Action = (function()
		return
			function()
			  display_panel328 = not display_panel328
				if display_panel328 then
					celestia:show("comettails")
					panel328Check.Text = "|"
				else
					celestia:hide("comettails")
					panel328Check.Text = ""
				end
			end
		end) ()

-- =====================================
-- Shadows on the rings
-- =====================================
panel329Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({1,1,1,0.7})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Shadows on rings"))
	:movable(false)
	:active(true)
	:attach( panel3Frame, 95, 2+17*(gg-9), 3, 3+17*9)

panel329Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 95+2, 2+17*(gg-9), 3+80, 3+17*9)

panel329Button.Action = (function()
		return
			function()
			  display_panel329 = not display_panel329
				if display_panel329 then
					celestia:show("ringshadows")
					panel329Check.Text = "|"
				else
					celestia:hide("ringshadows")
					panel329Check.Text = ""
				end
			end
		end) ()

-- =====================================
-- Galactic grid
-- =====================================
panel333Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({0.2,0.8,1,1})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Gal. grid"))
	:movable(false)
	:active(true)
	:attach( panel3Frame, 125, 2+17*(gg-3), 3, 3+17*3)

panel333Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 126, 2+17*(gg-3), 3+50, 3+17*3)

panel333Button.Action = (function()
		return
			function()
			  display_panel333 = not display_panel333
				if display_panel333 then
					celestia:show("galacticgrid")
					panel333Check.Text = "|"
				else
					celestia:hide("galacticgrid")
					panel333Check.Text = ""
				end
			end
		end) ()

-- =====================================
-- Tags
-- =====================================
panel334Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({0.2,0.8,1,1})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Markers"))
	:movable(false)
	:active(true)
	:attach( panel3Frame, 125, 2+17*(gg-4), 3, 3+17*4)

panel334Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-5, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 126, 2+17*(gg-4), 3+50, 3+17*4)

panel334Button.Action = (function()
		return
			function()
			  display_panel334 = not display_panel334
				if display_panel334 then
					celestia:hide("markers")
					panel334Check.Text = ""
				else
				   celestia:show("markers")
				   panel334Check.Text = "|"
				end
			end
		end) ()

-- =====================================
-- Distance scale
-- =====================================
-- distanceBox.lua
----------------------------------------
-- Define local functions
----------------------------------------
local ndigits = function(number)
	-- Return the number of digits in a number.
	local ndigits = 0
	while number >= 1 do
		ndigits = ndigits + 1
		number = number/10
	end
	return ndigits
end

local crossProduct = function(v1, v2)
	-- Return the Vector Cross Product of two vectors.
	local vcpx = v1.y * v2.z - v1.z * v2.y
	local vcpy = v2.x * v1.z - v1.x * v2.z
	local vcpz = v1.x * v2.y - v1.y * v2.x
	local vcp = celestia:newvector(vcpx, vcpy, vcpz)
	return vcp
end

local setDistLabelStr = function(k)
	local distlabel_str = ""
	if k <= 2 then
		distlabel_str = string.format("%g", math.pow(10, k))
	else
	 distlabel_str = "10^"..k
	end
	return distlabel_str
end

local setDistMarkerAlpha = function(marker_size_pix)
	local distMarkerAlpha = 0.9
	if marker_size_pix < 100 then
		distMarkerAlpha = 0.9 * marker_size_pix / 100
	end
	return distMarkerAlpha
end

local findNewAngle = function(r, larger)
	local sel = celestia:getselection()
	local obs = celestia:getobserver()

	local o = (KM_PER_LY/1e6) * (obs:getposition() - sel:getposition())
	local d = o:length()
	local tangent_angle = math.asin(sel:radius()/d)
	local a = math.pi - tangent_angle - math.asin(d*math.sin(tangent_angle)/r)

	local angle1 = (2*math.asin(d*math.cos(a)/math.sqrt(o.x*o.x + o.z*o.z))-(math.abs(o.x)/o.x)*math.pi+2*(math.atan(o.z/o.x)))/2
	local angle2 = -1*(2*math.asin(d*math.cos(a)/math.sqrt(o.x*o.x + o.z*o.z))+(math.abs(o.x)/o.x)*math.pi-2*(math.atan(o.z/o.x)+math.pi))/2

	if larger then
		return angle1
	else
		return angle2
	end
end

-- Draw distance square-markers in the observer's plane (centered on screen).
local drawDistMarkerInObsPlane = function(marker_size)
	local sel = celestia:getselection()
	local obs = celestia:getobserver()

	local distFov = obs:getfov()
	local distFovRatio = math.tan(distFovCoeff/2)/math.tan(distFov/2)

	local obs_direction = (celutil.rotation_transform(celestia:newvector(0,0,-1),obs:getorientation())):normalize()
	local obs_sel = (KM_PER_LY/1e6) * (sel:getposition() - obs:getposition())
	local dist_to_sel = celutil.get_dist(obs, sel)

	local obs_sel_angle = math.atan(marker_size/dist_to_sel)
	local a = 2*height*distFovRatio*math.tan(obs_sel_angle)
	local centerX, centerY = width/2, height/2

	-- Draw distance square markers
	gl.Vertex(centerX-a, centerY-a)
	gl.Vertex(centerX-a, centerY+a)
	gl.Vertex(centerX+a, centerY+a)
	gl.Vertex(centerX+a, centerY-a)

	-- Set distance label position.
	distLabelXPos, distLabelYPos = centerX + a + 5, centerY+a+5
end

-- Draw distance circle-markers in the ecliptic plane (centered on the current selection).
-- TODO: Optimize the rendering of distance circle-markers using the symmetry of ellipse.
local drawDistMarkerInEclipticPlane = function(marker_size)
	local sel = celestia:getselection()
	local sel_pos  = sel:getposition()
	local obs = celestia:getobserver()
	local obs_sel_vect = (KM_PER_LY/1e6) * (sel:getposition() - obs:getposition())
	local obs_direction = (celutil.rotation_transform(celestia:newvector(0, 0, -1), obs:getorientation())):normalize()
	local obs_side = (celutil.rotation_transform(celestia:newvector(1, 0, 0), obs:getorientation())):normalize()
	local obs_up = (celutil.rotation_transform(celestia:newvector(0, 1, 0), obs:getorientation())):normalize()
	local sel_radius = sel:radius()
	local dist_to_sel = celutil.get_dist(obs,sel)
	local sel_app_angle = math.asin(sel_radius/dist_to_sel)

	local distFov = obs:getfov()
	local distFovRatio = math.tan(distFovCoeff/2)/math.tan(distFov/2)

	local last_angle =  math.pi
	local last_horizontal_angle = math.pi

	local centerX, centerY = width/2, height/2

	local infront_sel = false
	local repeat_infront = false

	local uframe = celestia:newframe("universal")
	local pos0 = celestia:newposition(0,0,0)
	angle_step = 360 / distance_marker_sample_points

	for angle = -180, 180, angle_step do
		vectorX = marker_size * math.cos(angle * degToRad)
		vectorY = 0
		vectorZ = marker_size * math.sin(angle * degToRad)
		vector = uframe:from(celestia:newposition(vectorX, vectorY, vectorZ)) - pos0
		vertex = (obs_sel_vect + vector):normalize()
		obs_sel_angle = math.acos(vertex * obs_direction)
		projection = crossProduct(obs_direction, crossProduct(vertex, obs_direction)):normalize()

		horizontal_angle = math.acos(projection * obs_side)
		if math.acos(projection * obs_up) > math.pi/2 then
			horizontal_angle = -horizontal_angle
		end
		if obs_sel_angle > math.pi/2 then
			obs_sel_angle = math.pi/2
		end

		infront_sel = math.acos(vertex * (obs_sel_vect:normalize())) < sel_app_angle and (obs_sel_vect + vector):length() > obs_sel_vect:length()

		if infront_sel ~= repeat_infront then
			new_angle = findNewAngle(marker_size, repeat_infront)

			vectorX = marker_size * math.cos(new_angle)
			vectorY = 0
			vectorZ = marker_size * math.sin(new_angle)

			vector = uframe:from(celestia:newposition(vectorX, vectorY, vectorZ)) - celestia:newposition(0,0,0)
			vertex = (obs_sel_vect + vector):normalize()
			new_obs_sel_angle = math.acos(vertex * obs_direction)
			projection = crossProduct(obs_direction, crossProduct(vertex, obs_direction)):normalize()

			new_horizontal_angle = math.acos(projection * obs_side)
			if math.acos(projection * obs_up) > math.pi/2 then
				new_horizontal_angle = -new_horizontal_angle
			end
			if new_obs_sel_angle > math.pi/2 then
				new_obs_sel_angle = math.pi/2
			end

			if repeat_infront then
				last_angle = new_obs_sel_angle
				last_horizontal_angle = new_horizontal_angle
			else
				obs_sel_angle = new_obs_sel_angle
				horizontal_angle = new_horizontal_angle
			end

			repeat_infront = not(repeat_infront)
			infront_sel = false
		end

		if last_angle < math.pi and not(infront_sel) then
			local a = 2 * height * distFovRatio * math.tan(obs_sel_angle)
			local b = 2 * height * distFovRatio * math.tan(last_angle)
			local x1 = a * math.cos(horizontal_angle)
			local y1 = a * math.sin(horizontal_angle)
			local x2 = b * math.cos(last_horizontal_angle)
			local y2 = b * math.sin(last_horizontal_angle)

			gl.Vertex(centerX + x1,	centerY + y1)
			gl.Vertex(centerX + x2,	centerY + y2)

			--if angle >= 180 - angle_step then
				distLabelXPos = centerX + x1 + 5
				distLabelYPos = centerY + y1 + 5
			--end
		else
				distLabelXPos = nil
				distLabelYPos = nil
		end

		last_angle = obs_sel_angle
		last_horizontal_angle = horizontal_angle
	end
end

-- Draw distance markers.
local drawDistanceMarker = function(marker_size, unit_str, k)
	local obs = celestia:getobserver()
	local distFov = obs:getfov()
	local pix_size = 2 * math.tan(distFov / 2) / height
	local sel = celestia:getselection()
	local dist_to_sel = celutil.get_dist(obs, sel)

	local marker_size_pix = marker_size / (dist_to_sel * pix_size)
	if marker_size_pix > 10 and marker_size_pix < (6 * height) then
		distMarkerAlpha[k] = setDistMarkerAlpha(marker_size_pix)
		distMarkerColor = {cdistmark[1], cdistmark[2], cdistmark[3], cdistmark[4] * distMarkerAlpha[k]}

		if celestia:getrenderflags().smoothlines then
			enableSmoothLines()
		end

		if (distance_marker_mode == "ecliptic" or distance_marker_mode == "both") and (k < 5 or unit_str ~= "ly") then
			gl.Color(distMarkerColor[1], distMarkerColor[2], distMarkerColor[3], distMarkerColor[4] * alpha * opacity)
			gl.Disable(gl.TEXTURE_2D)
			gl.Begin(gl.LINES)
			drawDistMarkerInEclipticPlane(marker_size)
			gl.End()

			if distLabelXPos and distLabelYPos then
				distlabel_str = setDistLabelStr(k)
				textlayout:setfont(normalfont)
				textlayout:setfontcolor(distMarkerColor)
				textlayout:setpos(distLabelXPos, distLabelYPos)
				if k <= 2 then
					textlayout:println(string.format("%g", math.pow(10, k))..' '.._(unit_str))
				else
					textlayout:println("10 "..'  '.._(unit_str))
					textlayout:setfont(smallfont)
					textlayout:setpos(distLabelXPos + 14, distLabelYPos + 8)
					textlayout:println(k)
				end
			end
		end

if distance_marker_mode == "observer" or distance_marker_mode == "both" then
			gl.Color(distMarkerColor[1], distMarkerColor[2], distMarkerColor[3], distMarkerColor[4] * alpha * opacity)
			gl.Disable(gl.TEXTURE_2D)
			gl.Begin(gl.LINE_LOOP)
			drawDistMarkerInObsPlane(marker_size)
			gl.End()

			if distLabelXPos and distLabelYPos then
				distlabel_str = setDistLabelStr(k)
				textlayout:setfont(normalfont)
				textlayout:setfontcolor(distMarkerColor)
				textlayout:setpos(distLabelXPos, distLabelYPos)
				if k <= 2 then
					textlayout:println(string.format("%g", math.pow(10, k))..' '.._(unit_str))
				else
					textlayout:println("10 "..'  '.._(unit_str))
					textlayout:setfont(smallfont)
					textlayout:setpos(distLabelXPos + 14, distLabelYPos + 8)
					textlayout:println(k)
				end
			end
		end

		if celestia:getrenderflags().smoothlines then
			disableSmoothLines()
		end

	end
end
----------------------------------------
-- Set initial values
----------------------------------------
cDistance = ctext
distance_first_tick = true

-- Set the distance markers sample points.
distance_marker_sample_points = 90

distMarkerAlpha = {}

local distZoomToRad = 0.234
distFovCoeff = 2/3*math.pi*distZoomToRad

----------------------------------------
-- Set up and Draw the boxes
----------------------------------------
distanceButton = CXBox:new()
	   :init(0, 0, 0, 0)
	   :bordercolor({0, 0.5, 0.5, 0.5})
	   :fillcolor(cFrameFill)
	   :textfont(smallfont)
	   :textcolor(cbutextoff)
	   :textpos("left")
	   :movetext(5, 7)
	   :text(_("D.Markers"))
	   :movable(false)
	   :active(true)
       :attach( panel3Frame, 125, 2+17*(gg-5), 3, 3+17*5)

distanceCheck = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,.8})
		:textpos("left")
		:movetext(-4, 7)
		:text("")
		:movable(false)
		:active(true)
		:attach( panel3Frame, 126, 2+17*(gg-5), 3, 3+17*5)

distanceCheck.Customdraw =
	function(this)
		----------------------------------------------------------------------
		-- Set the initial state of the check-box from 'config.lua'.
		----------------------------------------------------------------------
		if distance_first_tick then

			if distance_state == 1 then
			   distanceCheck.Text = "="

			elseif distance_state == 2 then
			   distanceCheck.Text = "1"

			elseif distance_state == 3 then
			   distanceCheck.Text = "2"

			else
			   distanceCheck.Text = "3"

		end
			distanceCheck.Action()
		end
		distance_first_tick = false
		-------------------------------------------------------------------
		-- Get number of views.
		-------------------------------------------------------------------
		local tobs = celestia:getobservers()
		local nobs = table.getn(tobs)
		if nobs > 1 then
			---------------------------------------------------------------
			-- Disable distance markers in multiple views layout.
			---------------------------------------------------------------
			disableCheckBox(distanceCheck)
			cDistance = cchetextoff
			distanceFrame.Visible = false
		else
			enableCheckBox(distanceCheck)
			cDistance = ctext
			if distanceCheck.Text ~= "=" then
				distanceFrame.Visible = true
			end
		end
	end

distanceCheck.Action = (function()
		return
			function()
				if distanceCheck.Text == "=" then
					distanceFrame.Visible = true
					distanceCheck.Text = "1"
					distance_marker_mode = "observer"

				elseif distanceCheck.Text == "1" then
					distanceCheck.Text = "2"
					distance_marker_mode = "ecliptic"

				elseif distanceCheck.Text == "2" then
					distanceCheck.Text = "3"
					distance_marker_mode = "both"

				elseif distanceCheck.Text == "3"  then
					distanceFrame.Visible = false
				   distanceCheck.Text = "="
				end
			end
		end) ()
-- ==================
distanceFrame = CXBox:new()
	:init(0, 0, 0, 0)
	:active(false)
	:movable(false)
	:clickable(true)
	:visible(false)
	:attach(screenBox, 0, 0, width, height)

distanceFrame.Customdraw =
	function(this)
		local sel = celestia:getselection()
		local sel_radius = sel:radius()

		for k = ndigits(sel_radius * 1e3), 2 do
			-- Set the size of the "m" distance markers in pixel.
			local m_size = math.pow(10, k) * 1e-3
			-- Draw the "m" distance markers.
			drawDistanceMarker(m_size, "m", k)
		end

		for k = ndigits(sel_radius), 8 do
			-- Set the size of the "km" distance markers in pixel.
			local km_size = math.pow(10, k)
			-- Draw the "km" distance markers.
			drawDistanceMarker(km_size, "km", k)
		end

		for k = ndigits(sel_radius / KM_PER_AU), 3 do
			-- Set the size of the "AU" distance markers in pixel.
			local au_size = math.pow(10, k) * KM_PER_AU
			-- Draw the "AU" distance markers.
			drawDistanceMarker(au_size, "AU", k)
		end

		for k = ndigits(sel_radius / KM_PER_LY), 9 do
			-- Set the size of the "ly" distance markers in pixel.
			local ly_size = math.pow(10, k) * KM_PER_LY
			-- Draw the "ly" distance markers.
			drawDistanceMarker(ly_size, "ly", k)
		end

		-- Keep the size of distanceFrame null. Otherwise, active buttons
		-- wouldn't work when distanceFrame is drawn in front of them.
		distanceFrame:attach(screenBox, 0, 0, width, height)
	end

-- =============================================
-- "Style Star" (moved from the "View Settings")
-- =============================================
local setStarStyleRadioButtonText = function(s)
	if s =="point" then
		  starStyleCheck.Text = "1"
	elseif s ==  "fuzzy" then
		  starStyleCheck.Text = "2"
	elseif s == "disc" then
		  starStyleCheck.Text = "3"
	end
end
-------------------------------------------------
starStyleButton = CXBox:new()
		:init(0, 0, 0, 0)
		:bordercolor(cbubordoff)
		:fillcolor(cFrameFill)
		:textfont(smallfont)
		:textcolor({1,1,1,0.7})
		:movetext(5, 7)
		:text(_("Star Style"))
		:movable(false)
		:active(true)
		:attach( panel3Frame, 125, 2+17*(gg-6), 3, 3+17*6)

starStyleCheck = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,.8})
		:textpos("left")
		:movetext(-4, 7)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 126, 2+17*(gg-6), 3+50, 3+17*6)

setStarStyleRadioButtonText(starstyle)

starStyleButton.Customdraw =
	function(this)
		if starstyle ~= celestia:getstarstyle() then
		   starstyle = celestia:getstarstyle()
		   setStarStyleRadioButtonText(starstyle)
		end
	end

starStyleButton.Action = (function()
		return
			function()
				if starstyle == "disc" then
					starstyle = "point"
				elseif starstyle == "point" then
					starstyle = "fuzzy"
				elseif starstyle == "fuzzy" then
					starstyle = "disc"
				end
				celestia:setstarstyle(starstyle)
				setStarStyleRadioButtonText(starstyle)
			end
		end) ()

-- =====================================
-- Textures
-- =====================================
textureResButton = CXBox:new()
		:init(0, 0, 0, 0)
		:bordercolor({0,0.5,0.5,.5})
		:fillcolor(cFrameFill)
		:textfont(smallfont)
		:textcolor(cbutextoff)
		:textpos("left")
		:movetext(5, 7)
		:text(_("Textures"))
		:movable(false)
		:active(true)
		:attach( panel3Frame, 125, 2+17*(gg-7), 3, 3+17*7)

textureResCheck = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-4, 7)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 126, 2+17*(gg-7), 3+50, 3+17*7)

textureResCheck.Text = celestia:gettextureresolution()

textureResButton.Customdraw =
	function(this)
		if textureRes ~= celestia:gettextureresolution() then
			textureRes = celestia:gettextureresolution()
			textureResCheck.Text = (textureRes +1) -- +1 pour afficher 1 ou 2 ou 3 … la place de 0,1,2
		end
	end

textureResButton.Action = (function()
		return
			function()
			   if textureRes == 2 then
				  textureRes = 0
			   else
				  textureRes = textureRes + 1
			   end
				  celestia:settextureresolution(textureRes)
				 textureResCheck.Text = (textureRes + 1) -- +1 pour afficher 1 ou 2 ou 3 … la place de 0,1,2
			end
		end) ()

-- =====================================
-- Night party
-- =====================================
panel338Button = CXBox:new()
	:init(0, 0, 0, 0)
	:bordercolor({0,0.5,0.5,.5})
	:fillcolor(cFrameFill)
	:textfont(smallfont)
	:textcolor({1,1,1,0.7})
	:textpos("left")
	:movetext(1, 7)
	:text(_("Hightmaps"))
	:movable(false)
	:active(true)
	:attach( panel3Frame, 125, 2+17*(gg-8), 3, 3+17*8)

panel338Check = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(smallfont)
		:textcolor({1,0,0,1})
		:textpos("left")
		:movetext(-4, 8)
		:text("")
		:movable(false)
		:active(true)
		:attach(panel3Frame, 126, 2+17*(gg-8), 3+50, 3+17*8)

panel338Button.Action = (function()
		return
			function()
			  display_panel338 = not display_panel338
				if display_panel338 then
					celestia:show("nightmaps")
					panel338Check.Text = "|"
				else
					celestia:hide("nightmaps")
					panel338Check.Text = ""
				end
			end
		end) ()
