--======================================
-- renderLocsBox -- render of locations
-- Author - Patrick Ziegler a.k.a. Gironde 10.03.2017 
-- Integration by Lygin Gennady a.k.a Croc 18.04.2017
-- Edit by Patrick Ziegler a.k.a. Gironde 20-04-2017
-- modified by Patrick Ziegler a.k.a. Gironde 17-07-2017
-- version Lite by Lygin Gennady a.k.a Croc 18-09-2017
--======================================
require "config"
require "locale"
require "closeButton"
-----------------------------------
--  Set initial values
-----------------------------------
local newwidth3, newheight3
local locsLabelBoxWidth, locsLabelBoxHeight = 100, 20
local nlines = 20+1 +1 -- + 1 by Gironde 17-07-2017 -- Never +0 because this distorts the cursor
--local gg=nlines-1 -- its not used now -- Gironde 17-07-2017
local addwidth = 170 -- offset for each column
local renderLocsFrameWidth, renderLocsFrameHeight = 170*3, (20 * nlines)+40
local renderlocsLeftMargin = 10
local obs = celestia:getobserver()
local tableflag = obs:getlocationflags()

celestia:setminfeaturesize(22) -- Set at 22 at the start

local CheckResetPressed = true -- flag for Reset button

-- ============================= Переменные для LITE ===========================================

local Namecolor = {0.2,0.8,1,0.7} -- Color of the name of the type of location / цвет шрифта наименования типа локации
local Quadrocolor1 = cbutextoff -- Color checkbox locations with direct control (without Earth) / Цвет checkbox локаций c прямым управлением (без Земли)
local Quadrocolor2 = {0,0.4,1,1} -- Color checkbox locations with direct control (for Earth) / Цвет checkbox локаций c прямым управлением (для Земли)
local Quadrocolor3 = cbubordoff -- Color checkbox locations with indirect control (inactive) / Цвет checkbox локаций c косвенным управлением 

--============================= -- for detection of change of object ============================
local obj = celestia:getselection() -- added by Gironde 26-08-2017
local nameobj = obj:name() -- added by Gironde 26-08-2017
local lastobj = celestia:getselection() -- added by Gironde 26-08-2017
local namelastobj = lastobj:name() -- added by Gironde 26-08-2017
--=============== Marking according to the object -- added by Gironde 28-06-2017 =================
local obj = celestia:getselection() -- added by Gironde 28-06-2017
local makeflagLocs = function(obj)
    local name = obj:name()

    for k,v in pairs(ObjectsLocs) do -- k: index name of a table v: value in a finded table, the loop stop when value is nil (ObjectsLocs): principal table
        this = renderLocsFrame
        if k == name then -- when find the observed object as name of a table
            findedtable = ObjectsLocs[k]
            for kk,vv in pairs (findedtable) do -- search each value in finded table
                
                -- here, work with this type ------------------
                textlayout:setfontcolor({1,0,0,0.4})
                    textlayout:setpos(this.lb+4+125*3, this.tb -23-5- 20*22) -- для примечания внизу панели
                    textlayout:println(_("o"))				
                textlayout:setfontcolor({1,0,0,1})
                -- FOR CROC renderLocsBox
                -- COLONNE 1

                if vv == "AA" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*1) -- Croc AA
                    textlayout:println(_("o"))
                elseif vv == "AL" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*2) -- Croc AL
                    textlayout:println(_("o")) 
                elseif  vv == "AR" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*3) -- Croc AR
                    textlayout:println(_("o")) 
                elseif  vv == "AS" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*4) -- Croc AS
                    textlayout:println(_("o")) 
                elseif vv == "CA" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*5) -- Croc CA
                    textlayout:println(_("o")) 
                elseif vv == "CB" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*6) -- Croc CB
                    textlayout:println(_("o")) 
                elseif vv == "CH" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*7) -- Croc CH
                    textlayout:println(_("o")) 
                elseif vv == "CM" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*8) -- Croc CM
                    textlayout:println(_("o")) 
                elseif vv == "CO" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*9) -- Croc CO
                    textlayout:println(_("o")) 
                elseif vv == "CR" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*10) -- Croc CR
                    textlayout:println(_("o")) 
                elseif vv == "DO" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*11) -- Croc DO
                    textlayout:println(_("o")) 
                elseif vv == "ER" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*12) -- Croc ER
                    textlayout:println(_("o")) 
                elseif vv == "FA" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*13) -- Croc FA
                    textlayout:println(_("o"))
                elseif vv == "FE" then -- "FR"
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*14) -- Croc FR
                    textlayout:println(_("o"))
                elseif vv == "FL" then -- "FE"
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*15) -- Croc FE
                    textlayout:println(_("o"))
                elseif vv == "FM" then -- "FL" 
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*16) -- Croc FL
                    textlayout:println(_("o"))
                elseif vv == "FO" then -- "FM"
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*17) -- Croc FM
                    textlayout:println(_("o"))
                elseif vv == "FR" then -- "FO"
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*18) -- Croc FO
                    textlayout:println(_("o"))
                elseif vv == "FT" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*19) -- Croc FT
                    textlayout:println(_("o"))
                elseif vv == "IN" then
                    textlayout:setpos(this.lb+4, this.tb -23 - 20*20) -- Croc IN
                    textlayout:println(_("o"))
                -- COLONNE 2
                elseif vv == "LA" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*1) -- Croc LA
                    textlayout:println(_("o"))
                elseif vv == "LB" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*2) -- Croc LB
                    textlayout:println(_("o"))
                elseif vv == "LC" then -- "LU"
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*3) -- Croc LU
                    textlayout:println(_("o"))
                elseif vv == "LE" then -- "LC"
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*4) -- Croc LC
                    textlayout:println(_("o"))
                elseif vv == "LF" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*5) -- Croc LF
                    textlayout:println(_("o"))
                elseif vv == "LG" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*6) -- Croc LG
                    textlayout:println(_("o"))
                elseif vv == "LI" then -- "LE"
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*7) -- Croc LE
                    textlayout:println(_("o"))
                elseif vv == "LN" then -- "LI"
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*8) -- Croc LI
                    textlayout:println(_("o"))
                elseif vv == "LU" then -- "LN"
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*9) -- Croc LN
                    textlayout:println(_("o"))
                elseif vv == "MA" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*10) -- Croc MA
                    textlayout:println(_("o"))
                elseif vv == "ME" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*11) -- Croc ME
                    textlayout:println(_("o"))
                elseif vv == "MN" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*12) -- Croc MN
                    textlayout:println(_("o"))
                elseif vv == "MO" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*13) -- Croc MO
                    textlayout:println(_("o"))
                elseif vv == "OC" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*14) -- Croc OC
                    textlayout:println(_("o"))
                elseif vv == "PA" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*15) -- Croc PA
                    textlayout:println(_("o"))
                elseif vv == "PE" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*16) -- Croc PE
                    textlayout:println(_("o"))
                elseif vv == "PL" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*17) -- Croc PL
                    textlayout:println(_("o"))
                elseif vv == "PM" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*18) -- Croc PM
                    textlayout:println(_("o"))
                elseif vv == "PR" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*19) -- Croc PR
                    textlayout:println(_("o"))
                elseif vv == "PU" then
                    textlayout:setpos(this.lb+4+125, this.tb -23 - 20*20) -- Croc PU
                    textlayout:println(_("o"))
                -- COLONNE 3
                elseif vv == "RE" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*1) -- Croc RE
                    textlayout:println(_("o"))	
                elseif vv == "RI" then  
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*2) -- Croc RI
                    textlayout:println(_("o"))
                elseif vv == "RI" then -- "RG"
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*3) -- Croc RG
                    textlayout:println(_("o"))
                elseif vv == "RU" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*4) -- Croc RU
                    textlayout:println(_("o"))
                elseif vv == "SA" then 
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*5) -- Croc SA
                    textlayout:println(_("o"))					
                elseif vv == "SC" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*6) -- Croc SC
                    textlayout:println(_("o"))
                elseif vv == "SE" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*7) -- Croc SE
                    textlayout:println(_("o"))
                elseif vv == "SF" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*8) -- Croc SF
                    textlayout:println(_("o"))
                elseif vv == "SI" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*9) -- Croc SI
                    textlayout:println(_("o"))
                elseif vv == "SU" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*10) -- Croc SU
                    textlayout:println(_("o"))
                elseif vv == "TA" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*11) -- Croc TA
                    textlayout:println(_("o"))
                elseif vv == "TE" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*12) -- Croc TE
                    textlayout:println(_("o"))
                elseif vv == "TH" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*13) -- Croc TH
                    textlayout:println(_("o"))
                elseif vv == "UN" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*14) -- Croc UN
                    textlayout:println(_("o"))
                elseif vv == "VA" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*15) -- Croc VA
                    textlayout:println(_("o"))
                elseif vv == "VI" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*16) -- Croc VI
                    textlayout:println(_("o"))
                elseif vv == "VS" then
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*17) -- Croc VS
                    textlayout:println(_("o"))
	             elseif vv == "RG" then -- "RT"
                    textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*18) -- Croc RT
                    textlayout:println(_("o"))					
                elseif vv == "Capitals" then
	                textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*19) -- Croc world-capitals			   
                    textlayout:println(_("o"))
                elseif vv == "city" then
	                textlayout:setpos(this.lb+4+125*2, this.tb -23 - 20*20) -- Croc city			   
                    textlayout:println(_("o"))
                -- COLONNE 4
                elseif vv == "G01" then -- when is used, replace "Earth type" by the short type corresponding. This short type must be in config/ObjectsLocs
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*1) -- Croc 01=Cont.+Oceans
                    textlayout:println(_("o"))               
                elseif vv == "G02" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*2) -- Croc 02=Islands
                    textlayout:println(_("o"))               
                elseif vv == "G03" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*3) -- Croc 03=Fjords
                    textlayout:println(_("o"))
                elseif vv == "G04" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*4) -- Croc 04=Trench
                    textlayout:println(_("o"))
                elseif vv == "G05" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*5) -- Croc 05=Seas
                    textlayout:println(_("o"))
                elseif vv == "G06" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*6) -- Croc 06=Lakes
                    textlayout:println(_("o"))
                elseif vv == "G07" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*7) -- Croc 07=Rivers
                    textlayout:println(_("o"))
                elseif vv == "G08" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*8) -- Croc 08=Meteorites
                    textlayout:println(_("o"))
                elseif vv == "G09" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*9) -- Croc 09=Earthquakes
                    textlayout:println(_("o"))
                elseif vv == "G10" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*10) -- Croc 10=Volcano
                    textlayout:println(_("o"))
                elseif vv == "G11" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*11) -- Croc 11=Mountains
                    textlayout:println(_("o"))
                elseif vv == "G12" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*12) -- Croc 12=Plateau
                    textlayout:println(_("o"))
                elseif vv == "G13" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*13) -- Croc 13=Plains
                    textlayout:println(_("o"))
                elseif vv == "G14" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*14) -- Croc 14=Deserts
                    textlayout:println(_("o"))
                elseif vv == "G15" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*15) -- Croc 15=Canyons
                    textlayout:println(_("o"))
                elseif vv == "G16" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*16) -- Croc 16=Historical
                    textlayout:println(_("o"))
                elseif vv == "G17" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*17) -- Croc 17=Countries
                    textlayout:println(_("o"))
                elseif vv == "G18" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*18) -- Croc 18=Observatory
                    textlayout:println(_("o"))
                elseif vv == "G19" then
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*19) -- Croc 19=Cosmodromes
                    textlayout:println(_("o"))
                elseif vv == "XX" then -- G20
                    textlayout:setpos(this.lb+4+125*3, this.tb -23 - 20*20) -- Croc XX=Other
                    textlayout:println(_("o"))
                end
                                 -----------------------------------------------
            end
        end
    end
end

-- Enabled Location labels --------------------------------------------------
celestia:setlabelflags{locations = true}	-- enabled name of locations


-- ================ Button's command frame ===================
renderLocsBox = CXBox:new() 
    :init(0, 0, 0, 0)
    --:bordercolor({0.2,0.8,1,.6})
    :fillcolor(cFrameFill)
    :movable(false)
    :attach(screenBox, width, height, 0, 0)

----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------

renderLocsButtonCheck = CXBox:new()
        :init(0, 0, 0, 0)
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(-32, 9)
        :text("")
        :movable(false)
        :active(true)  
        :attach(renderLocsBox, 20, 0, 0, 0)
  
renderLocsFrame = CXBox:new()
    :init(0, 0, 0, 0)
    :fillcolor(csetbofill)
    :bordercolor(cbubordoff)
    :textfont(titlefont)
    :textcolor({0.8, 0.8, 0.8, 0.9})
    :textpos("center")
    :text(_(""))
    :movetext(0, 5)
    :movable(true)
    :visible(false)
    :attach(screenBox, (width-renderLocsFrameWidth)/2, height-renderLocsFrameHeight-2, (width-renderLocsFrameWidth)/2, 2)
	
renderLocsFrame.Customdraw = 
    function(this)

     textlayout:setfont(normalfont)
     textlayout:setfontcolor({0,1,1,0.8})
     textlayout:setpos(this.lb+renderlocsLeftMargin, this.tb-20)  
     textlayout:println(_("PLANETARY NOMENCLATURE. Features of the location")) 
     textlayout:setfont(normalfont)
	 textlayout:setfontcolor({1,1,1,0.8})
	 textlayout:setpos(this.lb+330+35, this.tb-20)
     textlayout:println(nameobj)	 
	 
     local minFeatureSize = celestia:getminfeaturesize()

        if renderLocs_firstTickDone then
            if not(renderLocscloseButtonDone) then
                renderLocscloseButtonDone = true
                makeCloseButton(renderLocsCloseButton, renderLocsFrame, renderLocsButton)
            end
        else
            renderLocs_firstTickDone = true
        end

        if newwidth3 ~= width or newheight3 ~= height then
            newwidth3, newheight3 = width, height
            renderLocsFrame:attach(screenBox, (width-renderLocsFrameWidth)/2, height-renderLocsFrameHeight-10, (width-renderLocsFrameWidth)/2, 10)
       end

		obj = celestia:getselection()
		makeflagLocs (obj)
		
        ------------------- change object or not ------------------------
		obj = celestia:getselection() -- added by Gironde 26-08-2017
        nameobj = obj:name() -- added by Gironde 26-08-2017
		if namelastobj ~= nameobj then
		   CheckResetPressed = true -- forces the unselect for all
		end
		lastobj = obj -- save obj as lastobj
		namelastobj = obj:name() -- save obj:name as namelastobj
		----------------------------------------------------------------------
    end

---------------------------------------------------
-- button : check all managed types
-- the not managed types is selected by XX=Other
---------------------------------------------------

Locs001ResetButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(cbubordoff)
    :textfont(normalfont) 
    :textcolor(color0)
    :textpos("center")
    :movetext(17, 7)
    :text(_("Reset"))
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3+52, -4+20*(nlines+1), 545-135*4+15, 9+20*0)
	
Locs001ResetButton.Action = (function() -- uncheck all
        return
            function()
                LocsCheck420Box.Text = "" -- unchecks XX=other
			    tableflag.other = false
                obs:setlocationflags(tableflag)
				
                CheckResetPressed = true -- when true, the "action" button has been pressed, so reset all managed in their Customdraw
										 -- CheckResetPressed is setted to "false" in their .Action
            end
        end) ()	

-- =============================================================================
-- A table which contains the locationflags as keys, and booleans as values for each key. 
-- Each locationflag must be one of:
-- =============================================================================
--========= 1e colonne =========
Locs101Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("AA=Crater")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-0)-10, 515-170*1+35, 10+20*1)

LocsCheck101Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs101Box, 2, 4, 140-35, 5)

LocsCheck101Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
 
                if CheckResetPressed == true then
                   LocsCheck101Box.Text = "" -- reset text
                   tableflag.crater = false -- reset value
                   obs:setlocationflags(tableflag) -- save in celestia
                end
    end
       
LocsCheck101Box.Action = (function() 
        return
            function()
                CheckResetPressed = false
                if tableflag.crater then
                    LocsCheck101Box.Text = ""
                    tableflag.crater = false
                else
                    LocsCheck101Box.Text = "v"
					tableflag.crater = true
                end
                obs:setlocationflags(tableflag) -- reset celestia
             end
        end) ()
---------------------------------
Locs102Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("AL=Albedo")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-1)-10, 515-170*1+35, 10+20*2)

LocsCheck102Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs102Box, 2, 4, 140-35, 5)

LocsCheck102Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck102Box.Text = "" -- reset text
                    tableflag.other = false -- reset value
                    obs:setlocationflags(tableflag) -- save in celestia
                end
    end
       
LocsCheck102Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Mars" or name2 == "Moon" or name2 == "Mercury" or name2 == "Titan" then -- AL becomes AS for Mars, Moon, Mercury
                    if tableflag.astrum then                -- if astrum is ticked
						LocsCheck102Box.Text = ""             -- unticks AL instead of AS
						tableflag.astrum = false              -- refresh tableflag in memory
					else                                    -- if astrum is unticked
					    LocsCheck102Box.Text = "v"            -- ticks AL instead of AS
						tableflag.astrum = true               -- refresh tableflag in memory
					end
                end
                obs:setlocationflags(tableflag) -- save tableflag in celestia
            end
        end) ()
---------------------------------
Locs103Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("AR=Arcus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-2)-10, 515-170*1+35, 10+20*3)

LocsCheck103Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs103Box, 2, 4, 140-35, 5)

LocsCheck103Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck103Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck103Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Titan" then
                    if tableflag.chasma then
						LocsCheck103Box.Text = ""
						tableflag.chasma = false
					else
					    LocsCheck103Box.Text = "v"
						tableflag.chasma = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs104Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("AS=Astrum")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-3)-10, 515-170*1+35, 10+20*4)

LocsCheck104Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs104Box, 2, 4, 140-35, 5)

LocsCheck104Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck104Box.Text = ""
                    tableflag.astrum = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck104Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.astrum then
                    LocsCheck104Box.Text = ""
                    tableflag.astrum = false
                else
                    LocsCheck104Box.Text = "v"
					tableflag.astrum = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs105Box = CXBox:new()  -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("CA=Catena")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-4)-10, 515-170*1+35, 10+20*5)

LocsCheck105Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs105Box, 2, 4, 140-35, 5)

LocsCheck105Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck105Box.Text = ""
                    tableflag.catena = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck105Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.catena then
                    LocsCheck105Box.Text = ""
                    tableflag.catena = false
                else
                    LocsCheck105Box.Text = "v"
					tableflag.catena = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs106Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor)
    :textpos("left")    
    :movetext(12, 4)
    :text(_("CB=Cavus"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-5)-10, 515-170*1+35, 10+20*6)

LocsCheck106Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs106Box, 2, 4, 140-35, 5)

LocsCheck106Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck106Box.Text = "" 
                    tableflag.other = false 
                    obs:setlocationflags(tableflag) 
                end
    end
       
LocsCheck106Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Mars" or name2 == "Triton" or name2 == "Pluto" then			                 
                    if tableflag.insula then
						LocsCheck106Box.Text = ""
						tableflag.insula = false
					else
					    LocsCheck106Box.Text = "v"
						tableflag.insula = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs107Box = CXBox:new()  -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("CH=Chaos")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-6)-10, 515-170*1+35, 10+20*7)

LocsCheck107Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs107Box, 2, 4, 140-35, 5)

LocsCheck107Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck107Box.Text = ""
                    tableflag.chaos = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck107Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.chaos then
                    LocsCheck107Box.Text = ""
                    tableflag.chaos = false
                else
                    LocsCheck107Box.Text = "v"
					tableflag.chaos = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs108Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor)
    :textpos("left")    
    :movetext(12, 4)
    :text(_("CM=Chasma")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-7)-10, 515-170*1+35, 10+20*8)

LocsCheck108Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs108Box, 2, 4, 140-35, 5)

LocsCheck108Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck108Box.Text = ""
                    tableflag.chasma = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck108Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.chasma then
                    LocsCheck108Box.Text = ""
                    tableflag.chasma = false
                else
                    LocsCheck108Box.Text = "v"
					tableflag.chasma = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
----------------------------------
Locs109Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("CO=Colles"))  
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-8)-10, 515-170*1+35, 10+20*9)

LocsCheck109Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs109Box, 2, 4, 140-35, 5)

LocsCheck109Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck109Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck109Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Venus" then
                    if tableflag.reticulum then
						LocsCheck109Box.Text = ""
						tableflag.reticulum = false
					else
					    LocsCheck109Box.Text = "v"
						tableflag.reticulum = true
					end

				elseif name2 == "Mars" then
                    if tableflag.corona then
						LocsCheck109Box.Text = ""
						tableflag.corona = false
					else
					    LocsCheck109Box.Text = "v"
						tableflag.corona = true
					end
					
				elseif name2 == "Pluto" then
                    if tableflag.fluctus then
						LocsCheck109Box.Text = ""
						tableflag.fluctus = false
					else
					    LocsCheck109Box.Text = "v"
						tableflag.fluctus = true
					end
		
				elseif name2 == "Titan" then
                    if tableflag.chaos then
						LocsCheck109Box.Text = ""
						tableflag.chaos = false
					else
					    LocsCheck109Box.Text = "v"
						tableflag.chaos = true
					end					
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs110Box = CXBox:new()  -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("CR=Corona")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-9)-10, 515-170*1+35, 10+20*10)

LocsCheck110Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs110Box, 2, 4, 140-35, 5)

LocsCheck110Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
					LocsCheck110Box.Text = ""
                    tableflag.corona = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck110Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.corona then
                    LocsCheck110Box.Text = ""
                    tableflag.corona = false
                else
                    LocsCheck110Box.Text = "v"
					tableflag.corona = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs111Box = CXBox:new()  -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("DO=Dorsum")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-10)-10, 515-170*1+35, 10+20*11)

LocsCheck111Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs111Box, 2, 4, 140-35, 5)

LocsCheck111Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck111Box.Text = ""
                    tableflag.dorsum = false 
                    obs:setlocationflags(tableflag)
                end				
    end
       
LocsCheck111Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.dorsum then
                    LocsCheck111Box.Text = ""
                    tableflag.dorsum = false
                else
                    LocsCheck111Box.Text = "v"
					tableflag.dorsum = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs112Box = CXBox:new()  -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("ER=Erupt.center")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-11)-10, 515-170*1+35, 10+20*12)

LocsCheck112Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs112Box, 2, 4, 140-35, 5)

LocsCheck112Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck112Box.Text = ""
                    tableflag.volcano = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck112Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.volcano then
                    LocsCheck112Box.Text = ""
                    tableflag.volcano = false
                else
                  LocsCheck112Box.Text = "v"
					tableflag.volcano = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs113Box = CXBox:new() -- type not managed in celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("FA=Facula"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-12)-10, 515-170*1+35, 10+20*13)

LocsCheck113Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs113Box, 2, 4, 140-35, 5)

LocsCheck113Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck113Box.Text = ""
                    tableflag.other = false 
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck113Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Amalthea" or name2 == "Callisto" or name2 == "Ganymede" or name2 == "Titan" or name2 == "Ceres" then
                    if tableflag.dorsum then
						LocsCheck113Box.Text = ""
						tableflag.dorsum = false
					else
					    LocsCheck113Box.Text = "v"
						tableflag.dorsum = true
					end
                elseif name2 == "Mercury" then
                    if tableflag.insula then
                        LocsCheck113Box.Text = ""
                        tableflag.insula = false
                    else
                        LocsCheck113Box.Text = "v"
                        tableflag.insula = true
                    end
                end
				
                obs:setlocationflags(tableflag)
            end
        end) ()						
		
		--[[
LocsCheck113Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
            if name2 == "Amalthea" or name2 == "Callisto" or name2 == "Ganymede" or name2 == "Titan" or name2 == "Ceres" then
                    if tableflag.dorsum then
                  LocsCheck113Box.Text = ""
                  tableflag.dorsum = false
               else
                   LocsCheck113Box.Text = "v"
                  tableflag.dorsum = true
               end
            elseif name2 == "Mercury" then
               if tableflag.insula then
                  LocsCheck113Box.Text = ""
                  tableflag.insula = false
               else
                   LocsCheck113Box.Text = "v"
                  tableflag.insula = true
               end
                end

                obs:setlocationflags(tableflag)
            end
        end) ()		
		]]
---------------------------------
Locs114Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("FE=Flexus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-13)-10, 515-170*1+35, 10+20*14)

LocsCheck114Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs114Box, 2, 4, 140-35, 5)

LocsCheck114Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck114Box.Text = ""
                    tableflag.other = false 
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck114Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Europa" then			                
                    if tableflag.catena then
						LocsCheck114Box.Text = ""
						tableflag.catena = false
					else
					    LocsCheck114Box.Text = "v"
						tableflag.catena = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs115Box = CXBox:new() -- type managed by celestia 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("FL=Fluctus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-14)-10, 515-170*1+35, 10+20*15)

LocsCheck115Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs115Box, 2, 4, 140-35, 5)

LocsCheck115Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck115Box.Text = "" 
                    tableflag.fluctus = false 
                    obs:setlocationflags(tableflag) 
                end
    end

LocsCheck115Box.Action = (function() 
        return
            function()
                CheckResetPressed = false
                if tableflag.fluctus then
                    LocsCheck115Box.Text = ""
                    tableflag.fluctus = false
                else
                    LocsCheck115Box.Text = "v"
					tableflag.fluctus = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs116Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("FM=Flumen")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-15)-10, 515-170*1+35, 10+20*16)

LocsCheck116Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs116Box, 2, 4, 140-35, 5)

LocsCheck116Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
				
				if tableflag.other then
						LocsCheck116Box.Text = "v" -- Original type replaced
					else
						LocsCheck116Box.Text = "" -- Original type replaced
				end
				
                if CheckResetPressed == true then -- add 18-09-2017
                    LocsCheck116Box.Text = ""-- add 18-09-2017
                    tableflag.other = false -- add 18-09-2017
                    obs:setlocationflags(tableflag)-- add 18-09-2017
                end	 -- add 18-09-2017	
				
    end
	
LocsCheck116Box.Action = (function()
        return
            function()
			
		        CheckResetPressed = false -- add 18-09-2017
                local obj2 = celestia:getselection() -- add 18-09-2017
                local name2 = obj2:name() -- add 18-09-2017
			
                CheckResetPressed = false			 
                    if tableflag.fossa then
						LocsCheck116Box.Text = ""
						tableflag.fossa = false
					else
					    LocsCheck116Box.Text = "v"
						tableflag.fossa = true
					end
                obs:setlocationflags(tableflag) 
            end
        end) ()	
---------------------------------
Locs117Box = CXBox:new() -- type managed by celestia 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("FO=Fossa")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-16)-10, 515-170*1+35, 10+20*17)

LocsCheck117Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs117Box, 2, 4, 140-35, 5)

LocsCheck117Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck117Box.Text = "" 
                    tableflag.fossa = false 
                    obs:setlocationflags(tableflag) 
                end
    end
       
LocsCheck117Box.Action = (function() 
        return
            function()
                CheckResetPressed = false
                if tableflag.fossa then
                    LocsCheck117Box.Text = ""
                    tableflag.fossa = false
                else
                    LocsCheck117Box.Text = "v"
					tableflag.fossa = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs118Box = CXBox:new()  -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("FR=Farrum")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-17)-10, 515-170*1+35, 10+20*18)

LocsCheck118Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs118Box, 2, 4, 140-35, 5)

LocsCheck118Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck118Box.Text = ""
                    tableflag.farrum = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck118Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.farrum then
                    LocsCheck118Box.Text = ""
                    tableflag.farrum = false
                else
                    LocsCheck118Box.Text = "v"
					tableflag.farrum = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs119Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("FT=Fretum")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-18)-10, 515-170*1+35, 10+20*19)

LocsCheck119Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs119Box, 2, 4, 140-35, 5)

LocsCheck119Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck119Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck119Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Titan" then			                  
                    if tableflag.catena then
						LocsCheck119Box.Text = ""
						tableflag.catena = false
					else
					    LocsCheck119Box.Text = "v"
						tableflag.catena = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs120Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor)
    :textpos("left")    
    :movetext(12, 4)
    :text(_("IN=Insula")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+5, 20*(nlines-19)-10, 515-170*1+35, 10+20*20)

LocsCheck120Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs120Box, 2, 4, 140-35, 5)

LocsCheck120Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck120Box.Text = ""
                    tableflag.insula = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck120Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.insula then
                    LocsCheck120Box.Text = ""
                    tableflag.insula  = false
                else
                    LocsCheck120Box.Text = "v"
					tableflag.insula  = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()

--========= 2e colonne =========

Locs201Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("LA=Labes")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, -10+20*(nlines-0), 525-135*2, 10+20*1)

LocsCheck201Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs201Box, 2, 4, 105, 5)
 
LocsCheck201Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck201Box.Text = "" 
                    tableflag.other = false  				 
                    obs:setlocationflags(tableflag) 
                end
    end
       
LocsCheck201Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
			if name2 == "Mars" or name2 == "Lutetia" or name2 == "21 Lutetia" or name2 == "*Лютеция" or name2 == "1852-21" or name2 == "21" then
                    if tableflag.linea then
						LocsCheck201Box.Text = ""
						tableflag.linea = false
					else
					    LocsCheck201Box.Text = "v"
						tableflag.linea = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs202Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("LB=Labyrinthus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, -10+20*(nlines-1), 525-135*2, 10+20*2)

LocsCheck202Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs202Box, 2, 4, 105, 5)
 
LocsCheck202Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck202Box.Text = "" 
                    tableflag.other = false 
                    obs:setlocationflags(tableflag) 
                end
    end
       
LocsCheck202Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Venus"  or name2 == "Titan" then
                    if tableflag.mensa then
						LocsCheck202Box.Text = ""
						tableflag.mensa = false
					else
					    LocsCheck202Box.Text = "v"
						tableflag.mensa = true
					end
				elseif name2 == "Mars" then
                    if tableflag.mare then
						LocsCheck202Box.Text = ""
						tableflag.mare = false
					else
					    LocsCheck202Box.Text = "v"
						tableflag.mare = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs203Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("LC=Lacus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-2)-10, 525-135*2, 10+20*3)

LocsCheck203Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs203Box, 2, 4, 105, 5)

LocsCheck203Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck203Box.Text = "" 
                    tableflag.other = false 
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck203Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Moon" then
                    if tableflag.insula then
						LocsCheck203Box.Text = ""
						tableflag.insula = false
					else
					    LocsCheck203Box.Text = "v"
						tableflag.insula = true
					end
				elseif name2 == "Titan" then
                    if tableflag.linea then
						LocsCheck203Box.Text = ""
						tableflag.linea = false
					else
					    LocsCheck203Box.Text = "v"
						tableflag.linea = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs204Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("LE=Lenticula")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-3)-10, 525-135*2, 10+20*4)

LocsCheck204Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs204Box, 2, 4, 105, 5)

LocsCheck204Box.Customdraw =
    function(this)
            local obj2 = celestia:getselection()
            local name2 = obj2:name()    

            if CheckResetPressed == true then
                LocsCheck204Box.Text = ""
                tableflag.other = false 
                obs:setlocationflags(tableflag) 
            end
    end
       
LocsCheck204Box.Action = (function() 
        return
            function()
                CheckResetPressed = false
                obs:setlocationflags(tableflag)
            end
        end) ()		
---------------------------------
Locs205Box = CXBox:new() -- type managed by celestia 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("LF=Landing")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-4)-10, 525-135*2, 10+20*5)

LocsCheck205Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs205Box, 2, 4, 105, 5)

LocsCheck205Box.Customdraw =
    function(this)
            local obj2 = celestia:getselection()
            local name2 = obj2:name()   

            if CheckResetPressed == true then
                LocsCheck205Box.Text = "" 
                tableflag.landingsite = false 
                obs:setlocationflags(tableflag) 
            end
    end
       
LocsCheck205Box.Action = (function() 
        return
            function()
                CheckResetPressed = false
                if tableflag.landingsite then
                    LocsCheck205Box.Text = ""
                    tableflag.landingsite = false
                else
                    LocsCheck205Box.Text = "v"
					tableflag.landingsite = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs206Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("LG=Large ringed")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-5)-10, 525-135*2, 10+20*6)

LocsCheck206Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs206Box, 2, 4, 105, 5)

LocsCheck206Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck206Box.Text = "" 
                    tableflag.other = false 
                    obs:setlocationflags(tableflag) 
                end
    end
       
LocsCheck206Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Callisto" or name2 == "Europa" or name2 == "Titan" then
                    if tableflag.planum then
						LocsCheck206Box.Text = ""
						tableflag.planum = false
					else
					    LocsCheck206Box.Text = "v"
						tableflag.planum = true
					end
                end
                obs:setlocationflags(tableflag) 
            end
        end) ()
---------------------------------
Locs207Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("LI=Linea")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-6)-10, 525-135*2, 10+20*7)

LocsCheck207Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs207Box, 2, 4, 105, 5)

LocsCheck207Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck207Box.Text = "" 
                    tableflag.linea = false 
                    obs:setlocationflags(tableflag) 
                end
    end
       
LocsCheck207Box.Action = (function() 
        return
            function()
                CheckResetPressed = false
                if tableflag.linea then
                    LocsCheck207Box.Text = ""
                    tableflag.linea = false
                else
                    LocsCheck207Box.Text = "v"
					tableflag.linea = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs208Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("LN=Lingula")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-7)-10, 525-135*2, 10+20*8)

LocsCheck208Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs208Box, 2, 4, 105, 5)

LocsCheck208Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck208Box.Text = "" 
                 --   tableflag.rima = false 
                    tableflag.other = false			 
                    obs:setlocationflags(tableflag) 
                end
    end
       
LocsCheck208Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Mars" then
                    if tableflag.rima then
						LocsCheck208Box.Text = ""
						tableflag.rima = false
					else
					    LocsCheck208Box.Text = "v"
						tableflag.rima = true
					end
				else

                    if CheckResetPressed == true then
                        LocsCheck208Box.Text = ""
                        tableflag.other = false 
                        obs:setlocationflags(tableflag) 
                    end
                end
                obs:setlocationflags(tableflag) 
            end
        end) ()
----------------------------------
Locs209Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("LU=Lacuna")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-8)-10, 525-135*2, 10+20*9)

LocsCheck209Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff) 
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs209Box, 2, 4, 105, 5)

LocsCheck209Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck209Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck209Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Titan" then
                    if tableflag.rima then
						LocsCheck209Box.Text = ""
						tableflag.rima = false
					else
					    LocsCheck209Box.Text = "v"
						tableflag.rima = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs210Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("MA=Macula")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-9)-10, 525-135*2, 10+20*10)

LocsCheck210Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs210Box, 2, 4, 105, 5)

LocsCheck210Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck210Box.Text = ""
                    tableflag.other = false 
                    obs:setlocationflags(tableflag) 
                end
    end
       
LocsCheck210Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Europa" or name2 == "Titan" or name2 == "Triton" or name2 == "Charon" or name2 == "Pluto" then
                    if tableflag.corona then
						LocsCheck210Box.Text = ""
						tableflag.corona = false
					else
					    LocsCheck210Box.Text = "v"
						tableflag.corona = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs211Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("ME=Mare")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-10)-10, 525-135*2, 10+20*11)

LocsCheck211Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs211Box, 2, 4, 105, 5)

LocsCheck211Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck211Box.Text = "" 
                    tableflag.mare = false 
                    obs:setlocationflags(tableflag) 
                end
    end
       
LocsCheck211Box.Action = (function() 
        return
            function()
                CheckResetPressed = false
                if tableflag.mare then
                    LocsCheck211Box.Text = ""
                    tableflag.mare = false
                else                  
                    LocsCheck211Box.Text = "v"
					tableflag.mare = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs212Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("MN=Mensa")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-11)-10, 525-135*2, 10+20*12)

LocsCheck212Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs212Box, 2, 4, 105, 5)

LocsCheck212Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck212Box.Text = ""
                    tableflag.mensa = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck212Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.mensa then
                    LocsCheck212Box.Text = ""
                    tableflag.mensa = false
                else
                    LocsCheck212Box.Text = "v"
					tableflag.mensa = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs213Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("MO=Mons"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-12)-10, 525-135*2, 10+20*13)

LocsCheck213Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs213Box, 2, 4, 105, 5)

LocsCheck213Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()  

                if CheckResetPressed == true then
                    LocsCheck213Box.Text = ""
                    tableflag.mons = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck213Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.mons then
                    LocsCheck213Box.Text = ""
                    tableflag.mons = false
                else
                    LocsCheck213Box.Text = "v"
					tableflag.mons = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs214Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor)
    :textpos("left")    
    :movetext(12, 4)
    :text(_("OC=Oceanus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-13)-10, 525-135*2, 10+20*14)

LocsCheck214Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs214Box, 2, 4, 105, 5)

LocsCheck214Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck214Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck214Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Moon" then
                    if tableflag.patera then
						LocsCheck214Box.Text = ""
						tableflag.patera = false
					else
					    LocsCheck214Box.Text = "v"
						tableflag.patera = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs215Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("PA=Palus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-14)-10, 525-135*2, 10+20*15)

LocsCheck215Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs215Box, 2, 4, 105, 5)

LocsCheck215Box.Customdraw = 
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck215Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck215Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Moon" then
                    if tableflag.planum then
						LocsCheck215Box.Text = ""
						tableflag.planum = false
					else
					    LocsCheck215Box.Text = "v"
						tableflag.planum = true
					end
					
				elseif name2 == "Mars" then
                    if tableflag.regio then
						LocsCheck215Box.Text = ""
						tableflag.regio = false
					else
					    LocsCheck215Box.Text = "v"
						tableflag.regio = true
					end					
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs216Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("PE=Patera")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-15)-10, 525-135*2, 10+20*16)

LocsCheck216Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs216Box, 2, 4, 105, 5)

LocsCheck216Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck216Box.Text = ""
                    tableflag.patera = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck216Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.patera then
                    LocsCheck216Box.Text = ""
                    tableflag.patera = false
                else
                    LocsCheck216Box.Text = "v"
					tableflag.patera = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs217Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("PL=Planitia")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-16)-10, 525-135*2, 10+20*17)

LocsCheck217Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs217Box, 2, 4, 105, 5)

LocsCheck217Box.Customdraw = 
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()  

                if CheckResetPressed == true then
                    LocsCheck217Box.Text = ""
                    tableflag.planitia = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck217Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.planitia then
                    LocsCheck217Box.Text = ""
                    tableflag.planitia = false
                else
                    LocsCheck217Box.Text = "v"
					tableflag.planitia = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs218Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("PM=Planum")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-17)-10, 525-135*2, 10+20*18)

LocsCheck218Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs218Box, 2, 4, 105, 5)

LocsCheck218Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck218Box.Text = ""
                    tableflag.planum = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck218Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.planum then
                    LocsCheck218Box.Text = ""
                    tableflag.planum = false
                else
                    LocsCheck218Box.Text = "v"
					tableflag.planum = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs219Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("PR=Promontor.")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-18)-10, 525-135*2, 10+20*19)

LocsCheck219Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs219Box, 2, 4, 105, 5)

LocsCheck219Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck219Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck219Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Moon" then
                    if tableflag.regio then
						LocsCheck219Box.Text = ""
						tableflag.regio = false
					else
					    LocsCheck219Box.Text = "v"
						tableflag.regio = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs220Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("PU=Plume")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 8+10+170-50, 20*(nlines-19)-10, 525-135*2, 10+20*20)

LocsCheck220Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs220Box, 2, 4, 105, 5)

LocsCheck220Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck220Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck220Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Triton" then			                 
                    if tableflag.rima then
						LocsCheck220Box.Text = ""
						tableflag.rima = false
					else
					    LocsCheck220Box.Text = "v"
						tableflag.rima = true
					end					
                end
                obs:setlocationflags(tableflag)
            end
        end) ()

--========= 3e colonne =========

Locs301Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("RE=Regio"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, -10+20*(nlines-0), 535-135*3, 10+20*1)

LocsCheck301Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs301Box, 2, 4, 105, 5)
 
LocsCheck301Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck301Box.Text = ""
                    tableflag.regio = false
                    obs:setlocationflags(tableflag)
                end
	end
       
LocsCheck301Box.Action = (function()
     return
         function()
                CheckResetPressed = false
                if tableflag.regio then  
                    LocsCheck301Box.Text = ""
                    tableflag.regio = false 
                else
                    LocsCheck301Box.Text = "v"
					tableflag.regio = true
                end
                obs:setlocationflags(tableflag)
         end
     end) ()
---------------------------------

---------------------------------
Locs302Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("RI=Rima")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, -10+20*(nlines-1), 535-135*3, 10+20*2)

LocsCheck302Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs302Box, 2, 4, 105, 5)
 
LocsCheck302Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck302Box.Text = ""
                    tableflag.rima = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck302Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.rima then
                    LocsCheck302Box.Text = ""
                    tableflag.rima = false
                else
                    LocsCheck302Box.Text = "v"
					tableflag.rima = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs303Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("RT=Reticulum"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-2)-10, 535-135*3, 10+20*3)

LocsCheck303Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs303Box, 2, 4, 105, 5)

LocsCheck303Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck303Box.Text = ""
                    tableflag.reticulum = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck303Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.reticulum then
                    LocsCheck303Box.Text = ""
                    tableflag.reticulum = false
                else
                    LocsCheck303Box.Text = "v"
					tableflag.reticulum = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs304Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("RU=Rupes"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-3)-10, 535-135*3, 10+20*4)

LocsCheck304Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs304Box, 2, 4, 105, 5)

LocsCheck304Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()      

                if CheckResetPressed == true then
                    LocsCheck304Box.Text = ""
                    tableflag.rupes = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck304Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.rupes then
                    LocsCheck304Box.Text = ""
                    tableflag.rupes = false
                else
                    LocsCheck304Box.Text = "v"
					tableflag.rupes = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs305Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("SA=Saxum")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-4)-10, 535-135*3, 10+20*5)

LocsCheck305Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs305Box, 2, 4, 105, 5)

LocsCheck305Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck305Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                 end
    end

--[[ -- подлежит редактированию !
      
LocsCheck305Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Mars" then
                    if tableflag.reticulum then
						LocsCheck305Box.Text = ""
						tableflag.reticulum = false
					else
					    LocsCheck305Box.Text = "v"
						tableflag.reticulum = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
]]		
---------------------------------
Locs306Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("SC=Scopulus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-5)-10, 535-135*3, 10+20*6)

LocsCheck306Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs306Box, 2, 4, 105, 5)

LocsCheck306Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck306Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                 end
    end
       
LocsCheck306Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Mars" then
                    if tableflag.reticulum then
						LocsCheck306Box.Text = ""
						tableflag.reticulum = false
					else
					    LocsCheck306Box.Text = "v"
						tableflag.reticulum = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs307Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("SE=Serpens")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-6)-10, 535-135*3, 10+20*7)

LocsCheck307Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs307Box, 2, 4, 105, 5)

LocsCheck307Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck307Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck307Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Mars" then
                    if tableflag.tessera then
						LocsCheck307Box.Text = ""
						tableflag.tessera = false
					else
					    LocsCheck307Box.Text = "v"
						tableflag.tessera = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs308Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("SF=Satellites")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-7)-10, 535-135*3, 10+20*8)

LocsCheck308Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs308Box, 2, 4, 105, 5)

LocsCheck308Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck308Box.Text = ""
                    tableflag.other = false 
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck308Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Moon" then
                    if tableflag.chaos then
						LocsCheck308Box.Text = ""
						tableflag.chaos = false
					else
					    LocsCheck308Box.Text = "v"
						tableflag.chaos = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
----------------------------------
Locs309Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("SI=Sinus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-8)-10, 535-135*3, 10+20*9)

LocsCheck309Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs309Box, 2, 4, 105, 5)

LocsCheck309Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
				
                if CheckResetPressed == true then
                    LocsCheck309Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck309Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Moon" or  name2 == "Titan" then
                    if tableflag.tessera then
						LocsCheck309Box.Text = ""
						tableflag.tessera = false
					else
					    LocsCheck309Box.Text = "v"
						tableflag.tessera = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs310Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("SU=Sulcus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-9)-10, 535-135*3, 10+20*10)

LocsCheck310Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs310Box, 2, 4, 105, 5)

LocsCheck310Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck310Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck310Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Mars" or name2 == "Ganymede" or name2 == "Enceladus" or name2 == "Miranda" or name2 == "Triton" or name2 == "Ceres"  then
                    if tableflag.farrum then
						LocsCheck310Box.Text = ""
						tableflag.farrum = false
					else
					    LocsCheck310Box.Text = "v"
						tableflag.farrum = true
					end								
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs311Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("TA=Terra"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-10)-10, 535-135*3, 10+20*11)

LocsCheck311Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs311Box, 2, 4, 105, 5)

LocsCheck311Box.Customdraw =
    function(this)
        local obj2 = celestia:getselection()
        local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck311Box.Text = ""
                    tableflag.terra = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck311Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.terra then
                    LocsCheck311Box.Text = ""
                    tableflag.terra = false
                else
                    LocsCheck311Box.Text = "v"
					tableflag.terra = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs312Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("TE=Tessera")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-11)-10, 535-135*3, 10+20*12)

LocsCheck312Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs312Box, 2, 4, 105, 5)

LocsCheck312Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck312Box.Text = ""
                    tableflag.tessera = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck312Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.tessera then
                    LocsCheck312Box.Text = ""
                    tableflag.tessera = false
                else
                    LocsCheck312Box.Text = "v"
					tableflag.tessera = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs313Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("TH=Tholus")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-12)-10, 535-135*3, 10+20*13)

LocsCheck313Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs313Box, 2, 4, 105, 5)

LocsCheck313Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck313Box.Text = ""
                    tableflag.tholus = false
                    obs:setlocationflags(tableflag)
                end				
    end
       
LocsCheck313Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.tholus then
                    LocsCheck313Box.Text = ""
                    tableflag.tholus = false
                else
                    LocsCheck313Box.Text = "v"
					tableflag.tholus = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs314Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor)
    :textpos("left")    
    :movetext(12, 4)
    :text(_("UN=Undae"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-13)-10, 535-135*3, 10+20*14)

LocsCheck314Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs314Box, 2, 4, 105, 5)

LocsCheck314Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck314Box.Text = ""
                    tableflag.undae = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck314Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.undae then
                    LocsCheck314Box.Text = ""
                    tableflag.undae = false
                else
                    LocsCheck314Box.Text = "v"
					tableflag.undae = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs315Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor)
    :textpos("left")    
    :movetext(12, 4)
    :text(_("VA=Vallis")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-14)-10, 535-135*3, 10+20*15)

LocsCheck315Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs315Box, 2, 4, 105, 5)

LocsCheck315Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()    

                if CheckResetPressed == true then
                    LocsCheck315Box.Text = ""
                    tableflag.vallis = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck315Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.vallis then
                    LocsCheck315Box.Text = ""
                    tableflag.vallis = false
                else
                    LocsCheck315Box.Text = "v"
					tableflag.vallis = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs316Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("VI=Virga")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-15)-10, 535-135*3, 10+20*16)

LocsCheck316Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs316Box, 2, 4, 105, 5)

LocsCheck316Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck316Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck316Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Titan" then
                    if tableflag.tholus then
						LocsCheck316Box.Text = ""
						tableflag.tholus = false
					else
					    LocsCheck316Box.Text = "v"
						tableflag.tholus = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------
Locs317Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("VS=Vastitas")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-16)-10, 535-135*3, 10+20*17)

LocsCheck317Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs317Box, 2, 4, 105, 5)

LocsCheck317Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()

                if CheckResetPressed == true then
                    LocsCheck317Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end
       
LocsCheck317Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Mars" then
                    if tableflag.volcano then
						LocsCheck317Box.Text = ""
						tableflag.volcano = false
					else
					    LocsCheck317Box.Text = "v"
						tableflag.volcano = true
					end
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
------------------------
Locs318Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("RG=Ring")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-17)-10, 535-135*3, 10+20*18)
--  :attach(renderLocsFrame, 23+120*2, 20*(nlines-18)-10, 535-135*3, 10+20*19)
LocsCheck318Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor3) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs318Box, 2, 4, 105, 5)

LocsCheck318Box.Customdraw =
    function(this)
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
				
                if CheckResetPressed == true then
                    LocsCheck318Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end

LocsCheck318Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                local obj2 = celestia:getselection()
                local name2 = obj2:name()
             
				if name2 == "Jupiter" or name2 == "Saturn" or name2 == "Uranus" or name2 == "Neptune" then
                    if tableflag.undae then
						LocsCheck318Box.Text = ""
						tableflag.undae = false
					else
					    LocsCheck318Box.Text = "v"
						tableflag.undae = true
					end								
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	 		
------------------------
Locs319Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("Capitals"))  -- analogue CR 110Box 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-18)-10, 535-135*3, 10+20*19)

LocsCheck319Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)  
    :attach(Locs319Box, 2, 4, 105, 5)
	
LocsCheck319Box.Customdraw =
    function(this)
                if CheckResetPressed == true then
                    LocsCheck319Box.Text = ""
                end
	end
	
LocsCheck319Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.corona then
                    LocsCheck319Box.Text = ""
                    tableflag.corona = false
                else
                    LocsCheck319Box.Text = "v"
					tableflag.corona = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
----------------------------
Locs320Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
  --  :text(_("Cities > 10000")) 
    :text(_("Cities"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-19)-10, 535-135*3, 10+20*20)

LocsCheck320Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs320Box, 2, 4, 105, 5)

LocsCheck320Box.Customdraw =
    function(this)
                if tableflag.city then
                    LocsCheck320Box.Text = "v"
                else
                    LocsCheck320Box.Text = ""
                end               

                if CheckResetPressed == true then
                    LocsCheck320Box.Text = ""
                    tableflag.city = false
                    obs:setlocationflags(tableflag)
                end
	end
       
LocsCheck320Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.city then 
                    LocsCheck320Box.Text = ""
                    tableflag.city = false
                else
                    LocsCheck319Box.Text = "v"
               tableflag.city = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()

--========= 4e colonne =========

Locs401Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor)
    :textpos("left")    
    :movetext(12, 4)
    :text(_("01=Cont.+Oceans")) -- analogue RE 301Box 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-0), 545-135*4, 10+20*1)

LocsCheck401Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs401Box, 2, 4, 105, 5)

LocsCheck401Box.Customdraw =
    function(this)
                if CheckResetPressed == true then
                   LocsCheck401Box.Text = ""
                end
	end

LocsCheck401Box.Action = (function()
     return
         function()
                CheckResetPressed = false
                if tableflag.regio then 
                    LocsCheck401Box.Text = ""
                    tableflag.regio = false 
                else
                    LocsCheck401Box.Text = "v"
					tableflag.regio = true 
                end
                obs:setlocationflags(tableflag)
         end
     end) ()
---------------------------------------------------
Locs402Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("02=Islands")) -- analogue IN 120Box 
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-1), 545-135*4, 10+20*2)

LocsCheck402Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs402Box, 2, 4, 105, 5)
	
LocsCheck402Box.Customdraw =
    function(this)
                if CheckResetPressed == true then
                    LocsCheck402Box.Text = ""
                end				
	end

LocsCheck402Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.insula then
                    LocsCheck402Box.Text = ""
                    tableflag.insula  = false
                else
                    LocsCheck402Box.Text = "v"
					tableflag.insula  = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
------------------------------------------------
Locs403Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("03=Fjords")) -- analogue RU 305Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-2), 545-135*4, 10+20*3)

LocsCheck403Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs403Box, 2, 4, 105, 5)	

LocsCheck403Box.Customdraw = 
    function(this)
                if CheckResetPressed == true then
                    LocsCheck403Box.Text = ""
                end
	end	

	LocsCheck403Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.rupes then
                    LocsCheck403Box.Text = ""
                    tableflag.rupes = false
                else
                    LocsCheck403Box.Text = "v"
					tableflag.rupes = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
------------------------------------------------
Locs404Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("04=Trench")) -- analogue FO 117Box
   :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-3), 545-135*4, 10+20*4)

LocsCheck404Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)	
    :attach(Locs404Box, 2, 4, 105, 5)
	
LocsCheck404Box.Customdraw =
    function(this)
                if CheckResetPressed == true then
                    LocsCheck404Box.Text = ""
                end
	end
	
LocsCheck404Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.fossa then
                    LocsCheck404Box.Text = ""
                    tableflag.fossa = false
                else
                    LocsCheck404Box.Text = "v"
					tableflag.fossa = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------------------------
Locs405Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("05=Seas")) -- analogue ME 211Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-4), 545-135*4, 10+20*5)

LocsCheck405Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs405Box, 2, 4, 105, 5)
	
LocsCheck405Box.Customdraw =
    function(this)
                if CheckResetPressed == true then
                    LocsCheck405Box.Text = ""
                end
	end
	
LocsCheck405Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.mare then
                    LocsCheck405Box.Text = ""
                    tableflag.mare = false
                else                
                    LocsCheck405Box.Text = "v"
					tableflag.mare = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
---------------------------------------------------
Locs406Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("06=Lakes"))  -- analogue PE 216Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-5), 545-135*4, 10+20*6)

LocsCheck406Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff) 
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)	
    :attach(Locs406Box, 2, 4, 105, 5)

LocsCheck406Box.Customdraw = 
    function(this)
                if CheckResetPressed == true then
                    LocsCheck406Box.Text = ""
                end
	end	
	
	LocsCheck406Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.patera then
                    LocsCheck406Box.Text = ""
                    tableflag.patera = false
                else
                    LocsCheck406Box.Text = "v"
					tableflag.patera = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
---------------------------------------------------
Locs407Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("07=Rivers"))  -- analogue FL 115Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-6), 545-135*4, 10+20*7)

LocsCheck407Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs407Box, 2, 4, 105, 5)
	
LocsCheck407Box.Customdraw =
    function(this)
                if CheckResetPressed == true then
                    LocsCheck407Box.Text = ""
                end
	end
	
LocsCheck407Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.fluctus then
                    LocsCheck407Box.Text = ""
                    tableflag.fluctus = false
                else
                    LocsCheck407Box.Text = "v"
					tableflag.fluctus = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
---------------------------------------------------
Locs408Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("08=Meteorite"))  -- analogue AA 101Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-7), 545-135*4, 10+20*8)

LocsCheck408Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)	
    :attach(Locs408Box, 2, 4, 105, 5)
	
	LocsCheck408Box.Customdraw =                   
    function(this)  
                if CheckResetPressed == true then
                    LocsCheck408Box.Text = ""
                end
    end
       
LocsCheck408Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.crater then
                    LocsCheck408Box.Text = ""
                    tableflag.crater = false
                else
                    LocsCheck408Box.Text = "v"
					tableflag.crater = true
                end
                obs:setlocationflags(tableflag)
             end
        end) ()
---------------------------------------------------
Locs409Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("09=Earthquakes"))  -- analogue CH 107Box 
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-8), 545-135*4, 10+20*9)

LocsCheck409Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
	:attach(Locs409Box, 2, 4, 105, 5)
	
LocsCheck409Box.Customdraw =
    function(this)
                if CheckResetPressed == true then
                    LocsCheck409Box.Text = ""
                end
	end
	
LocsCheck409Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.chaos then
                    LocsCheck409Box.Text = ""
                    tableflag.chaos = false
                else
                    LocsCheck409Box.Text = "v"
					tableflag.chaos = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------------------------
Locs410Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("10=Volcano"))  -- analogue ER 112Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-9), 545-135*4, 10+20*10)

LocsCheck410Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)	
    :attach(Locs410Box, 2, 4, 105, 5)
	
LocsCheck410Box.Customdraw =
    function(this)             
        if CheckResetPressed == true then
            LocsCheck410Box.Text = ""
        end
	end

LocsCheck410Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.volcano then
                    LocsCheck410Box.Text = ""
                    tableflag.volcano = false
                else
                  LocsCheck410Box.Text = "v"
					tableflag.volcano = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------------------------	
Locs411Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor)
    :textpos("left")    
    :movetext(12, 4)
    :text(_("11=Mountains"))  -- analogue MO 213Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-10), 545-135*4, 10+20*11)

LocsCheck411Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs411Box, 2, 4, 105, 5)
	
LocsCheck411Box.Customdraw =
    function(this)
        if CheckResetPressed == true then
            LocsCheck411Box.Text = ""
        end
	end

	LocsCheck411Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.mons then
                    LocsCheck411Box.Text = ""
                    tableflag.mons = false
                else
                    LocsCheck411Box.Text = "v"
					tableflag.mons = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------------------------
Locs412Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("12=Plateau"))  -- analogue PM 218Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-11), 545-135*4, 10+20*12)

LocsCheck412Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)	
    :attach(Locs412Box, 2, 4, 105, 5)
	
LocsCheck412Box.Customdraw =
    function(this)    
                if CheckResetPressed == true then
                    LocsCheck412Box.Text = ""
                end
	end

	LocsCheck412Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.planum then
                    LocsCheck412Box.Text = ""
                    tableflag.planum = false
                else
                    LocsCheck412Box.Text = "v"
					tableflag.planum = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()
---------------------------------------------------
Locs413Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("13=Plains"))  -- analogue PL 217Box
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-12), 545-135*4, 10+20*13)

LocsCheck413Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs413Box, 2, 4, 105, 5)
	
LocsCheck413Box.Customdraw =
    function(this)
        if CheckResetPressed == true then
            LocsCheck413Box.Text = ""
        end
	end

LocsCheck413Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.planitia then
                    LocsCheck413Box.Text = ""
                    tableflag.planitia = false
                else
                    LocsCheck413Box.Text = "v"
					tableflag.planitia = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
---------------------------------------------------
Locs414Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("14=Deserts"))  -- analogue UN 314Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-13), 545-135*4, 10+20*14)

LocsCheck414Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs414Box, 2, 4, 105, 5)
	
LocsCheck414Box.Customdraw =
    function(this)				
           if CheckResetPressed == true then
                LocsCheck414Box.Text = ""
           end
	end

LocsCheck414Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.undae then
                    LocsCheck414Box.Text = ""
                    tableflag.undae = false
                else
                    LocsCheck414Box.Text = "v"
					tableflag.undae = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
---------------------------------------------------
Locs415Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("15=Canyons"))  -- analogue CM 108Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-14), 545-135*4, 10+20*15)

LocsCheck415Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)	
    :attach(Locs415Box, 2, 4, 105, 5)
	
LocsCheck415Box.Customdraw =
    function(this)
                if CheckResetPressed == true then
                    LocsCheck415Box.Text = ""
                end
	end

LocsCheck415Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.chasma then
                    LocsCheck415Box.Text = ""
                    tableflag.chasma = false
                else
                    LocsCheck415Box.Text = "v"
					tableflag.chasma = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
---------------------------------------------------
Locs416Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("16=Historical"))  -- analogue VA 315Box
    :movable(false)
    :active(true)
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-15), 545-135*4, 10+20*16)

LocsCheck416Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs416Box, 2, 4, 105, 5)
	
LocsCheck416Box.Customdraw =
    function(this)				
                if CheckResetPressed == true then
                    LocsCheck416Box.Text = ""
                end
	end

LocsCheck416Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.vallis then
                    LocsCheck416Box.Text = ""
                    tableflag.vallis = false
                else
                    LocsCheck416Box.Text = "v"
					tableflag.vallis = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
---------------------------------------------------
Locs417Box = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor)
    :textpos("left")    
    :movetext(12, 4)
    :text(_("17=Countries"))  -- analogue TA 311Box
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-16), 545-135*4, 10+20*17)

LocsCheck417Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs417Box, 2, 4, 105, 5)
	
LocsCheck417Box.Customdraw =
    function(this)
           if CheckResetPressed == true then
                LocsCheck417Box.Text = ""
           end
	end

LocsCheck417Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.terra then
                    LocsCheck417Box.Text = ""
                    tableflag.terra = false
                else
                    LocsCheck417Box.Text = "v"
					tableflag.terra = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()			
----------------------------------  
Locs418Box = CXBox:new()  -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor)
    :textpos("left")    
    :movetext(12, 4)
    :text(_("Observatory"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-17), 545-135*4, 10+20*18)

LocsCheck418Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :active(true)
    :attach(Locs418Box, 2, 4, 105, 5)

LocsCheck418Box.Customdraw =
    function(this)
           local obj2 = celestia:getselection()
           local name2 = obj2:name()
           
		   if tableflag.observatory then
                    LocsCheck418Box.Text = "v"
                else
                    LocsCheck418Box.Text = ""
           end    
           if CheckResetPressed == true then
                LocsCheck418Box.Text = ""
                tableflag.observatory = false
                obs:setlocationflags(tableflag)
           end
    end
	
LocsCheck418Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.observatory then
                    LocsCheck418Box.Text = ""
                    tableflag.observatory = false
                else
               LocsCheck418Box.Text = "v"					
               tableflag.observatory = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
----------------------------
Locs419Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("Cosmodromes"))  -- analogue LF 205Box
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-18), 545-135*4, 10+20*19)

LocsCheck419Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs419Box, 2, 4, 105, 5)	
	
LocsCheck419Box.Customdraw =
    function(this)
            if CheckResetPressed == true then
                LocsCheck419Box.Text = ""
            end
    end
	
LocsCheck419Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.landingsite then
                    LocsCheck419Box.Text = ""
                    tableflag.landingsite = false
                else
                    LocsCheck419Box.Text = "v"
					tableflag.landingsite = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
-------------------------------
Locs420Box = CXBox:new() -- type managed by celestia
    :init(0, 0, 0, 0)
    :textfont(normalfont) 
    :textcolor(Namecolor) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("XX=Other"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 28+120*3, -10+20*(nlines-19), 545-135*4, 10+20*20)

LocsCheck420Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(true)
    :attach(Locs420Box, 2, 4, 105, 5)

LocsCheck420Box.Customdraw =
    function(this)

                if CheckResetPressed == true then
                    LocsCheck420Box.Text = ""
                    tableflag.other = false
                    obs:setlocationflags(tableflag)
                end
    end

LocsCheck420Box.Action = (function()
        return
            function()
                CheckResetPressed = false
                if tableflag.other then
                    LocsCheck420Box.Text = ""
                    tableflag.other = false
                else
                    LocsCheck420Box.Text = "v"
                    tableflag.other = true
                end
                obs:setlocationflags(tableflag)
            end
        end) ()	
--======================================
-- featureSizebox : container adds frame
-- Author - Vincent Giangiulio a.k.a Vincent
-- Edit by JoÑ‘l a.k.a Jogad 
-- Integration by Lygin Gennady a.k.a Croc 21.12.2013 Ð¸  28.08.2016
--======================================

-- There is no method to retrieve or change the cursor position in Celestia feature window
-- Only the number size

-----------------------------------------------
-- Set initial values
-----------------------------------------------
local columnwidth = 170 -- for adapt code of Gironde
local diffcolumnwidth = 0 --40 -- for adapt code of Gironde
local column = 4-1 -- -- for adapt code of Gironde

local featureSizeBoxWidth, featureSizeBoxHeight = 4*(columnwidth-diffcolumnwidth), 100 -- 4 = number of col umn  170= width of each column, 130=170-40
--local minFeatureSize = celestia:getminfeaturesize() -- recuperation Celestia flag for size-mini of features 
local featureSizeTrackFrameW = 154  	-- 170 width of Track of feature (frame) edit Jogad
local featureSizeCursorFrameW = 12  	-- 10 width of cursor of feature
local featureSizeCursorMargin = 3  	-- margin of cursor
local featureSizePosMax = featureSizeTrackFrameW - featureSizeCursorFrameW - (2 * featureSizeCursorMargin) 	-- position max of cursor
local featureSizePos = math.ceil(celestia:getminfeaturesize() / 100 * featureSizePosMax) 								-- fixe the actual position of cursor edit Jogad

local locLabelFrameWidth, locLabelFrameHeight = 300, 20

-----------------------------------------------
-- set up and draw the box
-----------------------------------------------

featureSizeBox = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont)
    :textcolor(ctext)
    :movetext(350, 4)
    :text(_(""))
    :movable(false) 
    :attach(renderLocsFrame, 0, 20*(nlines-22)+5, 0, 20+20*21-5)
	
featureSizeBox.Customdraw =
    function(this)
        local minFeatureSize = celestia:getminfeaturesize()
        minFeatureSize_str = string.format("%1.0f", math.floor(minFeatureSize))
        featureSizeBox.Text = (_("Minimum Feature Size: ")..' '..minFeatureSize_str)
    end
------------------------------- feature Track of adjusting tool --------------------------------
featureSizeTrackFrame = CXBox:new()
    :visible(true)    
      :attach(featureSizeBox, 8+170, 6+18, 348-((columnwidth+diffcolumnwidth)*3-columnwidth*column)-170, 24-18)

featureSizeTrackFrame.Customdraw =
    function(this)
        featureSize_lb = featureSizeTrackFrame.lb
        featureSize_lb2 = featureSizeCursorFrame.lb
        featureSizeValue = 100 * math.ceil(featureSize_lb2 - featureSize_lb - featureSizeCursorMargin) / featureSizePosMax
        if featureSizeValue < 1 then
            featureSizeValue = 1
        end
        if lastFeatureSizeValue ~= featureSizeValue and not(featureSize_FirstTickDone) then
            -- The cursor has been moved set the new Minimum Feature Size value.
            lastFeatureSizeValue = featureSizeValue
            celestia:setminfeaturesize(featureSizeValue)
        end
        featureSize_FirstTickDone = false
    end
---------------------------------- feature cursor of adjusting tool -------------------------------------

featureSizeCursorBox = CXBox:new() --- cursor of scrollbar feature
    :bordercolor(cslidefrbord)
    :visible(true)    
    :attach(featureSizeTrackFrame, 2, 4, 2, 4)

featureSizeCursorFrame = CXBox:new() -- cursor of scrollbar feature
    :bordercolor(color4)
    :fillcolor(cslidebofill)
    :visible(true)
    :movable(true)
    :attach(featureSizeTrackFrame 
            , featureSizeCursorMargin+featureSizePos
            , 0
            , featureSizeTrackFrameW-featureSizeCursorMargin-featureSizePos-featureSizeCursorFrameW
            , 0)

featureSizeCursorBox.Masked = featureSizeCursorFrame

featureSizeCursorFrame.Customdraw =
    function(this)
        local minFeatureSizebefore = celestia:getminfeaturesize()
        if lastMinFeatureSize ~= minFeatureSizebefore then
            -- Minimum Feature Size has been changed
            -- set the new position of the cursor.
            lastMinFeatureSize = minFeatureSizebefore
            featureSizePos = math.ceil(minFeatureSizebefore / 100 * featureSizePosMax)
            featureSizeCursorFrame:attach(featureSizeTrackFrame
                                                        , featureSizeCursorMargin+featureSizePos
                                                        , 0
                                                        , featureSizeTrackFrameW-featureSizeCursorMargin-featureSizePos-featureSizeCursorFrameW
                                                        , 0)
            a1 = 0
        end
    end

------------------------------ locLabel frame and his check box-----------------------------------------
	
locLabelFrame = CXBox:new()
    :init(0, 0, 0, 0)
    :textfont(normalfont)
    :textcolor(color4)
    :movetext(20, 8)  
    :text(_("Label Features:"))
    :movable(false)
    :attach(featureSizeBox, 200-190, 2, 170-((columnwidth+diffcolumnwidth)*3-columnwidth*column) + 190, 4)  

	locLabelCheckFrame = CXBox:new()
        :init(0, 0, 0, 0)
	    :bordercolor(color4)
        :textfont(smallfont)
        :textcolor(cbutextoff)
        :textpos("center")
        :movetext(0, 10)
	    :text("")
        :movable(false)
        :active(true)		
     	:attach(locLabelFrame, 2+3, 3+20, 128-3, 0) 
		
locLabelFrame.Customdraw =
    function(this)
        if locLabelFlag ~= celestia:getlabelflags().locations then -- flag as changed
            locLabelFlag = celestia:getlabelflags().locations
        end
        
        if celestia:getlabelflags().locations then
            locLabelCheckFrame.Text = "v"
        else
            locLabelCheckFrame.Text = ""
        end                              
    end

locLabelCheckFrame.Action = (function()
        return
            function()
                local labelFlagTable = celestia:getlabelflags()
                labelFlagTable.locations = not(labelFlagTable.locations)
                celestia:setlabelflags(labelFlagTable)
            end
        end) ()		
-- =============================== Legende
Locs122Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.8})
    :textpos("left")    
    :movetext(12, 4)
    :text(_("Direct links")) 
    :movable(false)
    :active(false) 
    :attach(renderLocsFrame, 13, 20*(nlines-21)-15, 515-170*1+35, 20*22+15)

LocsCheck122Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor1)
    :fillcolor({1,0,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(false)
    :attach(Locs122Box, 2, 4, 140-35, 5)
--------------------------------------------	
Locs222Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(smallfont)
    :textcolor({0,1,1,0.8}) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("Indirect links")) 
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 138, 20*(nlines-21)-15, 525-135*2, 20*22+15)

LocsCheck222Box = CXBox:new()
    :init(0, 0, 0, 0)
   -- :bordercolor(Quadrocolor4) 
    :bordercolor(cbubordoff)
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(false) 
    :attach(Locs222Box, 2, 4, 105, 5)
-------------------------------------
Locs322Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(smallfont) 
    :textcolor({0,1,1,0.8}) 
    :textpos("left")    
    :movetext(12, 4)
    :text(_("Types for the Earth")) 
    :movable(false)
    :active(false) 
    :attach(renderLocsFrame, 23+120*2, 20*(nlines-21)-15, 535-135*3, 20*22+15)

LocsCheck322Box = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor(Quadrocolor2) 
    :fillcolor({1,1,0,.2})
    :textfont(smallfont)
    :textcolor(cbutextoff)
    :textpos("center")
    :movetext(0, 10)
    :text("")
    :movable(false)
    :active(false)
    :attach(Locs322Box, 2, 4, 105, 5)
----------------------------------------
Locs422Box = CXBox:new() 
    :init(0, 0, 0, 0)
    :textfont(smallfont)  
    :textcolor({0,1,1,0.8}) 
    :textpos("left")    
    :movetext(0, 4)
    :text(_("- Set for the object"))
    :movable(false)
    :active(true) 
    :attach(renderLocsFrame, 28+120*3, 20*(nlines-21)-15, 545-135*4, 20*22+15)	
--==============================================================================================
			