--------------------------------------------------------------
-- toolBox.lua
-- Edit by Lygin Gennady a.k.a Croc 21.12.2013
-- Modernization by Patrick Ziegler a.k.a. Gironde 07-04-2017
--------------------------------------------------------------

-- boxWidth = toolbox_width[lang];
-- boxWidth = math.min(200, math.max(146, boxWidth));
-- boxWidth =186;
boxWidth =20;

boxHeight = 12-1; -- standard button's box height in menu
boxheight_t = -- specific command's buttons height in menu -- for all others button boxHeight = 12-1
    {  
        menuLine1BoxH = 0,   -- menuLine1 -- TimeStopBoxH = 0

        menuLine2BoxH = 14,   -- menuLine2
        renderBoxH = 0,           -- attach at menuLine2Box
		addsBoxH = 0,            -- attach at menuLine2Box

        menuLine3BoxH = 11,       -- menuLine3
        solarSystemBoxH = 0,     -- attach at menuLine3Box
		ViDiBaBoxH = 0,            -- attach at menuLine3Box
		legendBoxH = 0,            -- attach at menuLine3Box
		renderLocsBoxH = 0,       -- attach at menuLine3Box

        menuLine4BoxH = 11,     -- menuLine4
        guidesOnOffBoxH = 0,   -- attach at menuLine4Box
		guidesBoxH = 0,           -- attach at menuLine4Box
        helpBoxH = 0,              -- attach at menuLine4Box
        liftBoxH = 0,                -- attach at menuLine4Box

        menuLine5BoxH = 0,      -- menuLine5
        KeplerParamBoxH = 0,   -- attach at menuLine5Box
        LagrangeBoxH = 0,        -- attach at menuLine5Box
        
        menuLine6BoxH = 11,     -- menuLine6  -- **
        HRBoxH = 0,                -- attach at menuLine6Box
        sepAnglesBoxH = 0,      -- attach at menuLine6Box

        menuLine7BoxH = 11,      -- menuLine7
        --panelAll2BoxH = 0,        -- attach at menuLine5Box (PULT and others panels, 1 to 7)
        panel1BoxH = 0,             -- add by Gironde 10-04-2017
        panel2BoxH = 0,             -- add by Gironde 10-04-2017
        panel3BoxH = 0,             -- add by Gironde 10-04-2017
        compassBoxH = 0,           -- add by Gironde 10-04-2017
        panel7BoxH = 11,             -- add by Gironde 10-04-2017 -- set the eight of the first guide's button !
        
        -- lines of spacing
        gap1BoxH = 3,
        gap2BoxH = 2,
        gap3BoxH = 18,
        gap4BoxH = 10,
        gap5BoxH = 14,
    }

timeBoxTop = 35;

toolBoxH = 0;
--toolBoxHeight = toolBoxH + timeBoxTop-15;
toolBoxHeight = toolBoxH + timeBoxTop-10

boxtop = {}

tools_t = {};

local kk = 1;
loadToolbox = function(k)
    if pcall( function() require (toolset[k]) end ) then
        tools_t[kk] = toolset[k];
        kk = kk + 1;
        celestia:log(" - Loading... "..toolset[k]);
     else
        celestia:log(" - Failed loading "..toolset[k]);
    end
end

setToolBoxHeight = function() -- calculates the height of total menu by addition of all boxheight and boxHeight
    if tools_t[1] == "timeBox" then
        timeBoxTop = 0;
    end
    for k, v in ipairs(tools_t) do
        local boxH = boxheight_t[v.."H"] or boxHeight;
        boxtop[v] = toolBoxH + timeBoxTop;
        toolBoxH = toolBoxH + boxH;
    end
    toolBoxHeight = toolBoxH + timeBoxTop;
end

setToolBoxVisibility = function(b)
    selname = nil;
    for k, v in ipairs(tools_t) do
        _G[v].Visible = b;
    end
end

enableCheckBox = function(checkBox)
    checkBox.Bordercolor = cbubordoff;
    checkBox.Active = true;
    checkBox.Textcolor = {1,0,0,0.8} -- cbutextoff;
end

disableCheckBox = function(checkBox)    
    checkBox.Bordercolor = nil;  
    checkBox.Active = false;    
    checkBox.Textcolor = {0,0,0,0};
end

-- =======================================================================
toolButton = CXBox:new()
        :init(0, 0, 0, 0)
        :movable(false)
        :active(true)
        :attach(screenBox, width, height, 0, 0);

toolButton.Customdraw =                                     -- сенсорная зона
    function(this)
        toolButton:attach(screenBox, width-5, height-toolBoxHeight, 0, 0)      
    end;

toolButton.Action = (function()
       return
          function()
            overlay.toggle();
         end
      end) ();
