---------------------------------------------------
-- sepAnglesBox.lua
-- Author - Joёl a.k.a Jogad 
-- Integration by Lygin Gennady a.k.a Croc 01.09.2016
-- Modernization  by  Lygin Gennady a.k.a Croc 20.01.2017
-- Edit by Patrick Ziegler a.k.a. Gironde 07-04-2017
---------------------------------------------------
require "locale";
require "closeButton";
require "sepAngles_config"
----------------------------------------------
-- Set initial values
----------------------------------------------

local obs = celestia:getobserver();
local newwidth, newheight;
local gn=2
local gg=gn-1
local sepAnglesFrameWidth, sepAnglesFrameHeight = 186, 17*gn+3;

local sel1, sel2 = nil, nil -- no object selected

local renderflags = celestia:getrenderflags()
renderflags["markers"] = true
celestia:setrenderflags(renderflags)

---------------------------------------------
-- personalization
---------------------------------------------
display_angle = sepAngles_visible or false
local textcolor = sepAngles_color or {0.7, 0.7, 1, 0.9}
local shortcut = sepAngles_shortcut or "A"

----------------------------------------------
-- local functions
----------------------------------------------
	local obj = celestia:getselection()

local getnewselection = function()
	local obj = celestia:getselection()
        ---------------------------------------------
	-- test if there is a new selection
        ---------------------------------------------
	local sel = true  
	if obj:type() == "null" then
		sel = false
	elseif sel2 and sel2:name() == obj:name() then
		sel = false
	elseif sel1 and sel1:name() == obj:name() then 
		sel = false
	end
	--------------------------------------------
	-- record and mark selection
        --------------------------------------------
	if sel then
		if sel2 then 
			sel1:unmark(); sel2:unmark()
			sel1=obj; sel2 = nil
			sel1:mark()
		elseif sel1 then
			sel2=obj; sel2:mark()
		else
			sel1=obj; sel1:mark()
		end
	end
end

local angle = function()
	if sel1 and sel2 then
		local obs = celestia:getobserver()
		local a= sel1:getposition() - obs:getposition()
		local b= sel2:getposition() - obs:getposition()
		local sepangle = math.acos(a:normalize() * b:normalize())*180/math.pi
		return string.format(" %0.2f°",sepangle)
	else
              --"For measuring select 2nd object"
              --  return "Для замера укажите 2-й объект"
              return "Entrez le deuxième objet."
	end
end


----------------------------------------------
-- Set up and Draw the boxes
----------------------------------------------

--[[
-- command's button -----------------------------------
sepAnglesBox = CXBox:new()    
    :init(0, 0, 0, 0)
    :movable(false)
    :attach(screenBox, width, height, 0, 0);

sepAnglesButton = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0.2,0.8,1,.6})
    :fillcolor(cFrameFill)
    :textfont(smallfont)
    :textcolor({1,1,0,0.8})
    :textpos("center")
    :movetext(-3, 9)
    :text(_("Separation angles"))  -- 
    :movable(false)
    :active(true) 
    :attach(menuLine6Box, -93, 0, 0, -11) -- :attach(HRBox, -93, 0, 0, -11) 

sepAnglesCheck = CXBox:new()
        :init(0, 0, 0, 0)
        --:bordercolor(cbubordoff)
        --:fillcolor({1,1,0,.2})
        :textfont(smallfont)
        :textcolor({1,0,0,1})
        :textpos("left")
        :movetext(5, 9)
        :text("")
        :movable(false)
        :active(true)  
        :attach(sepAnglesBox, 20, 0, 0, 0)

sepAnglesButton.Action = (function()
        return
            function()
              display_sepAngles = not display_sepAngles;
                if display_sepAngles then               
                    sepAnglesFrame.Visible = true;                    
                    sepAnglesCheck.Text = "o";
                else                   
                    sepAnglesFrame.Visible = false;                   
                    sepAnglesCheck.Text = "";
                end
            end
        end) ();
]]

-- frame -----------------------------------------------------------

sepAnglesFrame = CXBox:new()
    :init(0, 0, 0, 0)
    :bordercolor({0,1,0,.8}) 
    :fillcolor(csetbofill) 
    :movable(true)
    :clickable(false)    
    :visible(false)
    :attach(screenBox, (width-sepAnglesFrameWidth)/2, height-sepAnglesFrameHeight-2, (width-sepAnglesFrameWidth)/2, 2)

 sepAnglesFrame.Customdraw = function(this)  
            getnewselection()

            if sepAngles_firstTickDone then
                    if not(sepAnglesCloseButtonDone) then
                        sepAnglesCloseButtonDone = true
                        makeCloseButton(sepAnglesCloseButton, sepAnglesFrame, sepAnglesButton)
                    end
            else
                    sepAngles_firstTickDone = true
            end
            
            if newwidth ~= width or newheight ~= height then
               newwidth, newheight = width, height
               sepAnglesFrame:attach(screenBox, width-sepAnglesFrameWidth-35, height-sepAnglesFrameHeight-610, 35, 610)
            end
	   
            textlayout:setfont(normalfont)
            textlayout:setfontcolor({0.2,0.8,1,1})
	        textlayout:setpos(this.lb+5, this.tb - 14)   
            textlayout:println(_("Space separation angles:"))

            textlayout:setfontcolor({1,0,0,1})
	        textlayout:setpos(this.lb+5, this.tb - 14-18)

            textlayout:println(angle())
end


toggleAnglesDisplay = function()
    display_angle = not display_angle
	sepAnglesFrame.Visible = display_angle
	celestia:unmarkall()
	sel1=nil
	sel2=nil

end;

